; Listing 10.4
; Calculate the square root of each element of an array of
; single precision floating point numbers
;
; This code is 16-bit for ease of testing. Chapter 18 contains
; a template for testing 32-bit code.
;
; Listings 10.4 and 10.5 demonstrate the use of the timer library
;
; to build:
;
;   masm lst10-4;
;   link lst10-4,,,stimer;
;
; or
;
;   ml lst10-4.asm stimer.lib

.model small
.386
.387
.stack
.data

fp_src dd 10 dup (0.0, 1.0, 2.0, 4.0, 9.0, 16.0, 25.0, 36.0, 49.0, 64.0)
fp_len equ ($ - fp_src)/4
fp_dst dd fp_len dup(0)

timed_loops equ 33

.code

extrn timer_on    : proc
extrn timer_off   : proc
extrn timer_show  : proc

main proc

        mov     ax, @data
        mov     ds, ax
        mov     es, ax

        finit

        mov     dx, timed_loops
        call    timer_on               ; start timer
        sti
main_loop:
        lea     si, fp_src
        lea     di, fp_dst
        mov     cx, fp_len

        call    lst10_4                ; call routine to be timed
        dec     dx
        jnz     main_loop

        call    timer_off              ; stop timer
        cli
        call    timer_show             ; show timed results

        mov     ah, 4ch
        int     21h

main endp

lst10_4 proc

lbl:
        fld     dword ptr [si]          ; load 4-byte real
        fsqrt                           ; calculate square root
        fst     dword ptr [di]          ; store result
        add     si, 4                   ; advance source pointer
        add     di, 4                   ; advance destination pointer
        dec     cx                      ; decrement loop count
        jnz     lbl                     ; continue loop if ecx not 0
        ret

lst10_4 endp

; 32-bit version of code
;
;lbl:
;        fld     dword ptr [esi]         ; load 4-byte real
;        fsqrt                           ; calculate square root
;        fst     dword ptr [edi]         ; store result
;        add     esi, 4                  ; advance source pointer
;        add     edi, 4                  ; advance destination pointer
;        dec     ecx                     ; decrement loop count
;        jnz     lbl                     ; continue loop if ecx not 0
;        ret

end main
