; Listing 10.5
; Calculate the square root of each element of an array of
; single precision floating point numbers.
;
; Same as 10.4 except that during the long execution time of
; the FSQRT instruction integer instructions are executed.
;
; This code is 16-bit for ease of testing. Chapter 18 contains
; a template for testing 32-bit code.

.model small
.386
.387
.stack
.data

fp_src dd 10 dup (0.0, 1.0, 2.0, 4.0, 9.0, 16.0, 25.0, 36.0, 49.0, 64.0)
fp_len equ ($ - fp_src)/4
fp_dst dd fp_len dup(0)

timed_loops equ 33

.code

extrn timer_on    : proc
extrn timer_off   : proc
extrn timer_show  : proc

main proc

        mov     ax, @data
        mov     ds, ax
        mov     es, ax

        finit

        mov     dx, timed_loops
        call    timer_on               ; start timer
        sti
main_loop:
        lea     si, fp_src
        lea     di, fp_dst
        mov     cx, fp_len

        call    lst10_5                ; call routine to be timed
        dec     dx
        jnz     main_loop

        call    timer_off              ; stop timer
        cli
        call    timer_show             ; show timed results

        mov     ah, 4ch
        int     21h

main endp

lst10_5 proc

lbl:
        fld     dword ptr [si]          ; load 4-byte real
        fsqrt                           ; calculate square root
        add     si, 4                   ;;  advance pointers while
        add     di, 4                   ;;  the square root is executing
        dec     cx                      ;;  decrement loop count
        fwait                           ; wait for square root to finish
        fst     dword ptr [di-4]        ; store result
        jnz     lbl                     ; continue loop if cx not 0
        ret

lst10_5 endp

; 32-bit version of code
;
;lbl:
;        fld     dword ptr [esi]         ; load 4-byte real
;        fsqrt                           ; calculate square root
;        add     esi, 4                  ;;  advance pointers while
;        add     edi, 4                  ;;  the square root is executing
;        dec     ecx                     ;;  decrement loop count
;        fwait                           ; wait for square root to finish
;        fst     dword ptr [edi-4]       ; store result
;        jnz     lbl                     ; continue loop if ecx not 0

end main
