; Listing 13.12
; string copy, 32-bits (extra bytes may be copied)
; This is intended for 32-bit protected mode code, but is shown
; here with a real-mode driver. See Chapter 18 for true 32-bit code.
;
; requires MASM 6.0 or above or TASM 3.0 or above

.model small
.486
.stack
.data
str1 db 100 dup('a'), 0
str2 db 101 dup(0)

.code

main proc
        mov     ax, @data
        mov     ds, ax
        lea     esi, str1
        lea     edi, str2

        call    lst13_12

        mov     ah, 4ch
        int     21h

main endp

lst13_12 proc

                                ;  32-bit        real-mode or
lbl:                            ; PM cycles    16-bit PM cycles
        mov     eax, [esi]      ;  1                  2
        add     esi, 4          ;  0                  2
        mov     [edi], eax      ;  1                  2
        add     edi, 4          ;  0                  2
        cmp     al, 0           ;  1                  1
        jz      exit            ;  0                  0
        cmp     ah, 0           ;  1                  1
        jz      exit            ;  0                  0
        bswap   eax             ;  1                  1
        cmp     al, 0           ;  1                  1
        jz      exit            ;  0                  0
        cmp     ah, 0           ;  1                  1
        jne     lbl             ;  0                  0
exit:                           ; ---                ---
                                ;  7 cycles          13 cycles (3.25 per byte)
                                ;  1.75 cycles per byte
        ret

lst13_12 endp
end main
