; Listing 14.17
; case independent string search
; initial code

.model small
.stack
.data

buffer  db 127 dup('AaAaAaAa'), 'AaAaAaXx'
max_buf_len equ ($ - buffer)
        db 0
pattern db 'xx',0

; this table converts from UPPER to lower

tbl db  0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15
    db 16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31
    db 32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47
    db 48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63
    db 64,'abcdefghijklmnopqrstuvwxyz',91,92,93,94,95
    db 96,'abcdefghijklmnopqrstuvwxyz',123,124,125,126,127
    db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
    db 144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159
    db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
    db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
    db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
    db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
    db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
    db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

.code

main proc

        mov     ax, @data
        mov     ds, ax
        mov     es, ax

        lea     si, pattern     ; load ptr pattern to match
        lea     di, buffer      ; load ptr to buffer to search
        mov     cx, max_buf_len ; get maximum length of buffer

        call    lst14_17

        mov     ah, 4ch
        int     21h

main endp

lst14_17 proc near

                                ; inputs: DI ptr to text string
                                ;         CX length of string
                                ;         SI ptr to pattern to find
                                ;            (in lowercase)
        xor     bx, bx
        mov     dl, [si]        ;       load char to scan for
        inc     si              ;       advance ptr for compare

lbl:                            ; cycles
        mov     bl, [di]        ;  1    read a char
        inc     di              ;  0    advance mem ptr
        mov     al, tbl[bx]     ;  2    translate to lowercase  (AGI)
        cmp     al, dl          ;  1    compare with scan char
        je      compare         ;  0
lbl2:
        dec     cx              ;  1
        jnz     lbl             ;  0
        jmp     no_match        ; ---
                                ;  5 cycles per byte


compare:
        push    si
        push    di
m1:
        mov     al, [si]        ;  1    read next char in pattern
        inc     si              ;  0    advance ptr
        test    al, al          ;  1    check for null
        jz      exit            ;  0    done if end of string
        mov     bl, [di]        ;  1    read string char to convert
        inc     di              ;  0    advance ptr
        mov     ah, tbl[bx]     ;  2    read lowercase conversion (AGI)
        cmp     al, ah          ;  1    check for match
        je      m1              ;  0    continue while matching
exit:                           ; ---
        pop     di              ;  6 cycles per pattern char
        pop     si
        jne     lbl2            ;       return to scan if not a match
match:
        clc
        ret

no_match:
        stc
        ret

lst14_17  endp
end main
