; Listing 14.4
; scan for byte, four bytes per loop
; eliminate data-cache memory bank conflict

.model small
.stack
.data
str1 db 999 dup(1), 'x'
str1_len equ ($ - str1)

.code

main proc

        mov     ax, @data
        mov     ds, ax
        mov     es, ax

        lea     di, str1                ; ptr to string to scan
        mov     cx, str1_len            ; length of string
        mov     dl, 'x'                 ; byte to match

        call    lst14_4

        mov     ah, 4ch
        int     21h

main endp

lst14_4 proc near



lbl:                            ; cycles
        mov     ax, [di]        ;  1    read two char's
        add     di, 4           ;  0    advance ptr
        cmp     al, dl          ;  1    compare 1st with scan char
        je      exit1           ;  0    exit if a match
        mov     bx, [di-2]      ;  1    read two more char's
        cmp     ah, dl          ;  0    compare 2nd with scan char
        je      exit2           ;  1    exit if a match
        cmp     bl, dl          ;  1    compare 3rd with scan char
        je      exit3           ;  0    exit if a match
        cmp     bh, dl          ;  1    compare 4th with scan char
        je      exit4           ;  0    exit if a match
        dec     cx              ;  1
        jnz     lbl             ;  0
                                ;  7 cycles, 1.75 cycles per byte

exit1:
exit2:
exit3:
exit4:
        ret

lst14_4 endp
end main
