; Listing 15.10
; 16-bit checksum of 8-bit values, 4 bytes per loop
; Step 5, second method unroll the loop
;
; Note: The definition of "disp" is different in this listing
;       than the general concept shown in the book. The effect is
;       the same but this code will actually assemble correctly
;       with all assemblers. This code can be considered a stepping
;       stone to Listing 15.13 where disp is calculated in BX.

.model small
.stack
.data

buffer db 100 dup(1), 100 dup(3), 100 dup(5)
       db 100 dup(7), 100 dup(8), 100 dup(9)
buffer_len equ ($ - buffer)
disp label byte

.code
main proc

        mov     ax, @data
        mov     ds, ax

        mov     si, - buffer_len
        call    lst15_10

        mov     ah, 4ch
        int     21h

main endp

lst15_10 proc near

        xor     cx, cx
        xor     di, di

        mov     al, disp[si]
        mov     dl, disp[si+1]
lbl:                                ; cycles
        add     cx, ax              ;  1
        add     di, dx              ;  0
        mov     al, disp[si+2]      ;  1
        mov     dl, disp[si+3]      ;  0+1 <-- bank conflict
        add     cx, ax              ;  1
        add     di, dx              ;  0
        mov     al, disp[si+4]      ;  1
        mov     dl, disp[si+5]      ;  0+1 <-- bank conflict
        add     si, 4               ;  1
        jnc     lbl                 ;  0
                                    ; ---
                                    ;  7 cycles, 1.75 cycles per byte
        add     cx, di

        ret

lst15_10 endp
end main
