; Listing 15.11
; 16-bit checksum of 8-bit values, 4 bytes per loop
; Step 6, re-order to eliminate conflicts
;
; Note: The definition of "disp" is different in this listing
;       than the general concept shown in the book. The effect is
;       the same but this code will actually assemble correctly
;       with all assemblers. This code can be considered a stepping
;       stone to Listing 15.13 where disp is calculated in BX.

.model small
.stack
.data

buffer db 100 dup(1), 100 dup(3), 100 dup(5)
       db 100 dup(7), 100 dup(8), 100 dup(9)
buffer_len equ ($ - buffer)
disp label byte

.code
main proc

        mov     ax, @data
        mov     ds, ax

        mov     si, - buffer_len
        call    lst15_11

        mov     ah, 4ch
        int     21h

main endp

lst15_11 proc near

        xor     cx, cx
        xor     di, di

        mov     al, disp[si]
        mov     dl, disp[si+1]
lbl:                                ; cycles
        add     cx, ax              ;  1
        mov     al, disp[si+2]      ;  0
        add     di, dx              ;  1
        mov     dl, disp[si+3]      ;  0
        add     cx, ax              ;  1
        mov     al, disp[si+4]      ;  0
        add     di, dx              ;  1
        mov     dl, disp[si+5]      ;  0
        add     si, 4               ;  1
        jnc     lbl                 ;  0
                                    ; ---
                                    ;  5 cycles, 1.25 cycles per byte
        ret

lst15_11 endp
end main
