; Listing 15.14
; 16-bit checksum of 8-bit values, 1 bytes per loop
;      back to step 1, eliminating CX
;
; Note: The definition of "disp" is different in this listing
;       than the general concept shown in the book. The effect is
;       the same but this code will actually assemble correctly
;       with all assemblers. This code can be considered a stepping
;       stone to Listing 15.13 where disp is calculated in BX.

.model small
.stack
.data

buffer db 100 dup(1), 100 dup(3), 100 dup(5)
       db 100 dup(7), 100 dup(8), 100 dup(9)
buffer_len equ ($ - buffer)
disp label byte

.code
main proc

        mov     ax, @data
        mov     ds, ax

        mov     si, - buffer_len
        call    lst15_14

        mov     ah, 4ch
        int     21h

main endp

lst15_14 proc near

        xor     bx, bx
        mov     ah, 0
lbl:                            ; cycles
        mov     al, disp[si]    ;  1+1 <--- AGI
        add     bx, ax          ;  1   <--- register conflict, no pairing
        inc     si              ;  0   <--- address generation
        jnz     lbl             ;  1

        ret

lst15_14 endp
end main
