; Listing 15.4
; 16-bit checksum of 8-bit values, 2 bytes per loop
; Step 3, Eliminate redundant pointer operations

.model small
.stack
.data

buffer db 100 dup(1), 100 dup(3), 100 dup(5)
       db 100 dup(7), 100 dup(8), 100 dup(9)
buffer_len equ ($ - buffer)

.code
main proc

        mov     ax, @data
        mov     ds, ax

        lea     si, buffer
        mov     cx, buffer_len
        call    lst15_4

        mov     ah, 4ch
        int     21h

main endp

lst15_4 proc near

        xor     bx, bx
        mov     ah, 0
        mov     dh, 0
        shr     cx, 1           ; (divide count by 2)
        jc      lbl_2           ; (skip down if odd count)

lbl:                            ; cycles
        mov     al, [si]        ;  1
        add     bx, ax          ;  1  <-- register conflict, no pairing
lbl_2:
        mov     dl, [si+1]      ;  0  <-- bug (SI needs to be decremented
        add     si, 2           ;  1           for odd count entry point)
        add     bx, dx          ;  0
        dec     cx              ;  1
        jnz     lbl             ;  0
                                ; ---
                                ;  4 cycles, 2 per byte
        ret

lst15_4 endp
end main
