; Listing 15.7
; 16-bit checksum of 8-bit values, 2 bytes per loop
; Step 4, remove CX (use pointer as counter)
; (causes AGI, bank conflict, register conflict)
;
; Note: The definition of "disp" is different in this listing
;       than the general concept shown in the book. The effect is
;       the same but this code will actually assemble correctly
;       with all assemblers. This code can be considered a stepping
;       stone to Listing 15.13 where disp is calculated in BX.

.model small
.stack
.data

buffer db 100 dup(1), 100 dup(3), 100 dup(5)
       db 100 dup(7), 100 dup(8), 100 dup(9)
buffer_len equ ($ - buffer)
disp label byte

.code
main proc

        mov     ax, @data
        mov     ds, ax

        mov     si, - buffer_len
        call    lst15_7

        mov     ah, 4ch
        int     21h

main endp

lst15_7 proc near

        xor     bx, bx
        mov     ah, 0
        mov     dh, 0
        shr     cx, 1           ; divide count by 2
        jnc     lbl             ; skip down if even count
        lodsb
        add     bx, ax

lbl:                            ; cycles
        mov     al, disp[si]    ;  1+1  <--- AGI delay
        mov     dl, disp[si+1]  ;  0+1  <--- bank conflict delay
        add     bx, ax          ;  1
        add     bx, dx          ;  1    <--- no pairing, register conflict
        add     si, 2           ;  0    <--- address generation
        jnc     lbl             ;  1
                                ; ---
                                ;  6
        ret

lst15_7 endp
end main
