; Listing 15.8
; 16-bit checksum of 8-bit values, 2 bytes per loop
; Step 4, second method, remove CX (use pointer as counter)
;       add two sums after loop ends
;
; Note: The definition of "disp" is different in this listing
;       than the general concept shown in the book. The effect is
;       the same but this code will actually assemble correctly
;       with all assemblers. This code can be considered a stepping
;       stone to Listing 15.13 where disp is calculated in BX.

.model small
.stack
.data

buffer db 100 dup(1), 100 dup(3), 100 dup(5)
       db 100 dup(7), 100 dup(8), 100 dup(9)
buffer_len equ ($ - buffer)
disp label byte

.code
main proc

        mov     ax, @data
        mov     ds, ax

        mov     si, - buffer_len
        call    lst15_8

        mov     ah, 4ch
        int     21h

main endp

lst15_8 proc near

        xor     bx, bx
        xor     cx, cx
        mov     ah, 0
        mov     dh, 0
        shr     cx, 1           ; divide count by 2
        jnc     lbl             ; skip down if even count
        lodsb
        add     bx, ax

        mov     al, disp[si]
        mov     dl, disp[si+1]      ;
lbl:                                ; cycles
        add     bx, ax              ;  1
        add     cx, dx              ;  0
        mov     al, disp[si+2]      ;  1
        mov     dl, disp[si+3]      ;  0+1 <--- bank conflict
        add     si, 2               ;  1
        jnc     lbl                 ;  0
                                    ; ---
                                    ;  4 cycles, 2 cycles per byte
        add     bx, cx              ;  add two sums

        ret

lst15_8 endp
end main
