; Listing 15.9
; 16-bit checksum of 8-bit values, 3 bytes per loop
; Step 5, unroll the loop
;
; Note: The definition of "disp" is different in this listing
;       than the general concept shown in the book. The effect is
;       the same but this code will actually assemble correctly
;       with all assemblers. This code can be considered a stepping
;       stone to Listing 15.13 where disp is calculated in BX.

.model small
.stack
.data

buffer db 100 dup(1), 100 dup(3), 100 dup(5)
       db 100 dup(7), 100 dup(8), 100 dup(9)
buffer_len equ ($ - buffer)
disp label byte

.code
main proc

        mov     ax, @data
        mov     ds, ax

        mov     si, - buffer_len
        call    lst15_9

        mov     ah, 4ch
        int     21h

main endp

lst15_9 proc near

        xor     di, di
        xor     bp, bp

        mov     al, disp[si]
        mov     bl, disp[si+1]
        mov     cl, disp[si+2]
lbl:                                ;  cycles
        add     di, ax              ;  1
        add     bp, bx              ;  0
        mov     al, disp[si+3]      ;  1
        mov     bl, disp[si+4]      ;  0+1 <-- bank conflict
        add     di, cx              ;  1
        mov     cl, disp[si+5]      ;  0
        add     si, 3               ;  1
        jnc     lbl                 ;  0
                                    ; ---
                                    ;  5 cycles, 1.67 cycles per byte
        add     di, bp              ;  add two sums

        ret

lst15_9 endp
end main
