; Listing 16.1
;
; This example demonstrates the following FPU operations:
;
;  basic calculations (area of circle and square)
;  compare two FP numbers
;  branching based on FP compares
;  store FP results

.model small
.286
.287
.stack
.data

radius dd 1.2   ; radius of a circle
side   dd 2.1   ; side of a square
circle dd 0     ; result area of circle
square dd 0     ; result area of square

.code

main proc

        mov     ax, @data
        mov     ds, ax

        call    lst16_1

        mov     ah, 4ch
        int     21h

main endp

lst16_1 proc near

; calculate area of circle (pi * r * r)

        fld     radius          ; load the radius
        fmul    st, st          ; square the radius
        fldpi                   ; load pi
        fmul                    ; multiply to get area

; calculate area of square

        fld     side            ; load side of a square
        fmul    st, st          ; square the side

; compare the areas

        fcom                    ; compare
        fstsw   ax              ; load FPU status into AX

; store the results

        fstp    square          ; store area of square and pop from stack
        fstp    circle          ; store area of circle and pop from stack

; branch based on previously obtained compare status

        sahf                    ; put FPU flags into main CPU flags
        jp      fperr           ; parity flag is C2 FPU flag
                                ;  (when this is set an error occurred)
        je      comp_equal
        jc      circle_larger
        jmp     square_larger

fperr:


comp_equal:


circle_larger:


square_larger:

        ret


lst16_1 endp
end main
