; Listing 16.10
; daxpy() function
; 4 operations per loop

; for ease of demonstartion, this example is shown as 16-bit code
; (32-bit code at bottom of file)

.model small
.stack
.286
.287

.data

; small demonstration data arrays
aptr dq 1.0
xptr dq 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0
yptr dq 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0
n equ ($-yptr)/8

.code

main proc

        mov     ax, @data
        mov     ds, ax
        mov     es, ax

        finit

; simulate C language call

        push    offset yptr
        push    offset xptr
        push    offset aptr
        push    n
        call    _lst16_10

        add     sp, 8

        mov     ah, 4ch
        int     21h

main endp

_lst16_10 proc

; void daxpy(int n, double *aptr, double *xptr, double *yptr)
;      forms the sum of a*x[i] + y[i], and stores in y[]

        push    bp
        mov     bp, sp
        push    di
        push    si

        mov     cx, word ptr [bp+4]     ;       count
        mov     bx, word ptr [bp+6]     ;       aptr
        fld     qword ptr [bx]          ;
        mov     si, word ptr [bp+8]     ;       xptr
        mov     di, word ptr [bp+10]    ;       yptr
        mov     dx, cx
        shr     cx, 2
        jz      lbl2

lbl:                                    ; cycles
        fld     qword ptr [si]          ;  1
        fmul    st, st(1)               ;  1
        fld     qword ptr [si+8]        ;  1
        fmul    st, st(2)               ;  1
        fxch    st(1)                   ;  0

        fadd    qword ptr [di]          ;  1
        fxch    st(1)                   ;  0
        fadd    qword ptr [di+8]        ;  1
        fxch    st(1)                   ;  0
        fstp    qword ptr [di]          ;  2
        fstp    qword ptr [di+8]        ;  2

        fld     qword ptr [si+16]       ;  1
        fmul    st, st(1)               ;  1
        fld     qword ptr [si+24]       ;  1
        fmul    st, st(2)               ;  1
        fxch    st(1)                   ;  0

        fadd    qword ptr [di+16]       ;  1
        fxch    st(1)                   ;  0
        fadd    qword ptr [di+24]       ;  1
        fxch    st(1)                   ;  0
        fstp    qword ptr [di+16]       ;  2
        fstp    qword ptr [di+24]       ;  2

        add     si, 32                  ;  1
        add     di, 32                  ;  0
        dec     cx                      ;  1
        jnz     lbl                     ;  0
                                        ; ---
                                        ; 22 cycles, 5.5 per double
; handle remaining 0 to 3 elements
lbl2:
        and     dx, 3
        jz      fin

lbl3:
        fld     qword ptr [si]
        fmul    st, st(1)
        fadd    qword ptr [di]
        fstp    qword ptr [di]
        add     si, 8
        add     di, 8
        dec     dx
        jnz     lbl3

fin:
        fstp    st(0)

        pop     si
        pop     di
        pop     bp
        ret

_lst16_10 endp


;_lst16_10 proc
;
;; void daxpy(int n, double *aptr, double *xptr, double *yptr)
;;      forms the sum of a*x[i] + y[i], and stores in y[]
;
;        push    ebp
;        mov     ebp, esp
;
;        mov     ecx, dword ptr [ebp+8]  ;       count
;        mov     eax, dword ptr [ebp+12] ;       aptr
;        mov     edx, dword ptr [eax+4]  ;
;        fld     qword ptr [eax]         ;
;        mov     eax, dword ptr [ebp+16] ;       xptr
;        mov     ebx, dword ptr [ebp+20] ;       yptr
;
;
;      lbl:                              ; cycles
;        fld     qword ptr [eax]         ;  1
;        fmul    st, st(1)               ;  1
;        fld     qword ptr [eax+8]       ;  1
;        fmul    st, st(2)               ;  1
;        fxch    st(1)                   ;  0
;
;        fadd    qword ptr [ebx]         ;  1
;        fxch    st(1)                   ;  0
;        fadd    qword ptr [ebx+8]       ;  1
;        fxch    st(1)                   ;  0
;        fstp    qword ptr [ebx]         ;  2
;        fstp    qword ptr [ebx+8]       ;  2
;
;        fld     qword ptr [eax+16]      ;  1
;        fmul    st, st(1)               ;  1
;        fld     qword ptr [eax+24]      ;  1
;        fmul    st, st(2)               ;  1
;        fxch    st(1)                   ;  0
;
;        fadd    qword ptr [ebx+16]      ;  1
;        fxch    st(1)                   ;  0
;        fadd    qword ptr [ebx+24]      ;  1
;        fxch    st(1)                   ;  0
;        fstp    qword ptr [ebx+16]      ;  2
;        fstp    qword ptr [ebx+24]      ;  2
;
;        add     eax, 32                 ;  1
;        add     ebx, 32                 ;  0
;        dec     ecx                     ;  1
;        jnz     lbl                     ;  0
;                                        ; ---
;                                        ; 22 cycles, 5.5 per double
;        fstp    st(0)
;        pop     ebp
;        ret
;
;_lst16_10 endp



end main
