; Listing 16.12
; ddot() function
; 2 operations per loop, simple instructions
; (see lst16-15 for full code example)

.386
.model flat
.code

__fac dq 0

_lst16_12 proc

; double ddot(int n, double *xptr, double *yptr)
;      forms the dot product of two row vectors
;      returns in edx:eax and __fac

        push    ebp
        mov     ebp, esp

        mov     ecx, dword ptr [ebp+8]  ;       count
        mov     eax, dword ptr [ebp+12] ;       xptr
        mov     ebx, dword ptr [ebp+16] ;       yptr
        fldz

lbl:                                    ; cycles
        fld     qword ptr [eax]         ;  1    load A1
        fmul    qword ptr [ebx]         ;  1+2  multiply A1 * A2
        fadd                            ;  1    add sum+A1*A2
        fld     qword ptr [eax+8]       ;  1    load B1
        fmul    qword ptr [ebx+8]       ;  1+2  multiply B1 * B2
        fadd                            ;  1    add sum+B1*B2
        add     eax, 16                 ;  1
        add     ebx, 16                 ;  0
        dec     ecx                     ;  1
        jnz     lbl                     ;  0
                                        ; ---
                                        ; 12 cycles, 6 per double
        fstp    __fac
        mov     eax, dword ptr __fac
        mov     edx, dword ptr __fac+4
        pop     ebp
        ret

_lst16_12 endp
end
