; Listing 16.14
; ddot() function
; 2 operations per loop, FADD order reversed with FXCH
; (see lst16-15 for full code example)

.386
.model flat
.code

__fac dq 0

_lst16_14 proc

; double ddot(int n, double *xptr, double *yptr)
;      forms the dot product of two row vectors
;      returns in edx:eax and __fac

        push    ebp
        mov     ebp, esp

        mov     ecx, dword ptr [ebp+8]  ;       count
        mov     eax, dword ptr [ebp+12] ;       xptr
        mov     ebx, dword ptr [ebp+16] ;       yptr
        fldz


        jmp     lbl2                    ; cycles
lbl:
        fadd                            ;  1    add sum+B1*B2
lbl2:
        fld     qword ptr [eax]         ;  1    load A1
        fmul    qword ptr [ebx]         ;  1    multiply A1*A2
        fld     qword ptr [eax+8]       ;  1    load B1
        fmul    qword ptr [ebx+8]       ;  1    multiply B1*B2
        fxch                            ;  0    exchange st(0) and st(1)
        faddp   st(2), st               ;  1    add sum+A1*A2
        add     eax, 16                 ;  1
        add     ebx, 16                 ;  0
        dec     ecx                     ;  1
        jnz     lbl                     ;  0
        fadd                            ; ---
                                        ;  8 cycles, 4 per double
        fstp    __fac
        mov     eax, dword ptr __fac
        mov     edx, dword ptr __fac+4
        pop     ebp
        ret

_lst16_14 endp
end
