; Listing 16-15
; ddot() function
; 4 operations per loop
; final listing

.model small
.stack
.286
.287

.data

__fac dq 0

xptr   dq 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0
       dq 10.0, 11.0, 12.0, 13.0, 14.0, 15.0, 16.0, 17.0, 18.0, 19.0
n equ ($ - xptr)/8

yptr   dq 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0
       dq 10.0, 11.0, 12.0, 13.0, 14.0, 15.0, 16.0, 17.0, 18.0, 19.0


.code

main proc

        mov     ax, @data
        mov     ds, ax
        mov     es, ax

        finit

; simulate C language call

        push    offset yptr
        push    offset xptr
        push    n
        call    _lst16_15
        add     sp, 6

        mov     ah, 4ch
        int     21h

main endp

_lst16_15 proc

; double ddot(int n, double *xptr, double *yptr)
;      forms the dot product of two row vectors
;      returns in __fac

        push    bp
        mov     bp, sp
        push    di
        push    si

        mov     cx, word ptr [bp+4]  ;       count
        mov     si, word ptr [bp+6]  ;       xptr
        mov     di, word ptr [bp+8]  ;       yptr
        fldz

        mov     dx, cx
        shr     cx, 2
        jz      lbl3
        jmp     lbl2                    ; cycles
lbl:
        fadd                            ;  1    add sum+D1*D2
lbl2:
        fld     qword ptr [si]          ;  1    load A1
        fmul    qword ptr [di]          ;  1    multiply A1*A2
        fld     qword ptr [si+8]        ;  1    load B1
        fmul    qword ptr [si+8]        ;  1    multiply B1*B2
        fxch                            ;  0    exchange st(0) and st(1)
        faddp   st(2), st               ;  1    add sum+A1*A2

        fld     qword ptr [si+16]       ;  1    load C1
        fmul    qword ptr [di+16]       ;  1    multiply C1*C2
        fxch                            ;  0    exchange st(0) and st(1)
        faddp   st(2), st               ;  1    add sum+B1*B2

        fld     qword ptr [si+24]       ;  1    load D1
        fmul    qword ptr [di+24]       ;  1    multiply D1*D2
        fxch                            ;  0    exchange st(0) and st(1)
        faddp   st(2), st               ;  1    add sum+C1*C2

        add     si, 32                  ;  1
        add     di, 32                  ;  0
        dec     cx                      ;  1
        jnz     lbl                     ;  0
        fadd                            ; ---
lbl3:                                   ; 14 cycles, 3.5 per double
        and     dx, 3
        jz      lbl6
        jmp     lbl5

lbl4:
        fadd
lbl5:
        fld     qword ptr [si]
        fmul    qword ptr [di]
        add     si, 8
        add     di, 8
        dec     dx
        jnz     lbl4
        fadd
lbl6:
        fstp    __fac

        pop     si
        pop     di
        pop     bp
        ret

_lst16_15 endp


; 32-bit code version

;_lst16_15 proc
;
;; double ddot(int n, double *xptr, double *yptr)
;;      forms the dot product of two row vectors
;;      returns in edx:eax and __fac
;
;        push    ebp
;        mov     ebp, esp
;
;        mov     ecx, dword ptr [ebp+8]  ;       count
;        mov     eax, dword ptr [ebp+12] ;       xptr
;        mov     ebx, dword ptr [ebp+16] ;       yptr
;        fldz
;
;        mov     edx, ecx
;        shr     ecx, 2
;        jz      lbl3
;
;        jmp     lbl2                    ; cycles
;lbl:
;        fadd                            ;  1    add sum+D1*D2
;lbl2:
;        fld     qword ptr [eax]         ;  1    load A1
;        fmul    qword ptr [ebx]         ;  1    multiply A1*A2
;        fld     qword ptr [eax+8]       ;  1    load B1
;        fmul    qword ptr [ebx+8]       ;  1    multiply B1*B2
;        fxch                            ;  0    exchange st(0) and st(1)
;        faddp   st(2), st               ;  1    add sum+A1*A2
;
;        fld     qword ptr [eax+16]      ;  1    load C1
;        fmul    qword ptr [ebx+16]      ;  1    multiply C1*C2
;        fxch                            ;  0    exchange st(0) and st(1)
;        faddp   st(2), st               ;  1    add sum+B1*B2
;
;        fld     qword ptr [eax+24]      ;  1    load D1
;        fmul    qword ptr [ebx+24]      ;  1    multiply D1*D2
;        fxch                            ;  0    exchange st(0) and st(1)
;        faddp   st(2), st               ;  1    add sum+C1*C2
;
;        add     eax, 32                 ;  1
;        add     ebx, 32                 ;  0
;        dec     ecx                     ;  1
;        jnz     lbl                     ;  0
;        fadd                            ; ---
;lbl3:                                   ; 14 cycles, 3.5 per double
;        and     edx, 3
;        jz      lbl6
;        jmp     lbl5
;
;lbl4:
;        fadd
;lbl5:
;        fld     qword ptr [eax]
;        fmul    qword ptr [ebx]
;        add     eax, 8
;        add     ebx, 8
;        dec     edx
;        jnz     lbl4
;        fadd
;lbl6:
;        fstp    __fac
;        mov     eax, dword ptr __fac
;        mov     edx, dword ptr __fac+4
;        pop     ebp
;        ret
;
;_lst16_15 endp

end main
