; 16-bit timer library C interface

ifdef ??version         ; check for TASM
   nowarn PDC           ; disable the "Pass Dependent Construct" warning
endif

ifndef msize
   msize equ <small>    ; default to small model
endif

%  .model &msize

if @codesize
  @codename equ <timer_text>
else
  @codename equ <>
endif


ifdef ??version         ; re-enable TASM warnings
   warn
endif

% .code @codename

extrn timer_init              : proc
extrn timer_on                : proc
extrn timer_off               : proc
extrn timer_show              : proc
extrn timer_show_ticks        : proc
extrn timer_show_microseconds : proc
extrn timer_show_average      : proc
extrn timer_set_format        : proc

public _timer_init
_timer_init proc
           jmp    timer_init
_timer_init endp


public _timer_on
_timer_on proc
           jmp    timer_on
_timer_on endp

public _timer_off
_timer_off proc
           jmp    timer_off
_timer_off endp

public _timer_show
_timer_show proc
           jmp    timer_show
_timer_show endp

public _timer_show_ticks
_timer_show_ticks proc
           jmp    timer_show_ticks
_timer_show_ticks endp

public _timer_show_microseconds
_timer_show_microseconds proc
           jmp    timer_show_microseconds
_timer_show_microseconds endp


public _timer_show_average
_timer_show_average proc
           jmp    timer_show_average
_timer_show_average endp

public _timer_set_format
_timer_set_format proc
;--------------------------------------
; Set the default timer result format
;
; inputs: AL format
;            0  clock tick format
;            1  microsecond format
;--------------------------------------

           push   bp
           mov    bp, sp
ife @codesize
           mov    al, [bp+4]
else
           mov    al, [bp+6]
endif
           call   timer_set_format
           push   bp
           ret

_timer_set_format endp

end
