	title  Number conversion subroutines
.8087

data  	segment public
base	dw	10
dnum	dd	?
dpl	dw	?
negflg	db	?
decflg	db	?
one	dw	1
two	dw	2
exp	dw	?
sig	dd	?
fdbuf	dd	?
ctrl	dw	?
ten8	dd	100000000
E	dd	?
F	dt	?
negeflg	db	?
fdumpb	dq	8 dup(?)
data	ends

	public	getnum,convert,digit
	public	sharp,sharps,ddiv
	public	dnegate,number,decflg
	public	base,negflg,dnum
	public	pax,upax,pdxax,updxax
	public	dot,udot,ddot,uddot
	public	absol,dabsol,mdmul
	public 	float,pst,binflt,tenx,fdump
	extrn	query:near,kbuf:byte
	extrn	bufend:byte,span:word
	extrn	mess:near,mess2:near,crlf:near
	extrn	getkey:near,dokey:near
	extrn	beep:near,chrout1:near
	extrn	deccur:near

code	segment	public
	assume	cs:code,ds:data

	page
;	get number from keyboard
;	number can have a decimal point (dp)
;	  and can be prceded by a minus sign
;	input:	none  
;	output:	dx:ax = double number
;		cx = # to right of dp
;		carry = 1 if invalid number
getnum	proc	near
	push	si
	push	di
	call	query		;get string
	mov	si,offset kbuf	;si->string
	call	number		;conv.to.binary
	cmp	byte ptr [si],0	;if invalid
	je	gtn1		; digit not 0
	stc			; set carry
gtn1:	pop	di
	pop	si
	ret			
getnum	endp

	page
;	print signed value in ax
pax	proc	near
	push	ax
	push	si
	call	dot		;signed string
	call	mess2		;print it
	pop	si
	pop	ax
	ret
pax	endp

;	print unsigned value in ax
upax	proc	near
	push	ax
	push	si
	call	udot		;get string
	call	mess2		;print it
	pop	si
	pop	ax
	ret
upax	endp

;	print signed value in dx:ax
pdxax	proc	near
	push	ax
	push	dx
	push	si
	call	ddot		;get string
	call	mess2		;print it
	pop	si
	pop	dx
	pop	ax
	ret
pdxax	endp

;	print unsigned value in dx:ax
updxax	proc	near
	push	ax
	push	dx
	push	si
	call	uddot		;get string
	call	mess2		;print it
	pop	si
	pop	dx
	pop	ax
	ret
updxax	endp

	page
;	convert ax to unsigned number string
;	output:	si -> number asciiz string
udot	proc	near
	push	ax
	push	bx
	push	di
	mov	word ptr dnum,ax ;dnum=ax
	mov	word ptr dnum+2,0
	mov	si,offset dnum
	mov	di,offset bufend-1
	mov	byte ptr 1[di],0 ;bufend=0
	call	sharps		;conv to ascii
	inc	di
	mov	si,di		;->1st digit
	pop	di
	pop	bx
	pop	ax
	ret
udot	endp

;	convert dx:ax to unsigned number string
;	output:	si -> number asciiz string
uddot	proc	near
	push	ax
	push	bx
	push	di
	mov	word ptr dnum,ax ;dnum=dx:ax
	mov	word ptr dnum+2,dx
	mov	si,offset dnum
	mov	di,offset bufend-1
	mov	byte ptr 1[di],0 ;bufend=0
	call	sharps		;conv to ascii
	inc	di
	mov	si,di		;->1st digit
	pop	di
	pop	bx
	pop	ax
	ret
uddot	endp

	page
;	convert ax to signed number string
;	output:	si -> number asciiz string
dot	proc	near
	push	ax
	push	bx
	push	di
	mov	bx,ax		;bx has sign
	call	absol
	mov	word ptr dnum,ax ;dnum=ax
	mov	word ptr dnum+2,0
	mov	si,offset dnum
	mov	di,offset bufend-1
	mov	byte ptr 1[di],0 ;bufend=0
	call	sharps		;conv to ascii
	or	bx,bx		;if negative
	jns	dt1
	mov	byte ptr [di],'-' ;add - sign
	dec	di
dt1:	inc	di
	mov	si,di		;->1st digit
	pop	di
	pop	bx
	pop	ax
	ret
dot	endp

;	convert dx:ax to signed number string
;	output:	si -> number asciiz string
ddot	proc	near
	push	ax
	push	bx
	push	di
	mov	bx,dx		;bx has sign
	call	dabsol
	mov	word ptr dnum,ax ;dnum=dx:ax
	mov	word ptr dnum+2,dx
	mov	si,offset dnum
	mov	di,offset bufend-1
	mov	byte ptr 1[di],0 ;bufend=0
	call	sharps		;conv to ascii
	or	bx,bx		;if negative
	jns	ddt1
	mov	byte ptr [di],'-' ;add - sign
	dec	di
ddt1:	inc	di
	mov	si,di		;->1st digit
	pop	di
	pop	bx
	pop	ax
	ret
ddot	endp

	page
;	absolute value of ax
absol	proc	near
	or	ax,ax		;if ax is neg
	jns	ab1
	neg	ax		;negate it
ab1:	ret
absol	endp

;	absolute value of dx:ax
dabsol	proc	near
	or	dx,dx		;if dx:ax 
	jns	da1		; is negative
	call	dnegate		;negate it
da1:	ret
dabsol	endp

	page
;	ascii number to binary conversion
;	input:  di -> bin buf   
;		si -> number string
;	output: si -> invalid digit
convert	proc	near
	push	ax		;save regs
	push	bx
	push	cx
	push	dx
	cld
cvt1:	lodsb			;get next digit
	call	digit		;conv to value
	jc	cvt2		;if valid digit
	mov	ah,0		;ax=digit value
	push	ax		;save value
	mov	bx,base		;mult dnumH by
	mov	ax,word ptr 2[di] ; base
	mul	bx
	mov	cx,ax		;cx=lo word
	mov	ax,word ptr [di] ;mult dnumL by
	mul	bx		; base
	pop	bx		;get value
	add	ax,bx		;add to prodL
	adc	dx,cx		;+ cx to prodH
	mov	word ptr [di],ax ;store in dnum
	mov	word ptr 2[di],dx
	cmp	decflg,0	;if . occurred
	je	cvt1
	inc	dpl		; inc dpl
	jmp	cvt1		;do until 
cvt2:	dec	si		; invalid digit
	pop	dx		;restore regs
	pop	cx
	pop	bx
	pop	ax
	ret
convert	endp

	page
;	convert ascii digit to value in base
;	al=char (ascii code)
;	output: carry=0 al=valid hex value
;		carry=1 al=invalid ascii code
digit	proc	near
	push	bx		;save regs
	push	ax
	mov	bx,base		;bx=base
	sub	al,'0'		;ascii codes<30
	jb	fail		; are invalid
	cmp	al,9		;char between
	jbe	dgt1		; 9 and A
	cmp	al,17		; are invalid
	jb	fail		;fill gap
	sub	al,7		; between 9&A
dgt1:	cmp	al,bl		;digit must be
	jae	fail		; < base
	clc			;valid digit
	pop	bx		;pop old ax
	pop	bx		;restore bx
	ret
fail:	pop	ax		;invalid digit
	pop	bx
	stc
	ret
digit	endp

	page	 
;	convert 1 digit & add to ascii string
;	si->bin buf  di->ascii buf
sharp	proc near
	push	ax		;save regs
	push	bx
	push	dx
	mov	dx,2[si]
	mov	ax,[si]
	mov	bx,base
	call	ddiv		;dnum/base
	mov	[si],ax		; = dnum
	mov	2[si],dx
	cmp	bl,9		;if rem>9
	jbe	shp1
	add	bl,7		; add 7
shp1:	add	bl,'0'		;conv to ascii
	mov	[di],bl		;store digit
	dec	di		;->next digit
	pop	dx		;restore regs
	pop	bx
	pop	ax
	ret
sharp	endp

;	convert all digits to ascii
;	si->bin buf   di->ascii buf
sharps	proc near
shs1:	call	sharp		;do next digit
	cmp	word ptr [si],0	;repeat until
	jne	shs1		; quot=0
	cmp	word ptr 2[si],0
	jne	shs1
	ret
sharps	endp

	page
;	divide double word dx:ax by bx
;	quot in dx:ax   rem in bx
ddiv	proc	near
	push	cx		;save reg
	push	ax		;save numL
	mov	ax,dx		;ax=numH
	mov	dx,0
	div	bx		;0 numH / bx
	mov	cx,ax		;cx=quotH
	pop	ax		;get numL
	div	bx		;rH numL / bx
	mov	bx,dx		;bx=rem
	mov	dx,cx		;dx:ax=quot
	pop	cx		;restore reg
	ret
ddiv	endp

;	negate double word dx:ax
dnegate	proc	near
	push	bx		;save regs
	push	cx
	mov	bx,dx		;bx=hi word
	mov	cx,ax		;cx=lo word
	xor	ax,ax		;ax=0
	mov	dx,ax		;dx=0
	sub	ax,cx		;dx:ax =
	sbb	dx,bx		; 0:0 - bx:cx
	pop	cx		;restore regs
	pop	bx
	ret
dnegate	endp

;	mixed double multiply
;	dx:ax = dx:ax * bx
;	      = A B * C = PH PL
;	PL = BCL
;	PH = BCH + ACL
mdmul	proc	near
	push	cx		;save cx
	mov	cx,dx		;cx = A
	mul	bx		;dx=BCH ax=BCL
	push	ax		;save BCL
	push	dx		;save BCH
	mov	ax,cx		;ax = A
	mul	bx		;dx=ACH ax=ACL
	pop	dx		;dx=BCH
	add	dx,ax		;dx=BCH+ACL
	pop	ax		;ax=BCL
	pop	cx		;restore cx
	ret
mdmul	endp

	page
;	convert real number
;	input:	si -> number string  
;	output:	dx:ax = double number
;		cx = # to right of dp
;		si -> invalid digit
number	proc	near
	push	di
	mov	di,offset dnum
	mov	word ptr [di],0	;clr bin buf
	mov	word ptr 2[di],0
	mov	dpl,0		;clr dpl
	mov	decflg,0	;clr decflg
	mov	negflg,0	;clear negflg
	cld
	lodsb			;get 1st char
	cmp	al,'-'		;if - sign
	jne	nb1
	not	negflg		;set neg flag
	jmp	nb2
nb1:	dec	si		;->1st digit
nb2:	call	convert		;convert number
	lodsb			; get next byte
	cmp	al,'.'		; if .
	jne	nb3
	not	decflg		; set decflg
	call	convert		;conv rest
	lodsb			;dummy load
nb3:	dec	si		;si->invalid dg
	mov	ax,[di]		;dx:ax=number
	mov	dx,2[di]
	cmp	negflg,0	;if negative
	je	nb4
	call	dnegate		;negate it
nb4:	mov	cx,dpl		;cx=dpl
	pop	di
	ret
number	endp

	page
;	convert to floating point
;	si --> ascii fp number string
;	di --> floating point buffer (qword)
float	proc	near
	push	ax
	push	bx
	push	cx
	push	dx
	cld
	call	number		;get signif
	mov	word ptr sig,ax
	mov	word ptr sig+2,dx
	neg	cx		;move -dpl
	mov	exp,cx		; to exp
	lodsb			;get char
	or	al,20h		;E or e
	cmp	al,'e'		;if not e
	je	flt1		; quit
	dec	si
	jmp	short flt2
flt1:	call	number		;get exp
	add	exp,ax		; + to exp
flt2:	push	si		;save si
	mov	si,offset sig	;convert to
	mov	bx,offset exp	; fpoint
	call	binflt
	pop	si		;restore si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
float	endp

	page
;	binary to floating point
;	si -> significand (dword)
;	bx -> exponent    (word)
;	di -> result      (qword)
binflt	proc	near
	push	bx		;save regs
	push	si
	push	di
	fild	word ptr [bx]	;Y
	call	tenx		;10**Y=2**E
	fimul	dword ptr [si]	;sig*2**E
	fstp	qword ptr [di]	;store ans
	fwait			;synchronize
	pop	di		;restore regs
	pop	si
	pop	bx
	ret
binflt	endp

;	10**ST
tenx	proc	near
	fstcw	ctrl		;round down
	fwait
	and	ctrl,0f3ffh	; ctrl reg
	or	ctrl,0400h	; bit 10=1
	fldcw	ctrl		; bit 11=0
	fldl2t			;Y\log2 10
	fmulp	st(1),st(0)	;Y*log2 10 = E
	fld	ST		; E \ E
	frndint			; E \ I
	fxch			; I \ E
	fld	st(1)		; I\E\I
	fsubp	st(1),st(0)	;I\(E-I=F)
	fidiv	two		;I\F/2
	f2xm1			;I\2**F/2 - 1
	fiadd	one		;I\2**F/2=T2
	fld	ST		;I\T2\T2
	fmulp	st(1),st(0)	;I\2**F
	fscale			;I\2**(F+I)
	fstp	st(1)		;2**E
	fwait
	ret
tenx	endp

	page
;	floating point to F*10**E
fpdec	proc	near		;z
	fld	st(0)		;z\z
	fld	st(0)		;z\z\z
	fabs			;z\z\|z|
	fld1			;z\z\|z|\1
	fxch	st(1)		;z\z\1\|z|
	fyl2x			;z\z\log2 z
	fldl2t			;z\z\log2 z\log2 10
	fdivp	st(1),st(0)	;z\z\E'
	frndint			;z\z\E
	fist	E		;z\z\E
	fchs			;z\z\-E
	call	tenx		;z\z\10**-E
	fmulp	st(1),st(0)	;z\F (1-9)
	fimul	ten8		;z\F*10**8
	fbstp	F		;z\bcd store
	fwait			;z
	ret
fpdec	endp

;	negate E
negE	proc	near
	push	dx
	mov	ax,word ptr E
	mov	dx,word ptr E+2
	call	dnegate
	mov	word ptr E,ax
	mov	word ptr E+2,dx
	pop	dx
	ret
negE	endp

	page
;	print F*10**E
pst	proc	near
	push	ax
	push	cx
	push	si
	push	di
	push	es
	push	ds
	pop	es		;es=ds
	call	fpdec		;calc F*10**E
	std
	mov	di,offset bufend-1
	mov	byte ptr 1[di],0 ;bufend=0
	mov	si,offset E
	mov	negeflg,0	 ;convert E
	test	byte ptr E+3,80h ;if E neg
	jns	pf2
	call	negE		;negate E
	not	negeflg		;set flag
pf2:	call	sharps
	cmp	negeflg,0	;if E neg
	je	pf0
	mov	al,'-'		; add -
	stosb
pf0:	mov	al,'E'
	stosb			;add E
	mov	al,' '
	stosb			;add blank
	mov	si,offset F
	mov	base,16		;bcd is hex
	mov	cx,8
pf3:	call	sharp		;do 8 digits
	loop	pf3
	mov	al,'.'		;add .
	stosb
	mov	al,byte ptr F+4
	and 	al,0fh
	or	al,30h		;add units
	stosb			; digit
	mov	al,byte ptr F+9	;check sign
	test	al,80h		;if neg
	jns	pf1
	mov	al,'-'		;add -
	stosb
pf1:	inc	di
	mov	si,di		;si->string
	call	mess2
	mov	base,10		;base=10
	pop	es		;restore regs
	pop	di
	pop	si
	pop	cx
	pop	ax
	ret
pst	endp


	page
;	dump 8087 stack to fdumpb
fdump	proc	near
	push	bx
	push	cx
	mov	bx,0
	mov	cx,8
fdp1:	fst	qword ptr fdumpb[bx]
	fincstp
	add	bx,8
	loop	fdp1
	pop	cx
	pop	bx
	ret
fdump	endp

code	ends
	end

			
