	title  bcd math routines
;
	public	bcdadd,clrmem,bcdsub,bcdmul,bcddiv
code	segment public
	assume	cs:code
add:	jmp	bcdadd
sub:	jmp	bcdsub
mul:	jmp	bcdmul
div:	jmp	bcddiv
;
;	bcd addition
;	 reg1=reg1+reg2
;
bcdadd	proc near
	push	ax
	push	si		;save regs
	push	di	
	push	cx
	push	bp
	mov	bp,sp
	add	bp,12		;point to parameters
	mov	cx,[bp]		;cx=rlen
	mov	di,2[bp] 	;di=ptrr2
	mov	si,4[bp] 	;si=ptrr1
	std
	clc			;clear carry
add1:	lodsb
	adc	al,[di]
	daa			;dec adjust
	mov	1[si],al  	;[si]=[si]+[di]
	dec	di	
	loop	add1		;repeat rlen times
	pop	bp
	pop	cx
	pop	di
	pop	si
	pop	ax
	ret 6
bcdadd	endp
	page
;
;	bcd subtraction
;	 reg1=reg1-reg2
;
bcdsub	proc near
	push	ax
	push	si		;save regs
	push	di
	push	cx
	push	bp
	mov	bp,sp
	add	bp,12		;point to parameters
	mov	cx,[bp] 	;cx=rlen
	mov	di,2[bp] 	;di=ptrr2
	mov	si,4[bp] 	;si=ptrr1
	std
	clc			;clear carry
sub1:	lodsb
	sbb	al,[di]
	das			;dec adjust
	mov	1[si],al 	;[si]=[si]-[di]
	dec	di
	loop	sub1		;repeat rlen times
	pop	bp
	pop	cx		;restore regs
	pop	di
	pop	si
	pop	ax
	ret 6
bcdsub	endp
	page
;
;	clear cx bytes starting at di
;
clrmem	proc near
	push	cx
	push	es
	push	ds
	pop	es		;es=ds
	cld
	mov	al,0
	rep stosb
	pop	es
	pop	cx
	ret
clrmem	endp
	page
;
;	logic shift right reg1
;
lsrreg	proc near
	push	ax		;save regs
	push	si
	push	cx
	push	bp
	mov	bp,sp
	add	bp,10		;point to parameters
	mov	si,2[bp] 	;si=ptrr
	mov	cx,[bp]  	;cx=rlen
	inc	si
	sub	si,cx		;si->msb
	clc			;clear carry
lsr1:	rcr	byte ptr [si],1 ;rotate [si]
	inc	si
	loop	lsr1		;repeat rlen times
	pop	bp		;restore regs
	pop	cx
	pop	si
	pop	ax
	ret 4
lsrreg	endp
	page
;
;	logic shift left reg1
;
lslreg	proc near
	push 	ax		;save regs
	push	si
	push	cx
	push	bp
	mov	bp,sp
	add	bp,10		;point to parameters
	mov	si,2[bp] 	;si=ptrr
	mov	cx,[bp]		;cx=rlen
	clc			;clear carry
lsl1:	rcl	byte ptr [si],1 ;rotate l [si]
	dec	si
	loop	lsl1		;repeat rlen times
	pop	bp		;restore regs
	pop	cx
	pop	si
	pop	ax
	ret 4
lslreg	endp
	page
;
;	bcd multiplication
;
bcdmul	proc near
	push	ax		;save regs
	push	bx
	push	cx
	push	dx
	push	di
	push	bp
	mov	bp,sp
	add	bp,14		;point to parameters
	mov	ax,[bp]
	shl	ax,1
	mov	cx,ax
	mov	di,6[bp] 	;di=prod
	sub	di,cx
	inc	cx
	mov	dx,cx		;dx=2*rlen+1
	call	clrmem		;clr prod
	dec	cx		;cx=2*rlen
mul1:	mov	di,2[bp]
	mov	al,[di]
	and	al,0fh
	je	mul3
	mov	bl,al		;bl=bcnt
mul2:	mov	ax,6[bp]
	sub	ax,[bp]
	push	ax		;ptrr1=prod-rlen
	push	4[bp]		;ptrr2=op1
	mov	ax,[bp]
	inc	ax
	push	ax  		;rlen+1
	call	bcdadd		;bcd add op1 & prod
	dec	bl		;repeat bcnt times
	jne	mul2
mul3:	mov	bh,4
mul4:	push	6[bp]		;rotate
	push	dx		; prod
	call	lsrreg
	push	2[bp]		; & op2
	push	[bp]
	call	lsrreg		; right
	dec	bh		; 4 bits
	jne	mul4
	loop	mul1		;repeat 2*rlen times
	pop	bp		;restore regs
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret 8
bcdmul	endp
	page
;
;	bcd division
;
bcddiv	proc near
	sub	sp,2		;2 temp locations
	push	ax		;save regs
	push	bx
	push	cx
	push	di
	push	bp
	mov	bp,sp
	add	bp,10		;point to equot
	mov	ax,4[bp] 	;rlen
	shl	ax,1
	mov	cx,ax		;cx=2*rlen
	call	normal		;normalize
	mov	di,10[bp] 	;quot
	mov	bx,di
	sub	di,cx
	inc	di		;di=quot-2*rlen+1
	call	clrmem		;clear quot
	mov	di,bx
	dec	di		;di=quot-1
div1:	push	8[bp]		;push num
	push	6[bp]		;push denom
	mov	bx,4[bp]
	inc	bx
	push	bx		;push rlen+1
	call	bcdsub		;sub denom from num
	jb	div2		; until a borrow (C=1)
	inc	byte ptr [di] 	;else  +quot
	jmp	div1		; & repeat
div2:	push	8[bp]		;add denom
	push	6[bp]		; to num
	push	bx		;rlen+1
	call	bcdadd
	dec	cx		;do 2*rlen times
	je	div4
	mov	ah,4		;rotate
div3:	push	di		; quot
	push	4[bp]
	call	lslreg
	push	8[bp]		; & num
	push	bx
	call	lslreg		; left
	dec	ah		; 4 bits
	jne	div3
	jmp	div1		;repeat all
div4:	mov	ax,[bp]		;adj dec. pt.
	sub	ax,1[bp]
	shl	bx,1		;2*(rlen+1)
	sub	ax,bx		;equot=enum-eden
	add	ax,3		;  -2*rlen+5
	mov	1[di],al	;exp in quot
	pop	bp		;restore regs
	pop	di
	pop	cx
	pop	bx
	pop	ax
	add	sp,2		;fix stack
	ret 8
bcddiv	endp
	page
;
;	normalize num and denom
normal	proc near
	push	ax		;save regs
	push	cx
	push	si
	mov	byte ptr [bp],0 ;enum=0
	mov	byte ptr 1[bp],0 ;eden=0
	push	cx		;save 2*rlen
nm1:	mov	si,6[bp] 	;si=denom
	sub	si,4[bp]
	mov	al,1[si] 	;al=msb of denom
	and	al,0f0h
	jne	nm4		;if =0 &
	dec	cx		; 2*rlen<>0
	jne	nm2		; if denom=0
	mov	byte ptr 1[si],10h ;set to 1
	jmp	nm4
nm2:	dec	byte ptr 1[bp] 	;then dec eden
	mov	ah,4		; rotate
nm3:	push	6[bp]		;  denom
	push	4[bp]
	call	lslreg		;  left
	dec	ah		;  4 bits
	jne	nm3
	jmp	nm1		;repeat
nm4:	pop	cx		;cx=2*rlen
nm5:	mov	si,8[bp] 	;si=num
	sub	si,4[bp]
	mov	al,1[si] 	;al=msb of num
	and	al,0f0h
	jne	nm7		;if =0 &
	dec	cx		; 2*rlen<>0
	je	nm7
	dec	byte ptr [bp] 	;dec enum
	mov	ah,4		; rotate
nm6:	push	8[bp]		;  num
	push	4[bp]
	call	lslreg		;  left
	dec	ah		;  4 bits
	jne	nm6
	jmp	nm5		;repeat
nm7:	pop	si		;restore regs
	pop	cx
	pop	ax
	ret
normal	endp
code	ends
	end
