
	title  real-time clock

;	Link with screen

stack	segment para stack
	db	64 dup (?)
stack	ends

zerop	segment at 0
	org	1ch*4
int1c	label	word
zerop	ends

	extrn	mess2:near,setcur:near
	extrn	query:near,quit:near
	extrn	kbuf:byte,blank:near

data	segment	public
msg1	db	'Enter current time '
	db	'<hour:min:sec>: ',0
count	db	'?'
cnt5	db	'?'
vidseg	dw	?	;video segment address
vecseg	dw	?	;save int vector segment addr
vecoff	dw	?	;save int vector offset addr
data	ends
;
code	segment public
	assume	cs:code,ds:data

;	turn clock off
clkoff	proc near
	push	ds			;save ds
	mov	dx,vecoff		;restore old
	mov	ds,vecseg		; 1Ch int vec
	mov	al,1Ch
	mov	ah,25h
	int	21h
	pop	ds		
	int 3
clkoff	endp

;	main program
clock	proc far
	mov	ax,data
	mov	ds,ax			;ds=data
	mov	ah,15			;get video state
	int	10h
	cmp	al,7			;if mode 7
	jne	clk1
	mov	vidseg,0b000h		;vidseg=b000
	jmp	clk2			;else
clk1:	mov	vidseg,0b800h		;vidseg=b800
clk2:	mov	dh,24	 		;row=24
	call	blank			;blank row 24
	mov	dl,0			;col=0
	call	setcur			;set cursor
	mov	si,offset msg1
	call	mess2			;enter
	call	query			; starting time
	call	dsptim			;display time
	mov	count,18		;count=18
	mov	cnt5,5			;cnt5=5
	push	ds			;save ds
	mov	ah,35h			;save 1Ch int vec
	mov	al,1Ch
	int	21h
	mov	vecseg,es
	mov	vecoff,bx
	push	cs			;store int vec
	pop	ds
	mov	dx,offset intser
	mov	ah,25h
	int	21h
	pop	ds			;restore ds
	int 3				; stay in tutor
clock	endp
	page

;	interrupt service routine
intser	proc near
	push	ax			;save regs
	push	cx
	push	si
	push	ds
	mov	ax,data
	mov	ds,ax			;ds=data
	dec	count			;dec count
	jne	out2			;if = 0
	mov	si,offset kbuf		;point to time
	mov	ax,6[si]		;ax=secs
	xchg	al,ah
	add	al,1			;inc secs
	aaa				;ascii adjust
 	or	al,30h
	mov	6[si],ah
	mov	7[si],al
	cmp	ax,3630h		;if secs=60
	jne	out1			;then
	mov	word ptr 6[si],3030h 	;secs=00
	mov	ax,3[si]
	xchg	al,ah
	add	al,1			;  inc mins
	aaa
	or	al,30h
	mov	3[si],ah
	mov	4[si],al
	cmp	ax,3630h		;  if mins=60
	jne	out1			;  then
	mov	word ptr 3[si],3030h 	;mins=00
	mov	ax,[si]
	xchg	al,ah
	add	al,1			;    inc hours
	aaa
	or	al,30h
	mov	[si],ah
	mov	1[si],al
	cmp	ax,3133h		;  if hours=13
	jne	out1			;  then
	mov	word ptr [si],3130h 	; hours=01
out1:	call	dsptim			;display time
	mov	count,18		;count=18
	dec	cnt5			;  (or every
	jne	out2			;    5th time,
	inc	count			;   count=19)
	mov	cnt5,5			; reset cnt5=5
out2:	pop	ds			;restore regs
	pop	si
	pop	cx
	pop	ax
out3:	iret
intser	endp

	page
;	display time
dsptim	proc near
	push	ax			;save regs
	push	si
	push	di
	push	cx
	push	es
	mov	ax,vidseg		;point to video
	mov	es,ax			; RAM with es
	mov	di,008ch		;end of 1st row
	mov	cx,8			;move 8 bytes
	mov	si,offset kbuf  	;point to time
	mov	ah,70h			;reverse video
	cld
dpt1:	lodsb				;load byte
	stosw				;store word
	loop	dpt1			;do 8 times
	pop	es			;restore regs
	pop	cx
	pop	di
	pop	si
	pop	ax
	ret
dsptim	endp

code	ends
	end	clock
