	title	RPN calculator
	
stack	segment	para	stack
	db	128 dup(?)
stack	ends

data	segment	public
to_in	dw	?
here	db	16 dup(?)
msg1	db	' <-- What??',0
bptop	dw	?
data	ends

bpush	macro	val
	xchg	bp,sp		;push val
	push	val		;on bp stack
	xchg	bp,sp
	endm

bpop	macro	val
	xchg	bp,sp		;pop val
	pop	val		;from bp stack
	xchg	bp,sp
	endm

	extrn	clrscn:near,dokey:near
	extrn	query:near,number:near
	extrn	pax:near,crlf:near
	extrn	mess2:near,chrout1:near
	extrn	kbuf:byte
	extrn	span:word

code	segment	public
	assume	cs:code,ds:data

main	proc	far
	mov	ax,data
	mov	ds,ax		;set ds
	mov	es,ax		;es=ds
	mov	bp,sp
	sub	bp,128		;set data stack
	mov	bptop,bp	;top of data stack
	cld			;dir increase
	call	clrscn		;clear screen
mn1:	mov	to_in,0		;t0_in=0
	call	crlf		;do crlf
	call	query		;get input
mn2:	call	getword		;get next word
	cmp	here,0		;if no word
	je	mn1		; get new input
	call	doword		;eval word
	jmp	mn2
main	endp

	page
;	parse string for blanks between words
;	input:	si -> string
;		cx -> length of string
;	output:	si -> 1st char of parsed word
;		di -> 1st blank after word
parse	proc	near
	mov	di,si		;di->string
	push	ds
	pop	es		;es=ds
	cld			;di increases
	mov	al,20h		;look for blank
	jcxz	pr2		;skip no string
	repe scasb		;skip leading
	je	pr1		; blanks
	inc	cx		;back up to 1st
	dec	di		; non blank
pr1:	mov	si,di		;si->next word
	jcxz	pr2		;skip no string
	repne scasb		;find 1st blank
	jne	pr2		; after word
	inc	cx		;back up to 1st
	dec	di		; blank
pr2:	ret
parse	endp

;	parse next word & move to here
getword	proc	near
	mov	si,offset kbuf
	add	si,to_in	;si->to_in
	mov	cx,span		;cx = # of
	sub	cx,to_in	;chars left
	jcxz	wd1		;if 0 do again
	call	parse		;get next word
	mov	cx,di		;cx=# char
	sub	cx,si		; in word
	mov	ax,di
	sub	ax,offset kbuf
	mov	to_in,ax	;set to_in
wd1:	mov	di,offset here	;move word
	mov	[di],cl		; as $string
	inc	di		; to here
	jcxz	wd2
	rep movsb
wd2:	mov	al,0		; make asciiz
	stosb
	ret
getword	endp
	
	page
;	find word in dictionary and execute it
doword	proc	near
	mov	al,here			;al=count
dwd1:	mov	si,offset here		;si->$string
	inc	si			;si->1st char
	cmp	al,1			;if not 1 char
	je	dwd2		
	call	cknum			;check for number
	ret
dwd2:	mov	di,offset jmptbo	;di->jump table
	mov	dx,offset cknum		;default check number
	mov	al,[si]			;al = char (operator)
	call	dokey			;use dokey
	ret
doword	endp

jmptbo	db	'+'		;add
	dw	plus
	db	'-'		;subtract
	dw	minus
	db	'*'		;multiply
	dw	times
	db	'/'		;divide
	dw	slash
	db	'.'		;print value
	dw	dott
	db 	0

	page
;	add top 2 elements on data stack
plus	proc	near
	bpop	ax
	bpop	bx
	add	ax,bx
	bpush	ax
	ret
plus	endp
	
;	subtract top 2 elements on data stack
minus	proc	near
	bpop	bx
	bpop	ax
	sub	ax,bx
	bpush	ax
	ret
minus	endp

;	multiply top 2 elements on data stack
times	proc	near
	bpop	ax
	bpop	bx
	mul	bx		;signed prod
	bpush	ax		;is in ax!
	ret
times	endp

	page
;	divide 2nd element on data stack
;	by the top element on data stack
slash	proc	near
	bpop	bx		;bx=denom
	bpop	ax
	or	ax,ax		;if negative
	jns	sl1
	mov	dx,0ffffh	;sign extend
	jmp	sl2		;else
sl1:	mov	dx,0		;0:ax=numer
sl2:	idiv	bx		;signed divide
	bpush	ax
	ret
slash	endp

;	display top element on stack
dott	proc	near
	mov	al,20h
	call	chrout1
	bpop	ax		;get value
	call	pax		;print it
	ret
dott	endp

;	check word for number
cknum	proc	near
	push	si
	push	di
	mov	si,offset here		;si->$string
	mov	al,[si]
	mov	ah,0			;ax = count
	inc	si
	mov	bx,si
	add	bx,ax			;bx->00(end)
	call	number			; get number
	cmp	si,bx			;bx->00
	jne	ck1			;if valid
	bpush	ax			; push ax
	jmp	ck2			;else
ck1:	call	errmsg			;error message
ck2:	pop	di
	pop	si
	ret
cknum	endp

	page
;	print error message
errmsg	proc	near
	call	crlf
	mov	si,offset here
	inc	si
	call	mess2			;print word
	mov	si,offset msg1
	call	mess2			; <-- What??
	mov	bp,bptop		;reset data sp
	ret
errmsg	endp

code	ends
	end	main

			


			


