
////////////////////////////////////////////////////////////
Program 1.3. Interface Between C and Assembler
////////////////////////////////////////////////////////////
// C-module ARITHC_C.C calls ASM-module to sum two
// parameters. It includes a procedure which will be called
// from ASM-module and prints the result.
// Demo program for ExpAsm Chapter1 "Review of Assembly
// Language".
//
#include <stdio.h>
						//Definition of external procedure
						//(ASM-module C_to_ASM_add):
external void C_to_ASM_add (int Operand1,long Operand2);

void ASM_to_C (int i);  //The procedure ASM_to_C will be
						//called from ASM-module.

void main(void)
{
C_to_ASM_add(50,500);	//Call ASM-module with parameters
						//50 and 500.
}

void ASM_to_C (int Res)
{
printf("RESULT = %d \n", Res);
						//To no surprise it prints that
						//500 + 50 = 550.
}

;-----------------------------------------------------------
;ASM-module ARITHA_C.ASM adds parameters
; Op1 and Op2 and calls procedure ASM_to_C
;  and prints the result.
; Demo program for ExpAsm Chapter1 "Review of Assembly
; Language".
;
.MODEL small
PUBLIC _C_to_ASM_add
EXTRN c ASM_to_C : PROC

.CODE
			; Parameters from C-module
Op1		 EQU word ptr [bp+6]
Op2		 EQU word ptr [bp+4]

_C_to_ASM_add	 PROC NEAR
			push bp
			mov bp,sp

			mov ax,Op1		; AX = Op1
			add ax,Op2		; AX = Op1 + Op2

			push ax			; Value to be passed.
			call ASM_to_C	; Call the printer!
			add sp,2			; Clean up stack (deallocate the
							; parameter passed to ASM_to_C).
			pop bp
			ret
_C_to_ASM_add	 ENDP
END

