
////////////////////////////////////////////////////////////
Program 1.5. Multisegment Program.
////////////////////////////////////////////////////////////
;-----------------------------------------------------------

; Multisegment program. Procedures from two code segments
; print two exclamations from two data segments.
; Demo program for ExpAsm Chapter1 "Review of Assembly
; Language".
;
.DOSSEG
.MODEL large			; Large model is used.
.STACK 1000h			; Big stack.
.DATA				; Start of data segments.
Data1 SEGMENT		; Very big data segment.
	  Exclamation1	DB 9000 DUP ('OOPS! $')
	  Exclam		DB 7 DUP(?)
Data1 ENDS

Data2 SEGMENT		; One  more big data segment.
	  Exclamation2 DB 9000 DUP ('Aah! $')
Data2 ENDS

.CODE				; Start of code segments.
.STARTUP				; Initialization of Segment Registers.

			mov ax,SEG Exclamation1
			mov ds,ax
			mov si,offset Exclamation1
						 	; DS:SI points to Exclamation1 now.
			mov ax,SEG Exclam
			mov es,ax
			mov di,offset Exclam
								; ES:DI points to Exclam now.
			mov cx,7				; Using REP prefix,
			rep movsb			; Copy 6 bytes of Exclamation1 									; to Exclam.
			call Out_Exclamation  	; Print Exclamation2.

			jmp far ptr Entry_point 	; Jump to code
									; segment Code2.

Code1 SEGMENT				; First code segment

Out_Exclamation	PROC FAR
			push ds			; Preserve DS used in procedure.
			mov ax,SEG Exclam
			mov ds,ax
			mov dx,OFFSET Exclam
					 		; DS:DX points to Exclam now.
			mov ah,09h		; Print Exclam using DOS service.
			int 21h
			pop ds
			ret
Out_Exclamation ENDP

Code1 ENDS					; End of code segment Code1.

Code2 SEGMENT				; Second code segment.
Entry_point:
			mov ax,SEG Exclamation2
			mov ds,ax
			mov si,OFFSET Exclamation2
							; DS:SI points to Exclamation1 now.
			mov ax,SEG Exclam
			mov es,ax
			mov di,OFFSET Exclam
								; ES:DI points to Exclam now.
			mov cx,7				; Equivalent to loop
			.REPEAT				; construction.
			movsb				; It copies 6 bytes
			.UNTILCXZ			; from Exclamation2 to Exclam.
			call Out_Exclamation	; Print Exclamation2.

.EXIT 0							; Exit the program with code 0.
Code2 ENDS						; End of code segment Code2.
END	
