
////////////////////////////////////////////////////////////
Program 1.6. Multimodule program.
////////////////////////////////////////////////////////////
; Module1 of multimodule program.
; Demo program for ExpAsm Chapter1 "Review of Assembly
; Language".
;
.DOSSEG
.MODEL small
.STACK 100h
EXTRN Message3: BYTE					; Message from Module3.
EXTRN Str_out : NEAR, Mess_out: NEAR	
			; Procedures Str_out (from Module2) and
			; Mess_out (from Module3) are used in this module.
.DATA
	  Data_for_nothing DB 20 DUP (90)	; Unused data.
.CODE
.STARTUP		; Initialization of Segment Registers.

			mov dx,OFFSET Message3	; Print string from
			call Str_out				; Module3.

			call Mess_out		; Print string from Module2
						  		; using procedure from Module3.

.EXIT 0		 ; Exit program with code 0.

END			 ; End of program.

;-----------------------------------------------------------
;Module2 of multimodule program.
; Demo program for ExpAsm Chapter1 "Review of Assembly
; Language".
;
.DOSSEG
.MODEL small
PUBLIC Str_out	; Str_out can be used by other modules.
PUBLIC Message	; Message can be used by other modules.
.DATA
		Message DB 'Modules 2, 3 have already been used!';
				DB  10,13,'$'
.CODE

Str_out PROC NEAR
			mov ah,09h			; Function 09h.
			int 21h				; Call DOS service.
			ret
Str_out ENDP						; End of procedure.

END							; End of Module2.

;-----------------------------------------------------------
; Module3 of multisegment program.
; Demo program for ExpAsm Chapter1 "Review of Assembly
; Language".
;
.DOSSEG
.MODEL small
PUBLIC Message3		; String Message3 and procedure Mess_out
PUBLIC Mess_out		; can be used by other modules.
EXTRN  Message: BYTE	; Module3 uses string Message from Module2.
.DATA
	  Message3  DB 'I am from Module 3! ',10,13,'$'
.CODE

Mess_out	PROC NEAR					; Start of the procedure.
			mov dx,OFFSET Message	; Print string
			mov ah,09h				; Message using
			int 21h					; DOS function 09h.
			ret
Mess_out	ENDP					; End of procedure.

END							; End of Module3

