;SVGA information block returned by GetSVGAInfo call
SVGAInfoBlock	struc
	VESASignature	db 4 dup (?)	;Signature bytes:  must be 'VESA'
	VESAVersion	dw 0		;VESA version number
	OEMStringPtr	dd 0            ;Far pointer to OEM string
	Capabilities	dd 0            ;Capabilities
	VideoModePtr	dd 0            ;Far pointer to list of supported SVGA modes
	MemBlockInst	dw 0		;64K memory blocks installed
	reserved	db 236 dup (0)	;Revserved
SVGAInfoBlock	ends

;Mode information returned by GetModeInfo call
ModeInfoBlock	struc
	ModeAttributes	dw 0		;Mode attributes
	WinAAttributes	db 0            ;Window A attributes
	WinBAttributes	db 0		;Window B attributes
	WinGranularity	dw 0            ;Window granularity
	WinSize		dw 0            ;Window size
	WinASegment	dw 0            ;Window A start segment
	WinBSegment	dw 0            ;Window B start segment
	WinFuncPtr	dd 0		;Far pointer to window function call
	BytesPerLine	dw 0		;Bytes per scan line
;end of obligatory structure

	XResolution	dw 0		;Horizontal resolution
	YResolution	dw 0            ;Vertical resolution
	XCharCellSize	db 0            ;Character cell width
	YCharCellSize	db 0            ;Character cell height
	NumberOfPlanes	db 0            ;Number of memory planes
	BitsPerPixel	db 0            ;Bits per pixel
	NumberOfBanks	db 0            ;Number of banks
	MemoryModel	db 0            ;Memory model type
	BankSize	db 0            ;Bank size in KB
	NumberofPages	db 0		;Number of display pages available
	Reserv		db 226 dup (0)	;Reserved
ModeInfoBlock	ends

;VESA Control function
VESACall	EQU	4Fh
GetVESAInfo	EQU	0
GetModeInfo	EQU	1
SetVESAMode	EQU	2
GetVESAMode	EQU	3
SVGAState	EQU	4
SwichBank	EQU	5
ScanLineLength	EQU	6
StartofDisplay	EQU	7

End_of_modes	EQU	-1

;Video mode Attributes
HardSupport	EQU 	01h	;Mode is supported in hardware
OptionalInfo	EQU	02h	;Optional mode information is available
BIOSSupport	EQU 	04h	;BIOS supports output functions
Color		EQU	08h	;It is a is color mode
GraphicsMode	EQU	10h	;It is a graphics mode

;Window Attributes
WinExists	EQU	01h	;Window exists
WinRead		EQU	02h	;Window is readable
WinWrite	EQU	04h	;Window is writable

;Memory models
TextMode	EQU  	0	;Text modes
CGAGraphMode	EQU	1	;CGA Graphics modes
HercGraphMode	EQU	2	;Hercules graphics mode
PlanarMode	EQU	3	;4 Plane planar modes
PackedMode	EQU 	4	;Packed pixel modes
NonChainMode	EQU	5	;Extended packed pixel
HIColor		EQU	6	;R,G,B per pixel model
