#ifndef COLORMODEL_H
#define COLORMODEL_H

#include <math.h>
#include <common.h>
void HLS2RGB(float H,float L,float S,float &R,float &G,float &B);
void RGB2HLS(float R,float G,float B,float &H,float &L,float &S);
void HSV2RGB(float H,float S,float V,float &R,float &G,float &B);
void RGB2HSV(float R,float G,float B,float &H,float &S,float &V);
void YIQ2RGB(float Y,float I,float Q,float &R,float &G,float &B);
void RGB2YIQ(float R,float G,float B,float &Y,float &I,float &Q);
void CIE2RGB(float x,float y,float z,float &R,float &G,float &B);
void RGB2CIE(float R,float G,float B,float &x,float &y,float &z);
void RGB2CMY(float R,float G,float B,float &C,float &M,float &Y);
void RGB2CMYK(float R,float G,float B,float &C,float &M,float &Y,float &K);

// mix two colors in CIE representation
void mixcolors(float x1,float y1,float z1,
		float x2,float y2,float z2,
		float &x12,float &y12,float &z12);
#endif


