;(c) This program is writen by Kiselev J. 1994.

.model large

public _ditherpixel
public _ditherbar
public _setrgbcol

; macro for putting one row (byte) of dither cell
PutBlendByte	macro
		mov dl,0c4h	; DX = 3c4h (Sequenser addr reg port)
		mov ax,0102h	; AL = Map Mask register number
				; AH = value for Map Mask reg
				; enable write to first bit plane
		out dx,ax
		inc dx		; DX = 3c5h (Sequenser data port)
		mov ah,[si]	; AH = byte for first bit plae
		xchg es:[di],ah	; update bit plane
		out dx,al	; enable write to second bit plane
		mov al,[si+8]	; AL = byte for second bit plae
		mov es:[di],al  ; update bit plane
		mov al,4        ; enable write to third bit plane
		out dx,al
		mov al,[si+16]	; AL = byte for third bit plae
		mov es:[di],al	; update bit plane
		mov al,8	; enable write to fourth bit plane
		out dx,al
		mov al,[si+24]	; AL = byte for fourth bit plae
		mov es:[di],al	; update bit plane
endm

RGBColor struc	; 8x8 bitmap structure
  Plan0 db 8 dup (?)	; 8 bytes per each bit plane
  Plan1 db 8 dup (?)
  Plan2 db 8 dup (?)
  Plan3 db 8 dup (?)
RGBColor ends

.data
fillRGBcol	RGBcolor <0> ; allocate memory for bitmap in data segment
VideoSegment	dw 0a000h	; video memory segment

.code
.286


;this routine simply put pixel

PX		EQU word ptr [bp+6]	; X coordinate
PY              EQU word ptr [bp+8]	; Y coordinate
PR              EQU word ptr [bp+10]	; R component [0..63]
PG              EQU word ptr [bp+12]	; G component [0..63]
PB              EQU word ptr [bp+14]    ; B component [0..63]

_ditherpixel	proc far
		push bp
		mov bp,sp

		push PB
		push PG
		push PR
		push cs
		call near ptr _setrgbcol	;create dither cell
		add sp,6

		xor dx,dx
		mov ax,PY
		mov bx,PX
		mov dl,al
		call PixelAddr          ; calculation of pixel address
					; AH = bit mask
					; ES:DI points to video memory
					; CL = # bits to shift left
		shl ah,cl		; bit mask

		lea si,fillRGBCol.RGBColor.Plan0
		and dl,7
		add si,dx		; SI points to row in bitmap

		mov dx,3ceh
		mov al,8
		out dx,ax       	; set bit mask
		PutBlendByte		; put pixel
					; DX = 3c5h

		mov al,0fh		; restore  default registers
		out dx,al

		mov dl,0ceh
		mov ax,0ff08h
		out dx,ax

		pop bp
		ret
_ditherpixel	endp


;this routine simply draws bar

Y2		EQU word ptr [bp+12]	; coordinate of down-right
X2		EQU word ptr [bp+10]    ; corner of the bar
Y1		EQU word ptr [bp+8]	; coordinate of upper-left
X1		EQU word ptr [bp+6]     ; corner of the bar

Fm		EQU byte ptr [bp-2]
Lm		EQU byte ptr [bp-4]
cntbyte		EQU word ptr [bp-6]
ControlMask	EQU word ptr [bp-8]
IncNextRow      EQU word ptr [bp-10]
cntrow		EQU word ptr [bp-12]

_ditherbar	proc far
		enter 10,0
		push di
		push si

		mov ax,Y1
		mov bx,X1
		call PixelAddr  	; ES:DI -> video memory

		mov cx,X1
		and cl,7
		mov al,0ffh
		shr al,cl
		mov Fm,al		; bit mask for first mask

		mov cx,X2
		and cl,7
		xor cl,7
		mov al,0ffh
		shl al,cl
		mov Lm,al		; bit mask for last mask

		mov ax,X2               ; calculation of bytes in
		mov bx,X1		; line
		shr ax,3
		shr bx,3
		sub ax,bx
		dec ax
		jns no_one_byte
		mov bl,Fm
		and Lm,bl
no_one_byte:
		mov cntbyte,ax		; AX = bytes in line - 2

		sub ax,80
		not ax
		mov IncNextRow,ax

		mov ax,Y2
		sub ax,Y1
		inc ax
		mov cntrow,ax		; AX = rows in bar

		mov ax,Y1
		and ax,7
		lea si,fillRGBcol.RGBcolor.Plan0
		mov dx,si
		add si,ax		; SI = points to bitmap
		add dx,8
		mov ControlMask,dx
barnext_line1:
		mov dx,3ceh		; DX = 3ceh Graphics Controller
					; port address
		mov cx,cntbyte
		call FastBlendFillLine  ; draw horizontal line
		inc si			; next bitmap row
		cmp si,ControlMask
		jb IncRow
		lea si,fillRGBcol.RGBcolor.Plan0
IncRow:
		add di,IncNextRow	; DI = points to next screen line
		dec cntrow
		jnz barnext_line1	; next line

		pop si
		pop di
		leave
		ret
_ditherbar	endp

FastBlendFillLine proc near
		or cx,cx
		js BarL144B		; jamp if bar is too narrow(1 byte)

		mov al,8
		mov ah,Fm
		out dx,ax		; set bit mask
		PutBlendByte		; put byte
		inc di
		mov dl,0ceh
		or cx,cx
		jz BarL144B             ; jamp if bar is narrow(2 byte)

		mov ax,0ff08h
		out dx,ax    		; set bit mask
		PutBlendByte		; put byte

		mov al,0fh
		out dx,al		; enable write to all bit plane

		mov dl,0ceh
		inc di
		dec cx
		jz BarL144B
				; fast fill line in write mode 1
		mov ax,0105h
		out dx,ax		; set write mode 1
		mov ax,si
		mov si,di
		dec si
		db 0f3h,26h,0a4h	;rep movsb es:
		mov si,ax
		mov ax,5
		out dx,ax		; set write mode 0
BarL144B:
		mov ah,Lm
		mov al,8
		out dx,ax		; set bit mask
		PutBlendByte		; put byte
		ret
FastBlendFillLine endp

; base colors - number of "pure" colors in system palette
; (numbers of palette registers)
Red		EQU     4
LightRed	EQU     12
Green		EQU     2
LightGreen	EQU     10
Blue		EQU     1
LightBlue	EQU     9


; R,G,B componets [0..63]
B		EQU byte ptr [bp+10]
G		EQU byte ptr [bp+8]
R		EQU byte ptr [bp+6]

_setrgbcol	proc far
		push bp
		mov bp,sp
		push di		; preserve caller registers

		mov ax,@data
		mov es,ax
		lea di,fillRGBcol.RGBcolor.Plan0 ; ES:DI points to bitmap

		cld			; clear direction flag
		mov cx,16		; CX = word in bitmap
		xor ax,ax               ; AX = 0
		rep stosw		; zero bitmap

		lea di,fillRGBcol.RGBcolor.Plan0
		add al,R		; AL = Red component
		jz no_red		; jamp if R = 0

		mov cl,0		; CL = 0 (Black)
		mov ch,Red		; CH = number of "Red" register
		cmp al,32		; if R < 32 then will be mixed
					; Black and Red colors
		jb BlackRed
					; mixed Red and LightRed colors
		mov cl,ch		; CL = number of "Red" register
		mov ch,LightRed		; CH = number of "LightRed" register
		sub al,32		; AL = 0..31
BlackRed:
		call CalcMaskColor	; create mask for the first four
					; rows of bitmap
		call CreatBitMap	; creat the first four rows
					; of bitmap
no_red:
		mov al,G		; AL = Green component
		or al,al
		jz no_green             ; jamp if R = 0
		lea di,fillRGBcol.RGBcolor.Plan0
		mov cl,0		; CL = 0 (Black)
		mov ch,Green		; CH = number of "Green" register
		cmp al,32		; if G < 32 then will be mixed
					; Black and Green colors
		jb BlackGreen
					; mixed Green and LightGreen colors
		mov cl,ch		; CL = number of "Green" register
		mov ch,LightGreen	; CH = number of "LightGreen" register
		sub al,32		; AL = 0..31
BlackGreen:
		call CalcMaskColor	; create mask for the first four
					; rows of bitmap
		call CreatBitMap	; creat the first four rows
					; of bitmap
no_green:
		mov al,B		; AL = Blue component
		or al,al
		jz no_blue		; jamp if B = 0
		lea di,fillRGBcol.RGBcolor.Plan0
		mov cl,0		; CL = 0 (Black)
		mov ch,Blue		; CH = number of "Blue" register
		cmp al,32		; if B < 32 then will be mixed
					; Black and Blue colors
		jb BlackBlue
					; mixed Blue and LightBlue colors
		mov cl,ch               ; CL = number of "Blue" register
		mov ch,LightBlue	; CH = number of "LightBlue" register
		sub al,32		; AL = 0..31
BlackBlue:
		call CalcMaskColor	; create mask for the first four
					; rows of bitmap
		call CreatBitMap        ; create the first four rows
					; of bitmap
no_blue:

; make last four rows of bitmap

		lea di,fillRGBcol.RGBcolor.Plan0
		mov dl,4		; plan counter
		mov cl,4		; shift counter
shift_next_plan:
		mov ch,4		; row counter
shift_row:
		mov al,es:[di]		; AL = row from first half of bitmap
		rol al,cl		; shift AL at 4
		mov es:[di+4],al	; create row the second half of bitmap
		inc di			; DI point to next row
		dec ch
		jnz shift_row           ; shift next row

		add di,4		; DI point to next bit plane of bitmap
		dec dl
		jnz shift_next_plan	; next bit plane
debug_exit:
		pop di
		pop bp			; restore registers
		ret			; and return
_setrgbcol	endp

; subroutine for creating the first four rows of bitmap
; input: DL,DH,BL,BH = masks for corresponding rows
CreatBitMap  proc near
		call CalcBitMap    ; first row
		mov bl,bh
		inc di
		call CalcBitMap    ; second row
		mov bl,dl
		inc di
		call CalcBitMap    ; third row
		mov bl,dh
		inc di
		call CalcBitMap	   ; fourth row
		ret
CreatBitMap  endp

; subroutine for creating one row of bitmap
; input: BL = mask for that row
;	 CL,CH = base colors
CalcBitMap   proc near
		push dx
		mov dl,8	; bit counter
		mov ah,1	; unshifted bit mask
next_bit_mask:
		push di
		mov al,cl	; AL = base color 1
		shr bl,1        ; shifted BL bit by bit we monitoring
		jnc color1      ; CF flag to arise in dependence with
				; this choosing color for mix
		mov al,ch 	; AL = base color 2
color1:
		mov dh,4	; plane counter
next_bit_plane:
		shr al,1	; load AH to bit planes in
		jnc no_or	; according with four lower
		or es:[di],ah   ; bits AL (base color)
no_or:
		add di,8	; DI = points to next bit plane
		dec dh
		jnz next_bit_plane

		pop di
		shl ah,1	; next bit
		dec dl
		jnz next_bit_mask
		pop dx
		ret
CalcBitMap   endp

; masks table (32 items)
DitherTable:	db 08,0,0,0
		db 88h,0,0,0
		db 88h,0,20h,0
		db 88h,0,22h,0
		db 0a8h,0,22h,0
		db 0aah,0,22h,0
		db 0aah,0,0a2h,0
		db 0aah,0,0aah,0
		db 0aah,0,0aah,40h
		db 0aah,0,0aah,44h
		db 0aah,1,0aah,44h
		db 0aah,11h,0aah,44h
		db 0aah,11h,0aah,54h
		db 0aah,11h,0aah,55h
		db 0aah,51h,0aah,55h
		db 0aah,55h,0aah,55h
		db 0bah,55h,0aah,55h
		db 0bbh,55h,0aah,55h
		db 0bbh,55h,0eah,55h
		db 0bbh,55h,0eeh,55h
		db 0fbh,55h,0eeh,55h
		db 0ffh,55h,0eeh,55h
		db 0ffh,55h,0feh,55h
		db 0ffh,55h,0ffh,55h
		db 0ffh,55h,0ffh,75h
		db 0ffh,55h,0ffh,77h
		db 0ffh,0d5h,0ffh,77h
		db 0ffh,0ddh,0ffh,77h
		db 0ffh,0ddh,0ffh,0f7h
		db 0ffh,0ddh,0ffh,0ffh
		db 0ffh,0fdh,0ffh,0ffh
		db 0ffh,0ffh,0ffh,0ffh

; load to DX and BX masks for the first four rows of bitmap
; input: AL = mask number
CalcMaskColor	proc near
		cbw      	; AX = mask number
		mov bx,Offset DitherTable ; CS:BX - point to masks table
		shl ax,2	; AX = AX*4
		add bx,ax	; BX = points to mask
		mov dx,cs:[bx+2]; DX = masks for first and second rows
		mov bx,cs:[bx]	; DX = masks for 3rd and 4th rows
		ret
CalcMaskColor	endp

;Determine address of pixel in video memory
;input AX = Y coordinate
;      BX = X coordinate
;
;returns ES:DI points to byte in video memory
;        CL = number of bits to shift left
;	 AH = unshifted bit mask
PixelAddr     proc near
		mov cl,bl
		shl ax,4	; AX = Y*16
		mov di,ax
		shl ax,2	; AX = Y*4
		add di,ax	; DI = Y*16*4 + Y*16 (Y*80)
		shr bx,3        ; BX = X div 8
		add di,bx       ; DI = Y*80 + X div 8
		mov es,VideoSegment	; ES = video memory segment
		and cl,7
		xor cl,7	;CL = number of bits to shift left
		mov ah,1
		ret
PixelAddr     endp
end