// This module lets you fadding or better say
// smooth palette transforming (it may be used for
// fade as it is or partial palette changing as well).
// VGA 256 colors mode is assumed.
//
// (c) This program is written by Kiselev J. 1994.

#pragma -ml

#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <stdlib.h>
#include <mem.h>
#include <dos.h>

#include "colmodel.h"
#include "graph.h"
#include "common.h"
#include "formats.h"
#include "formconv.h"
#include "palette.h"

extern unsigned _stklen = 32000U;

typedef struct { float Y,I,Q;} YIQtype;
typedef struct { float H,L,S;} HLStype;

void fadehls(BYTE,BYTE,BYTE,colortype*,colortype*);
void fadeyiq(BYTE,BYTE,BYTE,colortype*,colortype*);

colortype palette[256];
colortype palette1[256];


void main(int argc, char *argv[]) {
	graph_file_reader *grf_r= NULL;
	int i,j;
	int current_line = 0, inc_line = 1;
	BYTE *dest;

	if(argc < 2) {
		printf("\n\n^Z FADE.\n");
		printf("Supported formats : TGA,PCX,GIF,Windows BMP(DIB)\n");
		printf(	"up to 256 colors images!\n" );
		printf("        usage : FADE inputfile\n");
		printf("        example : FADE wolrd.gif\n");
		exit(0);
	}
	grf_r = open_image_file(argv[1]);
	if (grf_r==NULL) {printf("Unknown file format.\n"); exit(0);}

	if(!grf_r->file_ok) {
		printf("Source file not found or\n");
		printf("format structure is indistingushed.\n");
		exit(0);
	}

	if (grf_r -> colors > 256)  {
		printf(" Sorry, I can not process HighColor image");
		exit(0);
		}
	if (grf_r -> colors < 6)  {
		printf(" Sorry, I have noting to do with mono image");
		exit(0);
		}

       graphinit();
       choosevideomode(grf_r);

       dest = new BYTE [grf_r->width+1];

       if (!grf_r->top_to_bottom) {
		current_line = grf_r->height;
		inc_line =-1;
		}

	for (i=0; i <grf_r->colors; i++) {
			palette[i].r = grf_r->palette[i].r/4;
			palette[i].g = grf_r->palette[i].g/4;
			palette[i].b = grf_r->palette[i].b/4;
		}

	setDACblock(0,grf_r->colors, palette);

	switch(grf_r->source_type) {
	case COLOR16IMG:
		for (i = grf_r->height; i > 0 ; i--) {
			grf_r->get_next_line();
			if(grf_r->source_ext_type != COLOR16_1PIXEL) {
				if(grf_r->source_ext_type == COLOR16_2PIXEL)
					col16A2col16B(grf_r->source_line,dest,grf_r->width);
				else col16plane2col16B(grf_r->source_line,dest,grf_r->width);
			// 16 colors
			putrow((rowptr)dest,0,current_line,grf_r ->width);
			}
			else putrow((rowptr)grf_r->source_line,0,current_line,grf_r ->width);
			current_line += inc_line;
			if(kbhit()) break;
		}
		break;
	case GRAY256IMG:
	case COLOR256IMG:
		for (i = grf_r->height; i > 0 ; i--) {
			grf_r->get_next_line();
			putrow((rowptr)grf_r->source_line,0,current_line,grf_r->width);
			current_line += inc_line;
			if(kbhit()) break;
		}
	}




	//////////////////////////////////////////////////////

	// create destination palette (dark blue)
	for(i=0; i < 256; i++)
		{
		palette1[i].r = 0;
		palette1[i].g = 0;
		palette1[i].b = (0.3*palette[i].r +
				 0.59*palette[i].g+
				 0.11*palette[i].b) / 2;
		}
	fadeyiq(0,grf_r->colors-1,80,palette,palette1);
        delay(1000);
	fadehls(0,grf_r->colors-1,80,palette1,palette);
	getch();
	delete dest;
	delete grf_r;
        closegraph();
}

// the following routine provide smooth palette
// transformation using YIQ color model
// you should input palette range to be transform
// and the number of conversion steps

void fadeyiq(BYTE first,BYTE last,BYTE step,colortype *pal,colortype *pal1) {
float D,R_,G_,B_,Y,I,Q;
int i,j;
YIQtype YIQ[256];
YIQtype DYIQ[256];
VGApalette tmppal;

for (j = first;j<=last;j++)	// calculate array of increments
{
	// for call RGB2YIQ normalyze R,G,B value
	RGB2YIQ((float)pal[j].r/63,(float)pal[j].g/63,(float)pal[j].b/63,
		YIQ[j].Y,YIQ[j].I,YIQ[j].Q);
	RGB2YIQ((float)pal1[j].r/63,(float)pal1[j].g/63,(float)pal1[j].b/63,
		Y,I,Q);
	DYIQ[j].Y = (YIQ[j].Y - Y)/step;
	DYIQ[j].Q = (YIQ[j].Q - Q)/step;
	DYIQ[j].I = (YIQ[j].I - I)/step;
}
for (i=1;i<step;i++)	// do fade (step - 1) times
{
	for (j=first;j<=last;j++)	// calculate intermediate palette
	{
		YIQ[j].I = YIQ[j].I-DYIQ[j].I;
		YIQ[j].Y = YIQ[j].Y-DYIQ[j].Y;
		YIQ[j].Q = YIQ[j].Q-DYIQ[j].Q;
		YIQ2RGB(YIQ[j].Y,YIQ[j].I,YIQ[j].Q,R_,G_,B_);
		tmppal[j].r = R_*63;
		tmppal[j].g = G_*63;
		tmppal[j].b = B_*63;
	}
	setDACblock(first,(last-first)+1,tmppal); //set VGA palette
}
// set VGA palette with last palette
setDACblock(first,(last-first)+1,pal1);
}

// the following routine provide smooth palette
// transformation using HLS color model

void fadehls(BYTE first,BYTE last,BYTE step,colortype *pal,colortype *pal1) {
float D,R_,G_,B_,H,L,S;
int i,j;
HLStype HLS[256];
HLStype DHLS[256];
VGApalette tmppal;
for (j=first;j<=last;j++)	// calculate array of increments
{
	// for call RGB2HLS normalyze R,G,B value
	RGB2HLS((float)pal[j].r/63,(float)pal[j].g/63,(float)pal[j].b/63,
		HLS[j].H,HLS[j].L,HLS[j].S);
	RGB2HLS((float)pal1[j].r/63,(float)pal1[j].g/63,(float)pal1[j].b/63,
		H,L,S);
	// being aware of critical situation with Hue (negative or
	// UNDEFINED)
	if ((HLS[j].H != -400) && (H != -400))
	{
		D = HLS[j].H - H;
		if (D > 0)
			if (D > 180) DHLS[j].H = -(360 - D)/step;
			else DHLS[j].H = D/step;
		else
			if (abs(D) > 180) DHLS[j].H = (360 + D)/step;
			else DHLS[j].H = D/step;
	}
	else
	{
		DHLS[j].H = 0;
		if (HLS[j].H == -400) HLS[j].H = H;
	}
	DHLS[j].L = (HLS[j].L - L)/step;
	DHLS[j].S = (HLS[j].S - S)/step;
}
for (i=1;i<step;i++)		// do fade (step - 1) times
{
	for (j=first;j<=last;j++)     // calculate intermediate palette
	{
		HLS[j].H = HLS[j].H-DHLS[j].H;
		HLS[j].L = HLS[j].L-DHLS[j].L;
		HLS[j].S = HLS[j].S-DHLS[j].S;
		HLS2RGB(HLS[j].H,HLS[j].L,HLS[j].S,R_,G_,B_);
		tmppal[j].r = R_*63;
		tmppal[j].g = G_*63;
		tmppal[j].b = B_*63;
	}
	setDACblock(first,(last-first)+1,tmppal); //set VGA palette
}
// set VGA palette with last palette
setDACblock(first,(last-first)+1,pal1);
}
