/* This program is just a demo of
*  our slide-show effects.
*  Written by Kiselev J. ^Z 1994
*/

#pragma -ml

#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include <dos.h>
#include <conio.h>

#include "common.h"
#include "graph.h"
#include "grfile.h"
#include "formats.h"
#include "screff.h"
#include "paleff.h"
#include "keymouse.h"

void mdelay(void) {
WORD key;
delay_key(1000);
if (kbhit()) key = readkeyword();
if ((key == kwEsc) || (key == kwCtrlBreak)  || (key == kwCtrlC)) {
	closegraph();
	exit(0);
}
}

void* CreateEmptyPic();
void* LoadBMPFile(char *file_name,VGApalette palptr);

void main(int argc,char **argv)
{
void *v,*p,*p1,*p2,*p3;
VGApalette pal;
long fsize;
int i,j;

randomize();

if (argc < 4) {printf("usage: effdemo picture1.bmp picture2.bmp picture3.bmp"); exit(0);}
p = LoadBMPFile(argv[1],pal);
p1 = LoadBMPFile(argv[2],pal);
p2 = LoadBMPFile(argv[3],pal);
p3 = CreateEmptyPic();

graphinit();
switchmode(VGA256);
v = MK_FP(0xA000,0);

setDACblock(0,256,pal);

ShowFromCenter(0,0,319,199,0,p,v);
mdelay();
ShowFromCenter(0,0,319,199,0,p1,v);
mdelay();
ShowFromCenter(0,0,319,199,0,p3,v);
mdelay();
ShowFromCenter(0,0,319,199,1,p2,v);

mdelay();
CenterExplode(0,0,319,199,2,p1,NULL,v);

mdelay();
ShowToCenter(0,0,319,199,0,p,v);

mdelay();
Jalousie(0,0,319,199,30,0,p1,v);

mdelay();
RandomFillArea(0,0,319,199,5,5,p2,v);

mdelay();
RandomFillArea(0,0,319,199,2,50,p,v);

mdelay();
BadFAX(0,0,319,199,25,0,p1,v);

mdelay();
BadFAX(0,0,319,199,15,1,p2,v);

mdelay();
for(i=0;i<=7;i++) RandomFillArea(i*40,0,i*40+39,199,2,40,p,v);

mdelay();
Develope(0,0,319,199,111,p1,v);

mdelay();
Explode(0,0,319,199,p2,v);

mdelay();
ShowFromCorner(0,0,319,199,20,0,p1,v);
mdelay();
ShowFromCorner(0,0,319,199,20,1,p2,v);
mdelay();
ShowFromCorner(0,0,319,199,20,2,p,v);
mdelay();
ShowFromCorner(0,0,319,199,20,3,p2,v);

mdelay();
Gone_with_the_wind(0,0,319,199,p2,p1,v);

mdelay();
Slide(0,0,319,199,1,0,p2,v);
mdelay();
Slide(20,20,300,159,2,1,p,v);
mdelay();
Slide(40,30,250,168,1,3,p2,v);
mdelay();
Slide(0,0,319,199,3,3,p1,v);

mdelay();
for(i=0;i<=9;i++) Slide(50,i*20,300,i*20+19,1,2,p,v);
mdelay();
for(i=0;i<=9;i++) Slide(i*32,0,i*32+31,199,2,0,p2,v);
mdelay();
for(i=9;i>=0;i--) Slide(i*32,0,i*32+31,199,2,0,p1,v);

mdelay();
for(i=0;i<=3;i++) CenterExplode(i*80,0,i*80+79,199,2,p1,p2,v);

mdelay();
CenterExplode(0,0,319,199,2,p,NULL,v);

mdelay();
for(i=0;i<=19;i++)
if (i%2 == 0) Slide(i*16,0,i*16+15,199,2,0,p1,v);
	   else Slide(i*16,0,i*16+15,199,2,1,p1,v);

mdelay();
for(i=0;i<=199;i++)
for(j=0;j<=319;j++)
if ((i+j)%2 == 0) *&MixBuffer(v)[i][j]=*&MixBuffer(p1)[i][j];
		else *&MixBuffer(v)[i][j]=*&MixBuffer(p2)[i][j];
mdelay();
Develope(0,0,319,199,127,p1,v);

mdelay();

Gone_with_the_wind(0,0,319,199,p1,p3,v);
mdelay();
Gone_with_the_wind(0,0,319,199,p3,p2,v);
mdelay(); 

free(p);
free(p1);
free(p2);
free(p3);

colwheeldemo1(v);
getch();
colwheeldemo2(v);
getch();

textmode(C80);
printf(" That's all folks !");
}

void* CreateEmptyPic()
{
void* ptr;
if ((ptr = malloc(64000)) == NULL )
{
   printf("Not enough memory to allocate buffer\n");
   exit(1);  //terminate program if out of memory
}
memset(ptr,0,64000);
return(ptr);
}

void* LoadBMPFile(char *file_name,VGApalette palptr)
{
	graph_file_reader *grf_r;
	int i, j, line_no = 0, inc_line = 1;
	void* imageptr;

	grf_r  = open_image_file(file_name);
	if (grf_r  == NULL) {printf("Can not open image file. %s",file_name); exit(0);}

	if ((grf_r->width > 320) && (grf_r->height > 200)) {
		printf("Too big image size (320x200 only)."); exit(0); }

	if ((grf_r->source_type != COLOR256IMG) &&
			(grf_r->source_type != GRAY256IMG)) {
			printf("Invalid image type (256 colors only)"); exit(0); }

	imageptr = CreateEmptyPic();
	for(i=0;i<256;i++) {
		palptr[i].r = grf_r->palette[i].r/4;
		palptr[i].g = grf_r->palette[i].g/4;
		palptr[i].b = grf_r->palette[i].b/4;
	}
	if(!grf_r->top_to_bottom) {line_no = grf_r->height-1;inc_line =-1;}

	for ( i = 0; i < grf_r->height; i++, line_no += inc_line) {
		grf_r->get_next_line();
		memmove((BYTE*)imageptr+line_no*320U,grf_r->source_line,grf_r->width);
	}
	delete grf_r;
	return(imageptr);
}
