; This program is the driver for all VGA 16 colors modes
; up to 800x600.
; Compiled with TASM 3.1.
; Written by Yuri Kiselev 1994
;
.model large,c

public proctable16
public ClipRectArea

viewporttype struc
left	dw 0
top	dw 0
right	dw 0
bottom	dw 0
ends

graphdata segment public
graphdata ends

extrn viewport : viewporttype
extrn videoselector : word
extrn linepattern : word
extrn fillpatternptr : dword
extrn patterntype : byte
extrn trflag : byte
extrn drawcolor : byte
extrn fillcolor : byte
extrn backcolor : byte
extrn bytesperline : word
extrn writemode : byte

.data
proctable16	dd far ptr putpixel
		dd far ptr drawline
		dd far ptr bar
		dd far ptr putimage
		dd far ptr getimage
		dd far ptr imagesize
		dd far ptr putrow
		dd far ptr drawpolygon
		dd far ptr changeput
		dd far ptr getpixel
.code
.286

changeput	proc far
		mov al,3
		shl ah,3
		mov dx,3ceh
		out dx,ax
		ret
changeput	endp


wrpixx          EQU word ptr [bp+6]
wrpixy          EQU word ptr [bp+8]
Color		EQU byte ptr [bp+10]

PutPixel	proc far
		push bp
		mov bp,sp
		push ds
		push di

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,wrpixy
		mov bx,wrpixx
		call PixelAddr

		shl ah,cl

		mov dx,3ceh
		mov al,8
		out dx,ax

		mov al,0
		xchg es:[di],al

		mov dl,0C4h
		mov ah,Color
		mov al,2
		out dx,ax

		mov byte ptr es:[di],0FFh

		mov ax,0F02h
		out dx,ax

		mov dl,0ceh
		mov ax,0FF08h
		out dx,ax

		pop di
		pop ds
		pop bp
		ret
PutPixel	endp

;
;
;
;

wrpixx          EQU word ptr [bp+6]
wrpixy          EQU word ptr [bp+8]

GetPixel	proc far
		push bp
		mov bp,sp
		push ds
		push di

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,wrpixy
		mov bx,wrpixx
		call PixelAddr

		shl ah,cl
		mov ch,ah
		mov bl,0

		mov dx,3ceh
		mov ax,0304h
nextbit:
		out dx,ax
		mov bh,es:[di]
		and bh,ch
		neg bh

		rol bx,1
		dec ah
		jge nextbit

		mov al,bl

		pop di
		pop ds
		pop bp
		ret
GetPixel	endp

;
;
;
;

LX1		EQU word ptr [bp+6]
LY1		EQU word ptr [bp+8]
LX2		EQU word ptr [bp+10]
LY2		EQU word ptr [bp+12]

VertInc		EQU word ptr [bp-2]
Inc1		EQU word ptr [bp-4]
Inc2		EQU word ptr [bp-6]
Routine		EQU word ptr [bp-8]
LPattern	EQU word ptr [bp-10]

DrawLine	proc  far
		push bp
		mov bp,sp
		sub sp,10
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,linepattern
		mov LPattern,ax
		cld

		mov dx,3ceh
		mov ax,0f01h
		out dx,ax

		mov ah,drawcolor
		dec al
		out dx,ax

		mov si,bytesperline

		mov cx,LX2
		sub cx,LX1
		jz VerticalLine		; jump if vertical line

		jns X1toX2		; jump if x2 > x1
		mov ax,LY2		; exchange y1 and y2
		xchg ax,LY1
		mov LY2,ax

		mov ax,LX2		; exchange x1 and x2
		xchg ax,LX1
		mov LX2,ax

		neg cx
X1toX2:
		mov ax,LY2
		sub ax,LY1
		jz HorizontalLine	; jump if horizontal line

		jns positslope		; jump if slope is positive

		neg ax
		neg si			; negate increment for buffer interleave

; select appropriate routine for slope of line

positslope:
		mov VertInc,si		; save vertical increment

		mov Routine,offset LoSlopeLine
		cmp ax,cx
		jle L04			; jump if dy <= dx (slope <= 1)

		mov Routine,offset HiSlopeLine
		xchg ax,cx

; calculate initial decision variable and increments

L04:
		shl ax,1
		mov Inc1,ax		; Inc1 = 2 * dy
		sub ax,cx
		mov si,ax
		sub ax,cx
		mov Inc2,ax		; Inc2 = 2 * (dy - dx)

		push cx
		mov ax,LY1
		mov bx,LX1
		call PixelAddr

		shl ah,cl
		mov al,8
		out dx,al
		inc dx

		mov al,ah
		pop cx
		inc cx			

		jmp Routine		; jump to appropriate routine for slope
	
					; routine for vertical lines
VerticalLine:
		mov ax,LY1
		mov cx,LY2
		sub cx,ax
		jge Y1toY2			; jump if dy >= 0

		neg cx
		mov ax,LY2
Y1toY2:
		inc cx
		mov bx,LX1
		push cx
		call PixelAddr

		shl ah,cl
		mov al,8
		out dx,ax

		pop cx
		cmp LPattern,0ffffh
		je SolidPattern
					; draw the line
		mov bx,LPattern
nextpixel:
		ror bx,1
		jnc skip_bit
		xchg es:[di],al
skip_bit:
		add di,si
		loop nextpixel

		jmp linedone
SolidPattern:
		xchg es:[di],al
		add di,si
		loop SolidPattern

		jmp linedone

				; routine for horizontal lines (slope = 0)
HorizontalLine:
		mov ax,LY1
		mov bx,LX1
		call PixelAddr

		mov bh,ah
		not bh
		shl bh,cl
		not bh			; BH = bit mask for first byte in line

		mov cx,LX2
		and cl,7
		xor cl,7		; CL = number of bits to shift left
		mov bl,0FFh
		shl bl,cl		; BL = bit mask for last byte in line

		mov ax,LX2
		mov dx,LX1
		shr ax,3		; AX = byte offset of x2
		shr dx,3		; DX = byte offset of x1
		mov cx,ax
		sub cx,dx		; CX = bytes in line - 1
		jnz noonebyte
		and bl,bh
noonebyte:
		mov dx,3ceh
		mov al,8
		out dx,al
		inc dx

		mov ax,es
		mov ds,ax

		mov si,di
		cmp LPattern,0ffffh
		jne nosolidline

		or cx,cx
		jz onebyte

		mov al,bh
		out dx,al
		movsb
		dec cx
		jz onebyte

		mov al,0ffh
		out dx,al
		rep movsb
onebyte:
		mov al,bl
		out dx,al
		movsb

		jmp linedone
nosolidline:
		mov si,LPattern
		or cx,cx
		jz onebytep

		mov ax,si
		and al,bh
		out dx,al
		xchg es:[di],al
		inc di
		ror si,8
		dec cx
		jz onebytep
nextbyte:
		mov ax,si
		out dx,al
		xchg es:[di],al
		ror si,8
		inc di
		loop nextbyte
onebytep:
		mov ax,si
		and al,bl
		out dx,al
		xchg es:[di],al

		jmp linedone

; routine for dy <= dx (slope <= 1)     

LoSlopeLine:
		mov bx,LPattern
lonextbyte:
		mov al,ah		; AH = bit mask for next pixel
maskrot:
		or al,ah		; mask current pixel position
		ror ah,1		; rotate pixel value
		jc putnxbyte		; jump if bit mask rotated to
					; leftmost pixel position

		or si,si		; test sign of d
		jns putbyte		; jump if d >= 0

		add si,Inc1		; d = d + Inc1
		loop maskrot

		and al,bl
		out dx,al
		xchg es:[di],al
		jmp short linedone
putbyte:
		add si,Inc2		; d = d + Inc2
		and al,bl
		out dx,al
		xchg es:[di],al

		add di,VertInc		; increment y
		loop lonextbyte

		jmp short linedone

				; bit mask shifted out
putnxbyte:
		and al,bl
		out dx,al
		xchg es:[di],al
		inc di			; increment x
		xchg bl,bh

		or si,si		; test sign of d
		jns nonneg		; jump if non-negative

		add si,Inc1		; d = d + Inc1
		loop lonextbyte

		jmp short linedone
nonneg:
		add si,Inc2		; d = d + Inc2
		add di,VertInc		; vertical increment
		loop lonextbyte

		jmp short linedone

					; routine for dy > dx (slope > 1)       

HiSlopeLine:
		mov bx,VertInc
		out dx,al
		cmp LPattern,0ffffh
		jne pattline
hsnextbyte:
		xchg es:[di],ah
		add di,bx		; increment y
		or si,si		; test sign of d
		jns nextmsk		; jump if d >= 0

		add si,Inc1		; d = d + Inc1
		loop hsnextbyte
		jmp short linedone
nextmsk:
		add si,Inc2		; d = d + Inc2
		ror al,1		; rotate bit mask
		adc di,0		; increment DI if when mask rotated to
					; leftmost pixel position
		out dx,al
		loop hsnextbyte
		jmp short linedone
pattline:
		ror LPattern,1
		jnc skip_bit1
		xchg es:[di],ah
skip_bit1:
		add di,bx		; increment y
		or si,si		; test sign of d
		jns nextmskwp		; jump if d >= 0

		add si,Inc1		; d = d + Inc1
		loop pattline
		jmp short linedone
nextmskwp:
		add si,Inc2		; d = d + Inc2
		ror al,1		; rotate bit mask
		adc di,0		; increment DI if when mask rotated to
					; leftmost pixel position
		out dx,al
		loop pattline
linedone:
		mov dx,3ceh
		xor ax,ax
		out dx,ax

		inc ax
		out dx,ax

		mov ax,0FF08h
		out dx,ax

		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
DrawLine	endp

;
; procedure Bar(x,y,x1,y1 : integer);
;
;

XO		EQU word ptr [bp+6]
YO		EQU word ptr [bp+8]
BarX2		EQU word ptr [bp+10]
BarY2		EQU word ptr [bp+12]

XOtop		EQU word ptr [bp-2]
YOtop		EQU word ptr [bp-4]
begin_line	EQU word ptr [bp-6]
end_line	EQU word ptr [bp-8]
begin_bit	EQU word ptr [bp-10]
end_bit		EQU word ptr [bp-12]
cntshift	EQU byte ptr [bp-14]
Fm		EQU byte ptr [bp-16]
Lm		EQU byte ptr [bp-18]
cntbyte		EQU word ptr [bp-20]
PatternEndOfs	EQU word ptr [bp-22]
PatternOfs      EQU word ptr [bp-24]
IncNextRow      EQU word ptr [bp-26]
FillLine	EQU word ptr [bp-28]

Bar		proc far
		push bp
		mov bp,sp
		sub sp,28
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax

		cld

		mov si,YO
		mov di,XO
		mov cx,BarX2
		sub cx,di
		inc cx
		mov dx,BarY2
		sub dx,si
		inc dx
		push cs
		call near ptr ClipRectArea		; lines in window end_line-begin_line !!!
		jns barvis
		jmp barinvis
barvis:
		mov ax,viewport.left
		add ax,XO
		and al,7
		mov cntshift,al
		call CalcOffsetandMask

		mov ax,begin_line
		dec ax
		sub end_line,ax

		mov ax,bytesperline
		sub ax,cntbyte
		dec ax
		mov IncNextRow,ax
		mov es,videoselector
		mov ax,0205h
		mov dx,3ceh
		cmp patterntype,1
		je solidfl
		mov bx,offset PatternLine
		cmp trflag,1
		jne no_tr_patt
		mov bx,offset GlassLine
no_tr_patt:
		mov FillLine,bx
		out dx,ax
		mov al,8
		out dx,al
		inc dx

		mov bh,backcolor
		mov bl,fillcolor
		mov es,videoselector
		lds si,fillpatternptr
		mov ax,si
		mov PatternOfs,ax
		mov cx,YOtop
		and cx,7
		add si,cx
		add ax,8
		mov PatternEndOfs,ax
barnext_linep:
		mov cx,cntbyte
		call FillLine
		add di,IncNextRow
		inc si
		cmp si,PatternEndOfs
		jne no_endpat
		mov si,PatternOfs
no_endpat:
		dec end_line
		jnz barnext_linep

		jmp short bar_done
solidfl:
		mov bx,offset QuickFillline
		cmp writemode,0
		jz quickly
		mov ah,fillcolor
		xor al,al            ; AL := Set/Reset reg number
		out dx,ax
		mov bx,offset FastFillline
		mov ax,0F01h
quickly:
		mov FillLine,bx
		out dx,ax
		mov bl,Fm
		mov bh,Lm
		mov ah,fillcolor
		mov al,8
		out dx,al
		inc dx
		mov cx,videoselector
		mov es,cx
		mov ds,cx
sbarnext_line:
		mov cx,cntbyte
		call FillLine
		add di,IncNextRow
		dec end_line
		jnz sbarnext_line
bar_done:
		mov dx,3ceh
		mov ax,5
		out dx,ax

		mov ax,0ff08h
		out dx,ax

		mov dl,0c4h
		mov ax,0f02h
		out dx,ax
barinvis:
		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
Bar	  	endp

FastFillLine	proc near  ; with OR,XOR,AND mode
		or cx,cx
		js fflast_byte

		mov al,bl
		out dx,al
		xchg es:[di],al
		inc di

		or cx,cx
		jz fflast_byte

		mov al,0ffh
		out dx,al
		mov si,di
		rep movsb
fflast_byte:
		mov al,bh
		out dx,al
		xchg es:[di],al
		ret
FastFillLine	endp

QuickFillLine	proc near  ; only NormalPut mode
		or cx,cx
		js qflast_byte

		mov al,bl
		out dx,al
		mov al,ah
		xchg es:[di],al
		inc di

		or cx,cx
		jz qflast_byte

		mov al,0ffh
		out dx,al
		mov al,ah
		shr cl,1
		rep stosw
		adc cl,0
		rep stosb
qflast_byte:
		mov al,bh
		out dx,al
		mov al,ah
		xchg es:[di],al
		ret
QuickFillLine	endp

PatternLine	proc near
		or cx,cx
		js pllast_byte

		mov al,[si]
		and al,Fm
		out dx,al
		mov ah,bl
		xchg es:[di],ah
		not al
		and al,Fm
		out dx,al
		mov al,bh
		xchg es:[di],al
		inc di

		or cx,cx
		jz pllast_byte
putnext_byte:
		mov al,[si]
		out dx,al
		mov ah,bl
		xchg es:[di],ah
		not al
		out dx,al
		mov al,bh
		xchg es:[di],al
		inc di
		dec cx
		or cx,cx
		jz pllast_byte

		; write mode 1 !!!
		dec dx
		mov ax,0105h
		out dx,ax
		push ds
		push si
		mov ax,es
		mov ds,ax
		mov si,di
		dec si
		rep movsb
		pop si
		pop ds
		mov ax,0205h
		out dx,ax
		mov al,8
		out dx,al
		inc dx
pllast_byte:
		mov al,[si]
		and al,Lm
		out dx,al
		mov ah,bl
		xchg es:[di],ah
		not al
		and al,Lm
		out dx,al
		mov al,bh
		xchg es:[di],al
		ret
PatternLine	endp

GlassLine	proc near
		mov ah,[si]
		or cx,cx
		js gllast_byte

		mov al,ah
		and al,Fm
		out dx,al
		mov al,bl
		xchg es:[di],al
		inc di

		or cx,cx
		jz gllast_byte

		mov al,ah
		out dx,al
gputnext_byte:
		mov al,bl
		xchg es:[di],al
		inc di
		loop gputnext_byte
gllast_byte:
		mov al,ah
		and al,Lm
		out dx,al
		mov al,bl
		xchg es:[di],al
		ret
GlassLine	endp

;
;
;
;

RowPtr		EQU dword ptr [bp+6]
XO		EQU word ptr [bp+10]
YO		EQU word ptr [bp+12]
Xcounter	EQU word ptr [bp+14]	; (X2 - X1 + 1)

PutRow		proc far
		push bp
		mov bp,sp
		sub sp,24
		push ds
		push si
		push di

		mov ax,SEG graphdata
		mov ds,ax

		mov si,YO
		mov di,XO
		mov cx,Xcounter
		mov dx,1
		push cs
		call near ptr ClipRectArea
		js short InvisRow

		mov ax,viewport.left
		add ax,XO               ; four commands
		and al,7
		mov cntshift,al		; for compatibility with ImageClip

		call CalcOffsetandMask
		mov cx,bx

		mov ax,0205h
		mov dx,3ceh
		out dx,ax

		mov bl,Fm
		mov bh,Lm
		mov al,8
		out dx,al
		inc dx

		mov es,videoselector
		lds si,RowPtr
		call _PutRow

		mov al,0ffh
		out dx,al
		dec dx
		mov ax,5
		out dx,ax
InvisRow:
		pop di
		pop si
		pop ds
		mov sp,bp
		pop bp
		ret
PutRow		endp

_PutRow		proc near
		add si,begin_bit
		or cx,cx
		js one_bytepr
		mov al,80h
next_pix:
		shl bl,1
		jnc no_write
		out dx,al
		mov ah,[si]
		xchg es:[di],ah
		inc si
no_write:
		shr al,1
		jnc next_pix
		inc di

		or cx,cx
		jz one_bytepr
copynext_byte:
		mov al,80h
next_pixel:
		out dx,al
		mov ah,[si]
		xchg es:[di],ah
		inc si
		shr al,1
		jnc next_pixel

		inc di
		loop copynext_byte
one_bytepr:
		mov al,80h
next_pix1:
		shl bh,1
		jnc no_write1
		out dx,al
		mov ah,[si]
		xchg es:[di],ah
		inc si
		shr al,1
		jnc next_pix1
no_write1:
		ret
_PutRow		endp

; Name: ImageSize
;
; Function: Calculation size of buffer for image store(in bytes)
;
; Caller: ImageSize(X1,Y1,X2,Y2:integer) : word;

ISX1		EQU word ptr [bp+6]
ISY1		EQU word ptr [bp+8]
ISX2		EQU word ptr [bp+10]
ISY2		EQU word ptr [bp+12]

ImageSize	proc far
		push bp
		mov bp,sp

		mov cx,ISX1
		mov bx,ISY2
		sub bx,ISY1
		inc bx
		mov ax,ISX2
		sub ax,cx
		inc ax
		and cx,7
		add ax,cx
		mov cl,al
		shr ax,3
		and cl,7
		jz byte_align11
		inc ax
byte_align11:
		shl ax,2		; *4 four planes
		mul bx
		add ax,HeaderLength	; size of header
		inc ax			; AX = size of buffer for image store
		xor dx,dx
		pop bp
		ret
ImageSize	endp

; Name: GetImage
;
; Caller: GetImage(int X1,Y1,X2,Y2,void *buffer);

IX1		EQU word ptr [bp+6]
IY1		EQU word ptr [bp+8]
IX2		EQU word ptr [bp+10]
IY2		EQU word ptr [bp+12]
buffer  	EQU dword ptr [bp+14]

cntline		EQU word ptr [bp-2]
real_len1	EQU word ptr [bp-4]
screen_len1 	EQU word ptr [bp-6]
Voffset1        EQU word ptr [bp-8]
BPL		EQU word ptr [bp-10]

GetImage   proc far
		push bp
		mov bp,sp
		sub sp,10
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,bytesperline
		mov BPL,ax

		les di,buffer
		mov ax,IX1
		and al,7
		xor dx,dx
		mov es:[di+0],dx
		mov es:[di+2],dx
		mov es:[di+8],al
		mov dl,al

		mov ax,IY2
		sub ax,IY1
		mov es:[di+6],ax
		inc ax
		mov cntline,ax

		mov ax,IX2
		sub ax,IX1
		mov es:[di+4],ax
		inc ax
		mov bx,ax
		mov cl,al
		shr ax,3
		and cl,7
		jz byte_align20
		inc ax
byte_align20:
		mov real_len1,ax
		mov ax,bx
		add ax,dx
		mov cl,al
		shr ax,3
		and cl,7
		jz byte_align01
		inc ax
byte_align01:
		mov screen_len1,ax
		mov es:[di+9],al
		mov ax,IY1
		mov bx,IX1
		mul bytesperline
		shr bx,3
		add bx,ax
		mov Voffset1,bx
		mov si,bx

		add di,HeaderLength
		mov dx,3ceh
		mov ax,5
		out dx,ax
		cld

		mov ds,videoselector
		mov bx,cntline
		mov al,4
		out dx,al
		inc dx
go_next_line:
		mov ax,0400h
go_next_plane:
		mov cx,screen_len1
		out dx,al
		mov si,Voffset1
		rep movsb
		inc al
		dec ah
		jnz go_next_plane
		mov ax,BPL
		add Voffset1,ax
		dec bx
		jnz go_next_line

		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
GetImage   endp

; Name: PutImage
; Function: Show and clipping picture (from buffer)
;
; Caller: PutImage(int XO,YO,void *buffer);
;

PutImageByte	macro
		mov dl,0C4h
		mov ax,0102h
		out dx,ax
		inc dx
		mov ah,[si]
		xchg es:[di],ah
		add si,bx
		out dx,al
		mov al,[si]
		mov es:[di],al
		add si,bx
		mov al,4
		out dx,al
		mov al,[si]
		mov es:[di],al
		mov al,8
		out dx,al
		mov al,[bx+si]
		mov es:[di],al
endm

HeaderLength	EQU 10

DataBuffer 	EQU dword ptr [bp+10]
YO		EQU word ptr [bp+8]
XO		EQU word ptr [bp+6]

; 2 - 22 from Bar
BytesPerStr     EQU word ptr [bp-24]
bperstr1	EQU word ptr [bp-26]
shiftbyte	EQU word ptr [bp-28]
Voffset		EQU word ptr [bp-30]
VS		EQU word ptr [bp-32]
BPL		EQU word ptr [bp-34]

PutImage	proc far
		push bp
		mov bp,sp
		sub sp,34
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,videoselector
		mov VS,ax
		mov ax,bytesperline
		mov BPL,ax

		les si,DataBuffer
		mov ax,es:[si+4]	; x2
		sub ax,es:[si]		; x1
		mov dx,es:[si+6]	; y2
		sub dx,es:[si+2]	; y1
		inc ax
		push ax
		mov bl,al
		shr ax,3
		and bl,7
		jz byte_align30
		inc ax
byte_align30:
		inc dx
		push dx
		mov bperstr1,ax
		xor ax,ax
		mov al,[si+9]
		shl ax,2
		mul dx
		inc ax
		mov shiftbyte,ax
		pop dx
		pop cx
		mov si,YO
		mov di,XO

		push cs
		call near ptr ClipRectArea
		jns vis
		jmp invis
vis:
		mov ax,viewport.left
		add ax,XO
		and al,7
		mov cntshift,al

		call CalcOffsetandMask
		mov Voffset,di

		lds si,DataBuffer

		mov ax,end_line
		inc ax
		mov dx,ax
		mov cl,cntshift
		mov al,cl
		mov ch,[si+8]
		sub al,ch
		xor bx,bx
		mov bl,[si+9]
		shl bx,2
		mov bperstr1,bx
		add [si+8],al		; correct counter shift
		add si,HeaderLength
		xor ax,ax

		; Search first line

		cmp begin_line,0
		je imno_search_line
		mov ax,begin_line
		sub dx,ax
		mov al,[si-1]
		cbw
		shl ax,2
		mov bx,dx
		mul begin_line
		mov dx,bx
imno_search_line:
		; Shift data into the buffer and
		; outputs a buffer image onto the screen

		push ax
		mov bx,shiftbyte
		mov ax,ds
		mov es,ax
		xor ax,ax
		push dx
		push si
		sub cl,ch
		jz imno_shift
		js shift_lift

		mov di,si
		mov dh,0ffh
		shr dh,cl
		mov ch,dh
		not ch
		lodsb
		ror ax,cl
		stosb

loop3:		mov dl,ah
		lodsb
		ror ax,cl
		and al,dh
		or al,dl
		or ah,dh
		and ah,ch
		stosb
		dec bx
		jnz loop3
		jmp short imno_shift
shift_lift:
		neg cl
		std
		add si,bx
		mov di,si

		mov dh,0ffh
		shl dh,cl
		mov ch,dh
		not ch
		lodsb
		rol ax,cl
		stosb

loop4:		mov dl,ah
		lodsb
		rol ax,cl
		and al,dh
		or ah,dh
		or al,dl
		and ah,ch
		stosb
		dec bx
		jnz loop4
		cld
imno_shift:
		pop si
		pop dx
		pop ax
		mov bh,0
		mov bl,[si-1]
		add si,begin_bit
		add si,ax
		mov es,VS
put_next_line:
		mov al,8
		push si
		mov di,Voffset
		push dx
		mov dx,3ceh

		mov cx,cntbyte
		or cx,cx
		js imone_byte

		mov ah,Fm
		out dx,ax

		push si
		PutImageByte
		inc di
		pop si
		inc si

		mov dl,0ceh
		mov ax,0ff08h
		out dx,ax

		or cx,cx
		jz imone_byte
		mov ah,cl

		mov dl,0C4h
		mov al,2
		out dx,al
		inc dx
imloop_str:
		mov cx,si

		; Put Byte

		mov al,1
		out dx,al
		mov al,[si]
		xchg es:[di],al
		add si,bx
		mov al,2
		out dx,al
		mov al,[si]
		mov es:[di],al
		add si,bx
		mov al,4
		out dx,al
		mov al,[si]
		mov es:[di],al
		mov al,8
		out dx,al
		mov al,[bx+si]
		mov es:[di],al

		inc di
		mov si,cx
		inc si
		dec ah
		jnz imloop_str
imone_byte:
		mov dl,0ceh
		mov al,8
		mov ah,Lm
		out dx,ax
		PutImageByte

		pop dx
		mov ax,BPL
		add Voffset,ax
		pop si
		add si,bperstr1
		dec dx
		jz exit_put
		jmp put_next_line
exit_put:
		mov dx,3c4h
		mov ax,0f02h
		out dx,ax

		mov dl,0ceh
		mov ax,0ff08h
		out dx,ax
invis:
		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
PutImage	endp

; This routines belongs to the kernel rather than to EGAVGA16 driver !!!
; lies here because it used variable names
; from routine Bar
;
; Calculating the variables :
;         begin_bit,end_bit,
;         begin_line,end_line
; for clipping of rectangular areas

; SI = Y0
; DI = X0
; DX = H
; CX = W
ClipRectArea	proc far
		or si,si
		jns no_signedYO
		or di,di
		js signedXO
		jmp no_signedXO
signedXO:
		mov ax,si
		neg ax
		mov begin_line,ax

		mov ax,viewport.left
		mov XOtop,ax
		mov ax,viewport.top
		mov YOtop,ax

		mov ax,dx
		mov bx,ax
		dec ax

		add bx,si
		js no_visible
		add bx,YOtop
		cmp bx,viewport.bottom
		jbe end_line_ok
		mov ax,si
		neg ax
		add ax,viewport.bottom
		sub ax,viewport.top
end_line_ok:
		mov end_line,ax

		mov ax,di
		neg ax
		mov begin_bit,ax
		mov ax,cx
		mov bx,ax
		dec ax

		add bx,di
		js no_visible
		add bx,XOtop
		cmp bx,viewport.right
		jbe end_bit_ok
		mov ax,di
		neg ax
		add ax,viewport.right
		sub ax,viewport.left
end_bit_ok:
		mov end_bit,ax
		xor al,al
no_visible:
		ret
no_signedYO:
		or di,di
		js signedXO1
		jmp no_signedXO1
signedXO1:
		mov ax,viewport.left
		mov XOtop,ax
		mov ax,si
		add ax,viewport.top
		mov YOtop,ax

		mov begin_line,0
		mov bx,viewport.bottom
		sub bx,ax
		mov ax,dx
		dec ax
		mov end_line,ax
		cmp bx,ax
		jae m1
		mov end_line,bx
m1:
		mov ax,di
		neg ax
		mov begin_bit,ax
		mov ax,cx
		mov bx,ax
		dec ax

		add bx,di
		js no_visible1
		add bx,XOtop
		cmp bx,viewport.right
		jbe end_bit_ok1
		mov ax,di
		neg ax
		add ax,viewport.right
		sub ax,viewport.left
end_bit_ok1:
		mov end_bit,ax
		xor al,al
no_visible1:
		ret
no_signedXO:
		mov ax,di
		add ax,viewport.left
		mov XOtop,ax
		mov ax,viewport.top
		mov YOtop,ax

		mov ax,si
		neg ax
		mov begin_line,ax
		mov ax,dx
		dec ax
		mov bx,ax

		add bx,si
		js no_visible2
		inc bx
		add bx,YOtop
		cmp bx,viewport.bottom
		jbe end_line_ok1
		mov ax,si
		neg ax
		add ax,viewport.bottom
		sub ax,viewport.top
end_line_ok1:
		mov end_line,ax

		mov begin_bit,0
		mov ax,viewport.left
		add ax,di
		mov bx,viewport.right
		sub bx,ax
		mov ax,cx
		dec ax
		mov end_bit,ax
		cmp bx,ax
		jae m2
		mov end_bit,bx
m2:
		xor al,al
no_visible2:
		ret
no_signedXO1:
		mov ax,di
		add ax,viewport.left
		mov XOtop,ax
		mov ax,si
		add ax,viewport.top
		mov YOtop,ax

		mov begin_line,0
		mov bx,viewport.bottom
		sub bx,ax
		js no_visible3
		mov ax,dx
		dec ax
		mov end_line,ax
		cmp bx,ax
		jae m3
		mov end_line,bx
m3:
		mov begin_bit,0
		mov ax,XOtop
		mov bx,viewport.right
		sub bx,ax
		js no_visible3
		mov ax,cx
		dec ax
		mov end_bit,ax
		cmp bx,ax
		jae end_calc_var
		mov end_bit,bx
end_calc_var:
		xor al,al
no_visible3:
		ret
ClipRectArea	endp

;
;
;  Call from Bar and PutImage,Packimage
;

CalcOffsetandMask proc near
		mov ax,YOtop
		mov bx,XOtop
		mov cl,bl
		mul bytesperline	; Bytes per line
		shr bx,3
		add bx,ax
		mov di,bx

		and cl,7
		mov al,0ffh
		shr al,cl
		mov Fm,al		; first mask

		mov ax,end_bit
		mov bx,ax
		sub ax,begin_bit
		mov cx,XOtop
		add cx,ax
		and cl,7
		xor cl,7
		mov al,0ffh
		shl al,cl
		mov Lm,al		; last mask

		mov ax,begin_bit
		mov cl,cntshift
		xor ch,ch
		add ax,cx
		shr ax,3

		inc bx
		add bx,cx
		mov cl,bl
		shr bx,3
		and cl,7
		jz byte_aligned2
		inc bx
byte_aligned2:
		sub bx,ax
		mov begin_bit,ax
		sub bx,2
		jns no_one_byte
		mov al,Fm
		and Lm,al
no_one_byte:
		mov cntbyte,bx
		ret
CalcOffsetandMask endp

;
;
;
;

sizeofonerow	EQU word ptr [bp+14]
Ymmin		EQU word ptr [bp+12]
YmmaxminusYmmin EQU word ptr [bp+10]
CurrOffset	EQU word ptr [bp+8]
SegXarray	EQU word ptr [bp+6]

CountX		EQU byte ptr [bp-2]
YOtop		EQU word ptr [bp-4]
BPL		EQU word ptr [bp-6]
FillPolyLine	EQU word ptr [bp-8]
BC		EQU byte ptr [bp-9]
FC		EQU byte ptr [bp-10]
LastX1		EQU word ptr [bp-12]
PatternEndOfs	EQU word ptr [bp-14]
Fm		EQU byte ptr [bp-16]
Lm		EQU byte ptr [bp-18]
PatternOfs      EQU word ptr [bp-20]
Pattptr		EQU dword ptr [bp-24]

DrawPolygon	proc far
		push bp
		mov bp,sp
		sub sp,24
		push ds

		mov ax,SEG graphdata
		mov ds,ax

		mov es,videoselector
		mov dx,bytesperline
		mov BPL,dx
		mov bl,fillcolor
		mov bh,backcolor
		mov word ptr FC,bx

		mov ax,Ymmin
		mov YOtop,ax
		mul dx
		mov Ymmin,ax  	; offset Y coordinate
		sub ax,4
		mov LastX1,4000
		cld

		mov dx,3CEh
		mov ax,0205h

		cmp patterntype,1
		jne no_solidfl
		jmp dpsolidfl
no_solidfl:
		mov bx,offset PatternLine
		cmp trflag,1
		jne dpno_tr_patt
		mov bx,offset GlassLine
dpno_tr_patt:
		mov FillPolyLine,bx
		out dx,ax
		mov al,8
		out dx,al

		mov ax,word ptr fillpatternptr[2]
		mov word ptr Pattptr[2],ax
		mov ax,word ptr fillpatternptr
		mov PatternOfs,ax
		mov bx,YOtop
		and bx,7
		add bx,ax
		mov word ptr Pattptr,bx
		add ax,8
		mov PatternEndOfs,ax

		mov ds,SegXarray
nextfillLinep:
		mov si,CurrOffset
		mov al,[si]
		shr al,1	; div 2 pair X - coord
		mov countX,al
		jz no_putlinep
next_lineinrowp:
		mov ax,[si+1]
		or ax,ax
		js no_putpairp
		push si
		call CalcPolyVar
		mov dx,3cfh
		lds si,Pattptr
		mov Fm,bl
		mov Lm,bh
		mov bx,word ptr FC
		call FillPolyLine
		pop si
		mov ds,SegXarray
no_putpairp:
		add si,4
		dec CountX
		jnz next_lineinrowp
no_putlinep:
		mov ax,word ptr Pattptr
		inc ax
		cmp ax,PatternEndOfs
		jne no_endpatp
		mov ax,PatternOfs
no_endpatp:
		mov word ptr Pattptr,ax
		mov LastX1,4000
		mov ax,BPL
		add Ymmin,ax
		mov ax,sizeofonerow
		add CurrOffset,ax
		dec YmmaxminusYmmin
		jnz nextfillLinep

		jmp short end_fill

dpsolidfl:
		mov cx,offset QuickFillLine
		cmp writemode,0
		jz quickly1		; jmp if NormalPut mode
		mov ah,bl
		mov al,0            ; AL := Set/Reset reg number
		out dx,ax
		mov ax,0F01h
		mov cx,offset FastFillLine
quickly1:
		mov FillPolyLine,cx
		out dx,ax
		mov al,8
		out dx,al
		mov ds,SegXarray
nextfillLine:
		mov si,CurrOffset
		mov al,[si]
		shr al,1	; div 2 pair X - coord
		mov countX,al
		jz no_putline
next_lineinrow:
		mov ax,[si+1]
		or ax,ax
		js no_putpair
		push si
		call CalcPolyVar
		mov dx,3cfh
		mov ah,FC
		call FillPolyLine
		pop si
no_putpair:
		add si,4
		dec CountX
		jnz next_lineinrow
no_putline:
		mov LastX1,4000
		mov ax,BPL
		add Ymmin,ax
		mov ax,sizeofonerow
		add CurrOffset,ax
		dec YmmaxminusYmmin
		jnz nextfillLine
end_fill:
		mov dx,3ceh
		mov ax,0ff08h
		out dx,al
		mov ax,5
		out dx,ax
		mov dl,0c4h
		mov ax,0f02h
		out dx,ax

		pop ds
		mov sp,bp
		pop bp
		ret
DrawPolygon	endp

CalcPolyVar	proc near
		mov di,Ymmin
		mov bx,[si+1]	; X1
		mov cl,bl
		mov ax,bx
		shr ax,3
		add di,ax

		and cl,7
		mov dl,0ffh
		shr dl,cl	; DL := bit mask for first byte

		mov ax,[si+3]	; X2
		mov cl,al
		and cl,7
		xor cl,7        ; CL := number of bits to shift left
		mov dh,0ffh     ; DH := unshifted bit mask for
				;        rightmost byte
		shl dh,cl       ; DH := bit mask for last byte
		cmp ax,LastX1
		jne no_inters
		shl dh,1
no_inters:
		mov LastX1,bx
; determine byte offset of first and last pixel in the line

		mov cl,3
		shr ax,cl       ; AX := byte offset of x2
		shr bx,cl       ; BX := byte offset of x1
		inc bx
		mov cx,ax
		sub cx,bx       ; CX := (# bytes in line) - 1
		jns no_one_byte11
		and dh,dl
no_one_byte11:
		mov bx,dx       ; BH := bit mask for last byte
				; BL := bit mask for first byte
		ret
CalcPolyVar	endp

; Call:       AX = y
;             BX = x
;
; Return:      AH = unshifted mask
;              DI = offset
;              CL = count shift
;              ES = Video selector

PixelAddr     proc near
		push dx
		mov cl,bl
		mul bytesperline
		shr bx,3	; /8
		add ax,bx
		mov di,ax
		mov es,videoselector
		and cl,7
		xor cl,7
		mov ah,1
		pop dx
		ret
PixelAddr     endp
end
