; The assembley routines to be used in kernel
; Written by Yuri Kiselev, 1994.

public _testadapter
public _normalline
public _VESAcallswitchbank
public _setDACblock
public _setVGApalette
public _getDACblock
public _VESAintswitchbank
public _clippixel
public _fillpoly
public _drawpoly

.model large,c
.286

;subsystem type
EGA		= 1
MCGA		= 2
VGA		= 3

;display types
EGADisplay	= 1
PS2MonoDisplay	= 2
PS2Display	= 3

viewporttype struc
left	dw 0
top	dw 0
right	dw 0
bottom	dw 0
ends

extrn proctable : word
extrn activemode : dword
extrn line
extrn bank : byte
extrn drawpoly_in_fillpoly : byte

public viewport
public viewport32767
public videoselector
public bytesperline
public linepattern
public fillpatternptr
public patterntype
public trflag
public drawcolor
public fillcolor
public backcolor
public writemode
public wasy
public ArrayScanLinesPtr
public sizeonerow
public callVESAswbnkptr
public grshift

assume ds:graphdata
graphdata segment public
	viewport viewporttype <0>
	viewport32767 viewporttype <0>
	videoselector dw 0A000h
	bytesperline dw ?
	linepattern dw 0ffffh
	fillpatternptr dd 0
	callVESAswbnkptr dd 0
	grshift db 0
	drawcolor db 0ffh
	fillcolor db 0ffh
	backcolor db 0
	writemode db 0
	ArrayScanLinesPtr dd 0
	wasy dw 0
	sizeonerow dw 16
	patterntype db 1
	trflag db 0
graphdata ends

.code
					;EGA switch values
EGADisplays	db	-1		;CGADisplay
		db	EGADisplay
		db	-1		;MDADisplay
		db	-1		;CGADisplay
		db	EGADisplay
		db	-1		;MDADisplay

DCCtable	dw	0		;translate table for INT 10h func 1Ah
		dw	-1		;MDA,MDADisplay
		dw	-1		;CGA,CGADisplay
		dw	0
		db	EGA,EGADisplay
		dw	-1		;EGA,MDADisplay
		dw	0
		db	VGA,PS2MonoDisplay
		db	VGA,PS2Display
		dw	0
		dw	-1		;MCGA,EGADisplay
		db	MCGA,PS2MonoDisplay
		db	MCGA,PS2Display

_testadapter	proc far
		mov	ax,1A00h
		int	10h		;call video BIOS for info

		cmp	al,1Ah
		jne	not_vga		;exit if function not supported
					;i.e., no VGA in system

		xor	bh,bh		;BX = DCC for active subsystem
		add	bx,bx
		mov	ax,cs:[bx+offset DCCtable]
		jmp	exitproc
not_vga:

					;Look for an EGA.
		mov	bl,10h		;BL = 10h (return EGA info)
		mov	ah,12h		;AH = 12h function number
		int	10h		;call EGA BIOS for info
					;if EGA BIOS is present,
					;BL <> 10H
					;CL = switch setting
		cmp	bl,10h
		je	not_ega		;jump if EGA BIOS not present

		mov	al,cl
		shr	al,1
		mov	bx,offset cs:EGADisplays
		xlat
		mov	ah,al		;AH = display type
		mov	al,EGA		;AL = subystem type
		ret
not_ega:
		mov ax,-1
exitproc:
		ret
_testadapter	endp

;
;
;
;
x1		EQU word ptr [bp+6]
y1		EQU word ptr [bp+8]
x2		EQU word ptr [bp+10]
y2		EQU word ptr [bp+12]
flag		EQU byte ptr [bp-2]

_normalline	proc far
		push bp
		mov bp,sp
		sub sp,2
		push ds
		push si
		push di

		mov ax,SEG graphdata
		mov ds,ax

		mov flag,1	; flag = 1 (slanted line)

		mov ax,word ptr viewport.left
		add x1,ax	; x1 += viewport.left
		add x2,ax	; x2 += viewport.left
		mov ax,word ptr viewport.top
		add y1,ax	; y1 += viewport.top
		add y2,ax	; y2 += viewport.top

		mov si,x2
		sub si,x1	; SI = dx
		jnz no_flag
		mov flag,-1     ; flag = -1 if x2 = x1 (vert line)
no_flag:
		mov di,y2
		sub di,y1	; DI = dy
		jnz no_flag1
		mov flag,0	; flag = 0 if y2 = y1 (horiz line)
no_flag1:
		mov ch,0	; ch - edge counter
next_edge:
				; calculate endpoints codes
		xor bx,bx	; BL = code for point x1,y1
				; BH = code for point x2,y2
		mov dx,32768
		mov ax,x1
		add ax,dx
		cmp ax,word ptr viewport32767.left
		rcl bl,1
		cmp word ptr viewport32767.right,ax
		rcl bl,1
		mov ax,y1
		add ax,dx
		cmp word ptr viewport32767.bottom,ax
		rcl bl,1
		cmp ax,word ptr viewport32767.top
		rcl bl,1

		mov ax,x2
		add ax,dx
		cmp ax,word ptr viewport32767.left
		rcl bh,1
		cmp word ptr viewport32767.right,ax
		rcl bh,1
		mov ax,y2
		add ax,dx
		cmp word ptr viewport32767.bottom,ax
		rcl bh,1
		cmp ax,word ptr viewport32767.top
		rcl bh,1

		or bx,bx		; comletely visible check
		jnz prob_part_vis	; jump if line is not comletely visible
					; draw line
		mov ax,SEG proctable
		mov ds,ax
		lea si,proctable
		les si,[si]
		push y2
		push x2
		push y1
		push x1
		call dword ptr es:[si+1*4]
		add sp,8
		jmp exitpr
prob_part_vis:
		mov ax,bx
		and ah,al		; partly visible check
		jz part_vis

		jmp exitpr		; exit if line is invisible
part_vis:
		mov dx,0101h
		mov cl,3
		sub cl,ch
		shl dx,cl
		mov ax,bx
		and ax,dx
		jnz no_loop		; jump if line is partly visible

		inc ch
		cmp ch,4
		jne part_vis

		jmp exitpr		; exit if line is invisible
no_loop:
		test bl,dh
		jnz no_swap
					; swap x1 y1 and x2 y2
		mov ax,x2
		xchg ax,x1
		mov x2,ax
		mov ax,y2
		xchg ax,y1
		mov y2,ax
no_swap:
					;
		mov ax,word ptr viewport.left
		cmp flag,-1
		je go
		cmp ch,1
		ja go
		jne no_1
		mov ax,word ptr viewport.right
no_1:
		mov dx,ax
		sub ax,x1
		mov x1,dx
		xor dx,dx
		imul di
		idiv si
		add ax,y1
		cmp ax,viewport.bottom
		jg exitpr
		cmp ax,viewport.top
		jl exitpr
		mov y1,ax
		jmp end_loop
go:
		mov ax,word ptr viewport.bottom
		cmp ch,2
		je go_ok
		mov ax,word ptr viewport.top
go_ok:
		cmp flag,0
		jz end_loop
		mov dx,y1
		mov y1,ax
		js end_loop
		sub ax,dx
		xor dx,dx
		imul si
		idiv di
		add ax,x1
		cmp ax,viewport.left
		jl exitpr
		cmp ax,viewport.right
		jg exitpr
		mov x1,ax
end_loop:
		inc ch
		cmp ch,4
		je all_edge
		jmp next_edge
all_edge:                           	; draw visible part of the line
		mov ax,SEG proctable
		mov ds,ax
		lea si,proctable
		les si,[si]
		push y2
		push x2
		push y1
		push x1
		call dword ptr es:[si+1*4]
		add sp,8
exitpr:
		pop di
		pop si
		pop ds
		mov sp,bp
		pop bp
		ret
_normalline	endp

_VESAcallswitchbank	proc far
		push ax			; DL = bank number
		push cx
		push bx
		push dx
		mov dl,bank
		mov cl,grshift
		shl dx,cl		; <- OffsetShiftBank
		xor bx,bx
		call dword ptr callVESAswbnkptr
		pop dx
		pop bx
		pop cx
		pop ax
		ret
_VESAcallswitchbank	endp

_VESAintswitchbank	proc far
		push ax
		push cx
		push bx
		push dx
		mov cl,grshift
		shl dx,cl
		mov ax,4F05h
		xor bx,bx
		int 10h
		pop dx
		pop bx
		pop cx
		pop ax
		ret
_VESAintswitchbank	endp

;
;
;
;
pal		EQU dword ptr[bp+10]
count		EQU word ptr[bp+8]
first		EQU byte ptr[bp+6]

_setDACblock	proc far
		push bp
		mov bp,sp

		push ds
		push si
		mov dx,3dah
Waitr:
		in al,dx
		test al,8
		jz Waitr

		cld
		mov cx,count
		mov ax,cx
		shl cx,1
		add cx,ax
		mov dl,0c8h
		mov al,first
		out dx,al
		inc dx
		lds si,pal
		rep outsb
		pop si
		pop ds
		pop bp
		ret
_setDACblock	endp

;
;
;
;
pal		EQU dword ptr[bp+10]
count		EQU word ptr[bp+8]
first		EQU byte ptr[bp+6]

_getDACblock	proc far
		push bp
		mov bp,sp
		push di

		mov dx,3dah
Waitr_:
		in al,dx
		test al,8
		jz Waitr_

		cld
		mov cx,count
		mov ax,cx
		shl cx,1
		add cx,ax
		mov dl,0c7h
		mov al,first
		out dx,al
		add dl,2
		les di,pal
		rep insb
		pop di
		pop bp
		ret
_getDACblock	endp

; Load VGA palette registers (16 colors mode)
Palette		EQU dword ptr [bp+6]
_setVGApalette	proc far
		push bp
		mov bp,sp
		push ds
		push si
		lds si,Palette
		mov cx,16
		mov dx,3c8h
		mov bl,0
load_pal:	mov al,bl
		out dx,al
		inc dx
		lodsw
		out dx,al
		jmp d1
d1:
		mov al,ah
		out dx,al
		lodsb
		jmp d2
d2:
		out dx,al
		inc bl
		cmp bl,6
		jne go_no5reg
		mov bl,14h
		jmp go_lreg
go_no5reg:
		cmp bl,15h
		jne go_no14reg
		mov bl,7
		jmp go_lreg
go_no14reg:
		cmp bl,8
		jne go_lreg
		mov bl,38h
go_lreg:	dec dx
		loop load_pal
		pop si
		pop ds
		pop bp
		ret
_setVGApalette	endp

x		EQU word ptr[bp+6]
y		EQU word ptr[bp+8]

_clippixel	proc far
		;clip of points
		push bp
		mov bp,sp
		push ds

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,word ptr viewport.left
		add x,ax
		cmp ax,x
		jg no_put
		mov ax,word ptr viewport.right
		cmp x,ax
		jg no_put
		mov ax,word ptr viewport.top
		add y,ax
		cmp ax,y
		jg no_put
		mov ax,word ptr viewport.bottom
		cmp y,ax
		jg no_put
		mov cx,y
		mov dx,x
		mov al,0
		pop ds
		pop bp
		ret
no_put:
		mov al,1
		pop ds
		pop bp
		ret
_clippixel	endp

x		EQU word ptr [bp+10]
y		EQU word ptr [bp+8]
x1              EQU word ptr [bp+6]
y1              EQU word ptr [bp+4]

deltax          EQU word ptr [bp-2]
prevy           EQU word ptr [bp-4]
ddx             EQU word ptr [bp-6]
dy              EQU word ptr [bp-8]
s1              EQU word ptr [bp-10]
s2              EQU word ptr [bp-12]

polyline	proc near
		push bp
		mov bp,sp
		sub sp,12

		mov ax,x1
		mov bx,y1
		mov cx,x
		mov dx,y
		mov s1,0
		sub ax,cx		;ax = x1-x;
		jz l
		mov s1,1
		jns l
		mov s1,-1
		neg ax
l:
		mov s2,0
		sub bx,dx		;bx = y1-y;
		jnz l12
					;skip horizontal lines
		jmp exit_line
l12:
		mov s2,1
		jns l1
		mov s2,-1
		neg bx
l1:
		mov prevy,dx
		dec prevy		;prevy = y - 1;
		cmp dx,wasy		;y >= wasy
		jle prev
		cmp dx,y1		;y < y1
		jnl prev
		inc prevy
prev:
		cmp dx,wasy		;y <= wasy
		jge prev1
		cmp dx,y1		;y > y1
		jle prev1
		inc prevy
prev1:
		mov wasy,dx
		cmp bx,ax		;dy > dx
		jle Low_slope
		xchg ax,bx
		mov si,bx
		shl si,1
		sub si,ax		;si = e =2*dy-dx;
		mov dy,bx
		mov ddx,ax
		inc ax
		mov deltax,ax
		mov y,dx
		les bx,ArrayScanLinesPtr
next_r:
		mov dx,y
		cmp prevy,dx
		je no_write_x
		cmp dx,viewport.bottom
		jg no_wr
		cmp dx,viewport.top
		jl no_wr
		mov ax,dx
		mul sizeonerow
		mov di,ax
		mov al,es:[bx+di]
		cbw
		cmp ax,sizeonerow
		jne no_change_size1
		stc
		jmp err_exit
no_change_size1:
		inc byte ptr es:[bx+di]
		shl ax,1
		add di,ax
		mov es:[bx+di+1],cx
no_wr:
		mov ax,y
		mov prevy,ax
no_write_x:
again:
		cmp si,0
		js is_sign
		add cx,s1
		mov ax,ddx
		shl ax,1
		sub si,ax
		jmp again
is_sign:
		mov ax,dy
		shl ax,1
		add si,ax
		mov ax,s2
		add y,ax
		dec deltax
		jnz next_r
		jmp exit_line
Low_slope:
;---------------------------------------
		mov si,bx
		shl si,1
		sub si,ax		;si = e =2*dy-dx;
		mov dy,bx
		mov ddx,ax
		inc ax
		mov deltax,ax
		mov y,dx
		les bx,ArrayScanLinesPtr
next_r1:
		mov dx,y
		cmp prevy,dx
		je no_write_x1
		cmp dx,viewport.bottom
		jg no_wr1
		cmp dx,viewport.top
		jl no_wr1
		mov ax,dx
		mul sizeonerow
		mov di,ax
		mov al,es:[bx+di]
		cbw
		cmp ax,sizeonerow
		jne no_change_size
		stc
		jmp err_exit
no_change_size:
		inc byte ptr es:[bx+di]
		shl ax,1
		add di,ax
		mov es:[bx+di+1],cx
no_wr1:
		mov ax,y
		mov prevy,ax
no_write_x1:
again1:
		cmp si,0
		js is_sign1
		mov ax,s2
		add y,ax
		mov ax,ddx
		shl ax,1
		sub si,ax
		jmp again1
is_sign1:
		mov ax,dy
		shl ax,1
		add si,ax
		add cx,s1
		dec deltax
		jnz next_r1
exit_line:
		clc
err_exit:
		mov sp,bp
		pop bp
		ret 8
polyline	endp

;
;
;
;

PolyP		EQU dword ptr [bp+8]
NumPoints	EQU word ptr [bp+6]

CountPoints	EQU word ptr [bp-2]
flag_hor_line	EQU word ptr [bp-4]
CurrOffset	EQU word ptr [bp-6]
YmmaxminusYmmin EQU word ptr [bp-8]
Ymmax           EQU word ptr [bp-10]
Ymmin           EQU word ptr [bp-12]

_fillpoly	proc far
		push bp
		mov bp,sp
		sub sp,12
		push ds
		push di
		push si

		mov ax,SEG activemode
		mov ds,ax
		mov cx,word ptr activemode[2]	; MaxY

		mov ax,SEG graphdata
		mov ds,ax

		mov Ymmax,-32768
		mov Ymmin,32767
		mov flag_hor_line,0

		les di,ArrayScanLinesPtr
		mov ax,sizeonerow
		mul cx
		mov cx,ax
		xor ax,ax
		shr cx,1
		rep stosw
		adc cl,1
		rep stosb

		les si,PolyP
		mov ax,NumPoints
		mov CountPoints,ax
		shl ax,1
		shl ax,1
		sub ax,8
		mov dx,si
		add si,ax
		mov ax,es:[si+2]
		mov si,dx
		add ax,viewport.top
		mov wasy,ax	  ; wasy = PolyP[NumPoints*2-2]
		xor bx,bx
		dec NumPoints
next_line:
		mov ax,es:[bx+si+2]
		cmp ax,es:[bx+si+6]
		je horl
		mov flag_hor_line,1
horl:
		push bx
		mov ax,es:[bx+si]
		add ax,viewport.left
		push ax
		mov ax,es:[bx+si+2]
		add ax,viewport.top
		push ax
		mov ax,es:[bx+si+4]
		add ax,viewport.left
		push ax
		mov ax,es:[bx+si+6]
		add ax,viewport.top
		push ax
		call PolyLine
		pop bx
		jnc no_err
		mov ax,-1
		jmp no_mem
no_err:
		les si,PolyP
		mov dx,viewport.top
		mov ax,es:[bx+si+2]
		add ax,dx
		cmp ax,Ymmax
		jl low1
		mov Ymmax,ax
low1:
		mov ax,es:[bx+si+2]
		add ax,dx
		cmp ax,Ymmin
		jg great
		mov Ymmin,ax
great:
		mov ax,es:[bx+si+6]
		add ax,dx
		cmp ax,Ymmax
		jl low2
		mov Ymmax,ax
low2:
		mov ax,es:[bx+si+6]
		add ax,dx
		cmp ax,Ymmin
		jg great1
		mov Ymmin,ax
great1:
		add bx,4
		dec NumPoints
		jz all_line
		jmp next_line
all_line:
		mov cx,Ymmax
		cmp cx,viewport.bottom
		jl no_g
		mov cx,viewport.bottom
		mov Ymmax,cx
no_g:
		mov ax,Ymmin
		cmp ax,viewport.top
		jg no_g1
		mov ax,viewport.top
		mov Ymmin,ax
no_g1:
		cmp flag_hor_line,0
		jne no_hor_line
				;find minx and maxx and draw hor. line
		jmp Draw_Poly
no_hor_line:
				;sorting X - coord.
		mov bx,cx
		sub bx,ax
		jz lala
		jns vis_y
lala:
		jmp Draw_Poly
vis_y:
		mov si,bx
		inc si
		mul sizeonerow
		les bx,ArrayScanLinesPtr
		add bx,ax
		inc bx
		mov CurrOffset,bx		;BX = offset first row in Xarray
		mov YmmaxminusYmmin,si    	;SI = Ymmax-Ymmin
sort_next_row:
		xor cx,cx
		mov cl,es:[bx-1]
		; *** even check of X count ***
		; problem with the horizontal line 
		mov al,cl
		shr al,1
		jnc ok_even
		dec byte ptr es:[bx-1]
ok_even:
		dec cl
		mov dx,bx
loop1:
		mov di,cx
		mov bx,dx
loop2:
		mov ax,es:[bx]
		cmp es:[bx+2],ax
		jge cont
		xchg ax,es:[bx+2]
		mov es:[bx],ax
cont:
		add bx,2
		loop loop2
		mov cx,di
		loop loop1
		mov bx,dx
		add bx,sizeonerow
		dec si
		jnz sort_next_row

;******************* Clip viewport.Right **************
		mov bx,CurrOffset	;BX = offset first row in Xarray
		mov si,YmmaxminusYmmin	;SI = Ymmax-Ymmin
		mov dx,viewport.right
		mov ch,0
next_xarray:
		mov cl,es:[bx-1]
		mov di,cx
		shr cx,1	; /2
		shl di,1	; *2
		sub di,2
next_xpair:
		cmp es:[bx+di],dx
		jle X_right
		cmp es:[bx+di-2],dx
		jle X_left
		sub byte ptr es:[bx-1],2
		jmp X_right
X_left:
		mov es:[bx+di],dx
X_right:
		sub di,4
		loop next_xpair
		add bx,sizeonerow
		dec si
		jnz next_xarray

;******************* Clip viewport.left **************
		mov bx,CurrOffset		;BX = offset first row in Xarray
		mov si,YmmaxminusYmmin		;SI = Ymmax-Ymmin
		mov dx,viewport.left
next_xarray1:
		xor di,di
		mov cl,es:[bx-1]
		shr cx,1
		jz o_kkk
next_xpair1:
		cmp es:[bx+di],dx
		jge X_right1
		cmp es:[bx+di+2],dx
		jge X_left1
		mov word ptr es:[bx+di],-1
		jmp X_right1
X_left1:
		mov es:[bx+di],dx
X_right1:
		add di,4
		loop next_xpair1
o_kkk:
		add bx,sizeonerow
		dec si
		jnz next_xarray1

;********************** Draw Polygon ***********************
		push sizeonerow
		push Ymmin
		push YmmaxminusYmmin		;Ymmax-Ymmin
		mov ax,CurrOffset   		;offset first row in Xarray
		dec ax
		push ax
		push word ptr ArrayScanLinesPtr[2] ;segment of array scanlines
		mov ax,SEG proctable
		mov ds,ax
		lea si,proctable
		les si,[si]
		call dword ptr es:[si+7*4]
		add sp,10
Draw_Poly:
		mov ax,SEG drawpoly_in_fillpoly
		mov ds,ax
		cmp drawpoly_in_fillpoly,0
		je no_drawpoly
		push word ptr PolyP[2]
		push word ptr PolyP
		dec countpoints
		push countpoints
		call far ptr _drawpoly
		add sp,6
no_drawpoly:
		xor ax,ax
no_mem:
		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
_fillpoly	endp

numpoints	EQU word ptr [bp+6]
polypoints	EQU dword ptr [bp+8]

_drawpoly	proc far
		push bp
		mov bp,sp
		push ds
		push di
		push si

		mov cx,numpoints
		mov ax,SEG line
		mov ds,ax
next_ln:
		push cx
		les di,polypoints
		push word ptr es:[di+6]
		push word ptr es:[di+4]
		push word ptr es:[di+2]
		push word ptr es:[di]
		call dword ptr line
		add sp,8
		pop cx
		add word ptr polypoints,4
		loop next_ln

		pop si
		pop di
		pop ds
		pop bp
		ret
_drawpoly	endp
end