; This program is the driver for VGA 256 colors modes
; Compiled with TASM 3.1
; Written by Yuri Kiselev, 1994

.model large,c

viewporttype struc
left	dw 0
top	dw 0
right	dw 0
bottom	dw 0
ends

graphdata segment public
graphdata ends

extrn viewport : viewporttype
extrn videoselector : word
extrn linepattern : word
extrn fillpatternptr : dword
extrn patterntype : byte
extrn trflag : byte
extrn drawcolor : byte
extrn fillcolor : byte
extrn backcolor : byte
extrn bytesperline : word
extrn writemode : byte
extrn ClipRectArea

public proctable256

.data
proctable256	dd far ptr putpixel
		dd far ptr drawline
		dd far ptr bar
		dd far ptr putimage
		dd far ptr getimage
		dd far ptr imagesize
		dd far ptr putrow
		dd far ptr drawpolygon
		dd far ptr changeput
		dd far ptr getpixel
.code
.286

countcase	db 2
counterchanges	db 6
NormalPutCode	db 88h
XorPutCode	db 30h
AndPutCode	db 20h
OrPutCode	db 8
ChangeOffset	dw offset ChangePut1 + 1
		dw offset ChangePut2 + 1
		dw offset ChangePut3 + 1
		dw offset ChangePut4 + 1
		dw offset ChangePut5 + 1
		dw offset ChangePut8 + 1
		db 2
		db 89h
		db 31h
		db 21h
		db 9
		dw offset ChangePut6 + 1
		dw offset ChangePut7 + 1

changeput	proc far
		push si
		push di
		mov al,ah
		mov ah,0
		mov ch,countcase
		mov dx,cs
		mov es,dx
		lea si,counterchanges
		mov bx,5
		sub bx,ax
next_case:
		mov cl,es:[si]
		add si,ax
		mov dl,es:[si+1]
		add si,bx
next_ofs:
		mov di,word ptr es:[si]
		mov es:[di],dl
		add si,2
		dec cl
		jnz next_ofs

		dec ch
		jnz next_case

		pop di
		pop si
		ret
changeput	endp

;
;
;
;

wrpixx          EQU word ptr [bp+6]
wrpixy          EQU word ptr [bp+8]
Color		EQU byte ptr [bp+10]

PutPixel	proc far
		push bp
		mov bp,sp
		push ds
		push di
		mov ax,SEG graphdata
		mov ds,ax
		mov ax,wrpixy
		mov bx,wrpixx
		call PixelAddr
		mov al,Color
		mov es:[di],al
		pop di
		pop ds
		pop bp
		ret
PutPixel	endp

;
; procedure GetPixel(x,y : integer;RGB : pointer);
;
;

x		EQU word ptr [bp+6]
y		EQU word ptr [bp+8]

GetPixel	proc far
		push bp
		mov bp,sp
		push ds
		push di

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,y
		mov bx,x
		call PixelAddr	; es:di -> Point address

		mov al,es:[di]	 ; reading color

		pop di
		pop ds
		pop bp
		ret
GetPixel	endp

LX1		EQU word ptr [bp+6]
LY1		EQU word ptr [bp+8]
LX2		EQU word ptr [bp+10]
LY2		EQU word ptr [bp+12]

Inc1		EQU word ptr [bp-2]
Inc2		EQU word ptr [bp-4]
Routine		EQU word ptr [bp-6]

DrawLine	proc  far
		push bp
		mov bp,sp
		sub sp,6
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax

		push linepattern
		cld

		mov si,bytesperline	; SI = y-increment

		mov cx,LX2
		sub cx,LX1
		jz VerticalLine		; jump if vertical line
		jns X1toX2		; jump if x2 > x1
		mov ax,LY2		; exchange y1 and y2
		xchg ax,LY1
		mov LY2,ax

		mov ax,LX2		; exchange x1 and x2
		xchg ax,LX1
		mov LX2,ax

		neg cx
X1toX2:
		mov ax,LY2
		sub ax,LY1
		jz HorizontalLine	; jump if horizontal line

		jns positslope		; jump if slope is positive

		neg ax
		neg si			; negate increment for buffer interleave

					; select appropriate routine for slope of line
positslope:
		push si
		mov Routine,offset LoSlopeLine
		cmp ax,cx
		jle L04

		mov Routine,offset HiSlopeLine
		xchg ax,cx

					; calculate initial decision variable and increments
L04:
		shl ax,1
		mov Inc1,ax		; Inc1 = 2 * dy
		sub ax,cx
		mov si,ax
		sub ax,cx
		mov Inc2,ax		; Inc2 = 2 * (dy - dx)

		mov ax,LY1
		mov bx,LX1
		call PixelAddr

		inc cx			; CX = pixels to draw

		pop bx			; BX = y-increment
		jmp Routine		; jump to appropriate routine for slope

					; routine for vertical lines
VerticalLine:
		mov ax,LY1		; AX = LY1
		mov cx,LY2		; BX = LY2
		sub cx,ax		; CX = dy
		jge Y1toY2		; if dy >= 0

		neg cx			; dy >= 0
		mov ax,LY2
Y1toY2:
		inc cx              
		mov bx,LX1		; BX = LX1

		call PixelAddr
		mov al,drawcolor
		mov bx,linepattern
		cmp bx,0ffffh
		jne vertpatln
					; Normal put
ChangePut1:
		mov es:[di],al		; updating byte
		add di,bytesperline	; increment to next line
		loop ChangePut1

		jmp linedone
vertpatln:
		ror bx,1
		jnc Skippix
ChangePut2:
		mov es:[di],al		; updating byte
Skippix:
		add di,bytesperline	; increment to next line
		loop vertpatln

		jmp linedone
					; routine for horizontal lines
HorizontalLine:
		mov ax,LY1
		mov bx,LX1
		call PixelAddr

		inc cx
		mov al,drawcolor
		mov ah,al
		mov bx,linepattern
		cmp bx,0ffffh
		jne XOR_put1

		cmp writemode,0
		jne XOR_put1

		shr cx,1
		rep stosw
		adc cl,0
		rep stosb

		jmp linedone
XOR_put1:
		mov si,cx
next_pixl:
		ror bx,1
		jnc skippix1
ChangePut3:
		mov es:[di],al
skippix1:
		inc di
		loop next_pixl
skip_byte4x:
		jmp linedone

; routine for dy <= dx (slope <= 1)     

LoSlopeLine:
		mov al,drawcolor
		xchg bx,linepattern
nextpoint:
		ror bx,1
		jnc Skippix4
ChangePut4:
		mov es:[di],al
Skippix4:
		inc di
		or si,si		; test sign of d
		jns incy		; jump if d >= 0

		add si,Inc1		; d = d + Inc1
		loop nextpoint
		jmp linedone
incy:
		add si,Inc2		; d = d + Inc2
		add di,linepattern	; increment y
		loop nextpoint
		jmp linedone

					; routine for dy > dx (slope > 1)       

HiSlopeLine:
		mov al,drawcolor
		inc bx
nextpoint1:
		ror linepattern,1
		jnc Skippix6
ChangePut5:
		mov es:[di],al
Skippix6:
		add di,bx		; increment y
		or si,si		; test sign of d
		jns incd		; jump if d >= 0

		add si,Inc1		; d = d + Inc1
		dec di
		loop nextpoint1
		jmp short linedone
incd:
		add si,Inc2		; d = d + Inc2
		loop nextpoint1
linedone:
		pop linepattern
		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
DrawLine 	endp


XO		EQU word ptr [bp+6]
YO		EQU word ptr [bp+8]
BarX2		EQU word ptr [bp+10]
BarY2		EQU word ptr [bp+12]

XOtop		EQU word ptr [bp-2]
YOtop		EQU word ptr [bp-4]
begin_line	EQU word ptr [bp-6]
end_line	EQU word ptr [bp-8]
begin_bit	EQU word ptr [bp-10]
end_bit		EQU word ptr [bp-12]
cntrows		EQU word ptr [bp-18]
cntbyte		EQU word ptr [bp-20]
IncNextLine	EQU word ptr [bp-22]
FillLine	EQU word ptr [bp-24]
PatternOfs      EQU word ptr [bp-26]

Bar		proc far
		push bp
		mov bp,sp
		sub sp,34
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax
		cld

		mov si,YO
		mov di,XO
		mov cx,BarX2
		sub cx,di
		inc cx
		mov dx,BarY2
		sub dx,si
		inc dx
		call far ptr ClipRectArea	; lines in window end_line-begin_line
		jns barvis
		jmp barinvis			; sign if bar is unvisible
barvis:
		mov ax,YOtop
		mov bx,XOtop
		call PixelAddr

		mov ax,end_line
		sub ax,begin_line
		inc ax
		mov cntrows,ax

		mov ax,end_bit
		sub ax,begin_bit
		inc ax
		mov cntbyte,ax
		mov bx,BytesPerLine
		sub bx,ax
		mov IncNextLine,bx

		cmp patterntype,1
		je solidfl
		mov ax,offset PatternLine
		cmp trflag,1
		jne no_tr_patt
		mov ax,offset GlassLine
no_tr_patt:
		mov FillLine,ax
		mov es,videoselector
		mov ah,backcolor
		mov al,fillcolor
		lds si,fillpatternptr
		mov bx,si
		mov PatternOfs,bx

		mov cx,XOtop
		and cl,7
		jz no_shiftpat
		mov ch,8
next_patbyte:
		rol byte ptr [si],cl
		inc si
		dec ch
		jnz next_patbyte
		sub si,8
no_shiftpat:
		mov cx,YOtop
		and cx,7
		add si,cx
		add bx,8
next_rowbarp:
		mov cx,cntbyte
		call FillLine
		inc si
		cmp si,bx
		jne no_endpat
		mov si,PatternOfs
no_endpat:
		add di,IncNextLine
		dec cntrows
		jnz next_rowbarp

		mov si,PatternOfs
		mov cx,XOtop
		and cl,7
		jz no_shiftpat1
		mov ch,8
next_patbyte1:
		ror byte ptr [si],cl
		inc si
		dec ch
		jnz next_patbyte1
no_shiftpat1:
		jmp barinvis
solidfl:
		mov ax,offset FastFillLine
		mov FillLine,ax
		cmp writemode,0			; NormalPut
		je norm_put
		mov ax,offset NoNormFillLine
		mov FillLine,ax
norm_put:
		mov al,fillcolor
		mov ah,al
		mov bx,IncNextLine
		mov si,cntbyte
next_rowbar:
		mov cx,si
		call FillLine
		add di,bx
		dec cntrows
		jnz next_rowbar
barinvis:
		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
Bar	  	endp

; fill line solid color (fastest)
FastFillLine	proc near
		shr cx,1
		rep stosw
		jnc short skip_byte1
		stosb
skip_byte1:
		ret
FastFillLine	endp

	; fill line solid color with XOR,OR,AND write mode

NoNormFillLine	proc near
		shr cx,1
		jcxz chk_byte
		jc odd_cntbyte
ChangePut6:
next_word:
		xor es:[di],ax
		add di,2
		loop next_word
		ret
odd_cntbyte:
ChangePut7:
		xor es:[di],ax
		add di,2
		loop odd_cntbyte
chk_byte:
ChangePut8:
		xor es:[di],al
		inc di
		ret
NoNormFillLine	endp

PatternLine	proc near
		mov dh,[si]
next_point:
		rol dh,1
		jc fill_col
		mov es:[di],ah
		inc di
		loop next_point
		ret
fill_col:
		mov es:[di],al
		inc di
		loop next_point
		ret
PatternLine	endp

GlassLine	proc near
		mov dh,[si]
gnext_point:
		rol dh,1
		jc gfill_col
		inc di
		loop next_point
		ret
gfill_col:
		mov es:[di],al
		inc di
		loop gnext_point
		ret
GlassLine	endp

HeaderLength	EQU 10

iX1		EQU word ptr[bp+6]
iY1		EQU word ptr[bp+8]
iX2		EQU word ptr[bp+10]
iY2		EQU word ptr[bp+12]

ImageSize	proc far
		push bp
		mov bp,sp

		mov ax,iX2
		sub ax,iX1
		inc ax
		mov dx,iY2
		sub dx,iY1
		inc dx
		mul dx
		add ax,HeaderLength
		adc dx,0
		; DX,AX - required number of bytes

		pop bp
		ret
ImageSize	endp

; Name: GetImage
;
; Caller: GetImage(X1,Y1,X2,Y2:integer;buffer:pointer);

IX1		EQU word ptr [bp+6]
IY1		EQU word ptr [bp+8]
IX2		EQU word ptr [bp+10]
IY2		EQU word ptr [bp+12]
buffer  	EQU dword ptr [bp+14]

real_len1	EQU word ptr [bp-4]
screen_len1 	EQU word ptr [bp-6]
cntline		EQU word ptr [bp-8]

GetImage   proc far
		push bp
		mov bp,sp
		sub sp,8
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,IY1
		mov bx,IX1
		call PixelAddr	; es:di -> Point address
		mov si,di

		les di,buffer
		mov word ptr es:[di+0],0
		mov word ptr es:[di+2],0
		mov word ptr es:[di+8],0

		mov ax,IY2
		sub ax,IY1
		mov es:[di+6],ax
		inc ax
		mov cntline,ax

		mov ax,IX2
		sub ax,IX1
		mov es:[di+4],ax
		inc ax
		mov real_len1,ax
		mov bx,BytesPerLine
		sub bx,ax
		add di,HeaderLength
		cld
		mov ds,VideoSelector
copy_nextrow:
		mov cx,real_len1
		shr cx,1
		rep movsw
		rcl cl,1
		rep movsb
		add si,bx
		dec cntline
		jnz copy_nextrow

		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
GetImage   endp

;
; Show and clipping picture (from buffer)
;

DataBuffer 	EQU dword ptr [bp+10]
YO		EQU word ptr [bp+8]
XO		EQU word ptr [bp+6]

BPL		EQU word ptr [bp-24]
Width_picture	EQU word ptr [bp-26]

PutImage	proc far
		push bp
		mov bp,sp
		sub sp,26	; vars from bar
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax

		mov ax,bytesperline
		mov BPL,ax

		les si,DataBuffer
		mov ax,es:[si+4]	; x2
		sub ax,es:[si]		; x1
		inc ax
		mov Width_picture,ax
		mov cx,ax
		mov dx,es:[si+6]	; y2
		sub dx,es:[si+2]	; y1
		inc dx
		mov si,YO
		mov di,XO

		call far ptr ClipRectArea
		js iminvis

		mov ax,YOtop
		mov bx,XOtop
		call PixelAddr

		mov ax,end_line
		sub ax,begin_line
		inc ax
		mov cntrows,ax

		lds si,DataBuffer
		mov ax,end_bit
		sub ax,begin_bit
		mov cntbyte,ax
		inc ax
		sub Width_picture,ax
		mov bx,BPL
		sub bx,ax
		cmp begin_line,0
		je imno_search_line
		mul begin_line
imno_search_line:
		add si,begin_bit
		add si,HeaderLength
next_rowbarpi:
		mov cx,cntbyte
		shr cx,1
		rep movsw
		adc cl,1
		rep movsb
		add di,bx
		add si,Width_picture
		dec cntrows
		jnz next_rowbarpi
iminvis:
		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
PutImage	endp

;
;
;
;
RowPtr		EQU dword ptr [bp+6]
XO		EQU word ptr [bp+10]
YO		EQU word ptr [bp+12]
Xcounter	EQU word ptr [bp+14]	; (X2 - X1 + 1)

PutRow		proc far
		push bp
		mov bp,sp
		sub sp,24
		push ds
		push si
		push di

		mov ax,SEG graphdata
		mov ds,ax

		mov si,YO
		mov di,XO
		mov cx,Xcounter
		mov dx,1
		call far ptr ClipRectArea
		js short InvisRow

		mov ax,YOtop
		mov bx,XOtop
		call PixelAddr

		mov ax,end_bit
		sub ax,begin_bit
		inc ax

		lds si,RowPtr
		add si,begin_bit
		mov cx,ax
		shr cx,1
		rep movsw
		adc cl,0
		rep movsb
InvisRow:
		pop di
		pop si
		pop ds
		mov sp,bp
		pop bp
		ret
PutRow		endp

;
;
;
;

sizeonerow	EQU word ptr [bp+14]
Ymmin		EQU word ptr [bp+12]
YmmaxminusYmmin EQU word ptr [bp+10]
CurrOffset	EQU word ptr [bp+8]
SegXarray	EQU word ptr [bp+6]

XOtop		EQU word ptr [bp-2]
YOtop		EQU word ptr [bp-4]
CountX		EQU byte ptr [bp-6]
PolyFillLine	EQU word ptr [bp-8]
OfsBlmask	EQU word ptr [bp-10]
ControlMaskpl	EQU word ptr [bp-12]
Pattptr		EQU dword ptr [bp-16]
PatternEndOfs	EQU word ptr [bp-18]
PatternOfs	EQU word ptr [bp-20]
BPL		EQU word ptr [bp-22]

DrawPolygon	proc far
		push bp
		mov bp,sp
		sub sp,22
		push ds
		push di
		push si

		mov ax,SEG graphdata
		mov ds,ax
		mov dx,bytesperline
		mov BPL,dx

		xor bx,bx	; x = 0
		mov ax,Ymmin
		mov YOtop,ax
		call PixelAddr
		mov Ymmin,di

		cmp patterntype,1
		jne patt_fill
		jmp dpsolidfl
patt_fill:
		mov ax,offset PatternLine
		cmp trflag,1
		jne dpno_tr_patt
		mov ax,offset GlassLine
dpno_tr_patt:
		mov PolyFillLine,ax

		mov ax,word ptr fillpatternptr[2]
		mov word ptr Pattptr[2],ax
		mov ax,word ptr fillpatternptr
		mov PatternOfs,ax
		mov bx,YOtop
		and bx,7
		add bx,ax
		mov word ptr Pattptr,bx
		add ax,8
		mov PatternEndOfs,ax

		mov al,fillcolor
		mov ah,backcolor
		mov ds,SegXarray
nextfillLinep:
		mov bx,CurrOffset
		mov cl,[bx]
		shr cl,1		; div 2 pair X - coord
		mov countX,cl
		or cl,cl
		jz no_putlinep
next_lineinrowp:
		mov di,Ymmin
		mov si,[bx+1]		;X1
		or si,si
		js no_putpairp
		add di,si
		mov cx,[bx+3]		; X2
		sub cx,si
		inc cx
		push ds
		mov dx,cx
		mov cx,si
		and cl,7
		lds si,Pattptr
		rol byte ptr [si],cl
		xchg cx,dx
		call PolyFillLine
		mov cl,dl
		ror byte ptr [si],cl
		pop ds
no_putpairp:
		add bx,4
		dec CountX
		jnz next_lineinrowp
no_putlinep:
		mov cx,word ptr Pattptr
		inc cx
		cmp cx,PatternEndOfs
		jne no_endpatp
		mov cx,PatternOfs
no_endpatp:
		mov word ptr Pattptr,cx

		mov cx,BPL
		add Ymmin,cx
		mov si,sizeonerow
		add CurrOffset,si
		dec YmmaxminusYmmin
		jnz nextfillLinep

		jmp short end_drawpoly
dpsolidfl:
		mov ax,offset FastFillLine
		mov PolyFillLine,ax
		cmp writemode,0		;NormalPut
		je norm_putpl
		mov ax,offset NoNormFillLine
		mov PolyFillLine,ax
norm_putpl:
		mov al,fillcolor
		mov ah,al
		mov ds,SegXarray
nextfillLine:
		mov bx,CurrOffset
		mov cl,[bx]
		shr cl,1		; div 2 pair X - coord
		mov countX,cl
		or cl,cl
		jz no_putline
next_lineinrow:
		mov di,Ymmin
		mov si,[bx+1]		;X1
		or si,si
		js no_putpair
		add di,si
		mov cx,[bx+3]		; X2
		sub cx,si
		inc cx
		call PolyFillLine
no_putpair:
		add bx,4
		dec CountX
		jnz next_lineinrow
no_putline:
		mov cx,BPL
		add Ymmin,cx
		mov si,sizeonerow
		add CurrOffset,si
		dec YmmaxminusYmmin
		jnz nextfillLine
end_drawpoly:
		pop si
		pop di
		pop ds
		mov sp,bp
		pop bp
		ret
DrawPolygon	endp

; call : eax = Y
;	 ebx = X
;
; returned : es:di -> Point address
;

PixelAddr	proc near
		mov es,VideoSelector
		xchg ah,al	; Y*256
		add bx,ax	; X + Y * 256
		shr ax,2	; Y*256/4
		add bx,ax	; X + (Y * 256 + Y*256/4) = "X + Y*320"
		mov di,bx	; DI = offset pixel
		ret
PixelAddr	endp
end