/* This sample program demonstrates use of OverlapString, */
/* an external procedure from Prog5_1.ASM.                */

#pragma -ml

#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include "graph.h"

extern char FontColor;
extern "C" void DispalyString(int x, int y, void* str_ptr,
		      void* font_ptr, int char_height, int char_width);

/* Pointer to character table */
void *fontptr;
int char_height;

void bold_string(int x, int y, void* str_ptr,
		      void* font_ptr, int char_height, int char_width);
void shadow_string(int x, int y, void* str_ptr,
		      void* font_ptr, int char_height, int char_width);
void engrave_string(int x, int y, void* str_ptr,
		      void* font_ptr, int char_height, int char_width);
void main(void)
{
if (graphinit() < 0) exit(0);
asm {
	push si
	mov ax,0
	mov es,ax
	mov si,0x43*4  // Vector 43h - pointer to the current BIOS font
	mov ax,es:[si]
	mov word ptr fontptr[0],ax
	mov ax,es:[si+2]
	mov word ptr fontptr[2],ax
	mov ax,0x40
	mov es,ax
	mov ax,es:[0x85]  // 0040:0085 - character height
	mov char_height,ax
	pop si
}
setfillstyle(SOLID_FILL,CYAN);
bar(0,0,getmaxx(),getmaxy());

DispalyString(100,100,"Hi, folks, I am a raster font!",fontptr,char_height,8);
bold_string(100,120,  "Getting bolder.",fontptr,char_height,8);
shadow_string(100,140,"Just me and my shadow...",fontptr,char_height,8);
FontColor = BLUE;
engrave_string(100,160,"Sir Crouchback, Esq.",fontptr,char_height,8);
if (getch() == 0) getch();
closegraph();
}

void bold_string(int x, int y, void* str_ptr,
		      void* font_ptr, int char_height, int char_width) {
DispalyString(x,y,str_ptr,font_ptr,char_height,char_width);
DispalyString(x+1,y,str_ptr,font_ptr,char_height,char_width);
}

void shadow_string(int x, int y, void* str_ptr,
		      void* font_ptr, int char_height, int char_width) {
char tmp;
tmp = FontColor;
FontColor = 0;
DispalyString(x+1,y+1,str_ptr,font_ptr,char_height,char_width);
FontColor = tmp;
DispalyString(x,y,str_ptr,font_ptr,char_height,char_width);
}

void engrave_string(int x, int y, void* str_ptr,
		      void* font_ptr, int char_height, int char_width) {
char tmp;
tmp = FontColor;
FontColor = 7;
DispalyString(x+1,y+1,str_ptr,font_ptr,char_height,char_width);
FontColor = tmp;
DispalyString(x,y,str_ptr,font_ptr,char_height,char_width);
}
