; This is a demo program for ExpAsm Chapter 13
; which loads overlay OVL.OVL (.EXE format)
; and executes them.

dosseg
.model small
.stack 200h
.data
	prog_name db 'ovl.ovl',0
	Ovr_str	dw 2 dup (0)
	entrypoint dw 0,0
	buffer dw 14 dup (0)
	tmp dw 0,0
.code
.286
Start:
		mov  ax,@data
		mov  ds,ax		; Load data segment
		call Init		; Resize program memory block
		jnc  Init_OK
		jmp  error_exit		; Exit on error
Init_OK:
		mov dx,offset prog_name
		mov ax,3d00h
		int 21h			; open overlay file
		jc error_exit

		mov bx,ax
		mov dx,offset buffer
		mov cx,28		; CX = size of .EXE file header
		mov ah,3fh
		int 21h			; read .EXE file header
		jc error_exit

		cmp ax,28
		jne error_exit

		cmp buffer,'ZM'
		jne error_exit		; check 'MZ' signature

		xor cx,cx
		mov dx,cx
		mov al,2
		mov ah,42h		; ssek to end of file
		int 21h			; get file size (DX:AX)
		jc error_exit

		push ax
		mov ah,3eh
		int 21h			; close overlay file
		pop ax
		jc error_exit

		mov cx,buffer+8		; get .EXE header size (in paragr.)
		mov bx,cx
		shl cx,4		
		shr bx,12		; BX:CX = header size (in bytes)

		sub ax,cx
		sbb dx,bx		; DX:AX = file_size - header_size

		add ax,15
		adc dx,0
		shr ax,4
		shl dx,12
		or ax,dx		; AX = size of program image (in parag.)

		mov bx,ax
		mov ah,48h
		int 21h			; allocat memory for overlay
		jc error_exit

		mov Ovr_str,ax		; fill up LoadOverlay structure
		mov Ovr_str+2,ax

		mov entrypoint+2,ax

					; load overlay 
		mov ax,4b03h
		mov dx,offset prog_name	; DS:DX -> program name
		mov cx,ds
		mov es,cx
		mov bx,offset Ovr_str	; ES:BX -> LoadOverlay structure
		int 21h			; Load
		jc error_exit		; CF = 1 if error

		; execute overlay
		call dword ptr entrypoint

		mov ah,49h
		mov es,Ovr_str
		int 21h			; free block allocated for overlay
		jc error_exit		; CF = 1 if error
		mov al,0
error_exit:
		mov ah,4ch
		int 21h			; exit

Init            proc
; Input:  ax=ds, es=PSP segment, SS:SP as set by DOS
; Output: SS:SP adjusted, CF=0 if resize is successful
;
		mov bx,ss
		sub bx,ax
		shl bx,4
		cli
		mov ss,ax		; Load stack pointer
		add sp,bx
		sti

		mov bx,sp
		add bx,15		; Round up to next paragraph
		shr bx,4
		add ax,bx		; AX = SS + SP / 16 = segment address
					; of the end of the program space
		mov bx,es
		sub ax,bx		; AX = required ammount of paragraphs
		mov bx,ax
		mov ah,4ah
		int 21h			; Resize program
		ret
Init            endp
end Start
