; Macros and structures for the expanded memory manager
; EMS API
;  Written by  Kiselev J. CZ 1994.


map_and_call_str struc
	target_offset dw 0
	target_segment dw 0
	new_page_map_len db 0
	new_page_map_ofs dw 0
	new_page_map_seg dw 0
	old_page_map_len db 0
	old_page_map_ofs dw 0
	old_page_map_seg dw 0
	reserved dw 4 dup (0)
map_and_call_str ends

log2phys_map	struc
	log_page dw 0
	phys_page dw 0
log2phys_map	ends

exp_mem_move	struc
	ems_counter dd 0
	source_mem_type db 0
	source_handle dw 0
	source_init_ofs dw 0
	source_init_seg_page dw 0
	dest_mem_type db 0
	dest_handle dw 0
	dest_init_ofs dw 0
	dest_init_seg_page dw 0
exp_mem_move	ends

; ZF = 1 if EMM present
EMM_install_check macro
		mov ah,35h	; Inst check
		mov al,67h
		int 21h
		mov di,10
		mov si,offset EMM_dev_name
		mov cx,4
		rep cmpsw
endm

; AL = version number
; ZF = 1 if OK
Get_EMM_version	macro
		mov ah,46h
		int 67h
		or ah,ah
endm

; DX = total number of pages
; BX = total ext mem (in KB)
; ZF = 1 if OK
EMM_get_free_exp_mem macro
		mov ah,42h
		int 67h
		shl bx,4		; *16
		or ah,ah
endm

; caller: BX = number of logical pages(16 KB)
;
; DX = handle
; ZF = 1 if OK
EMM_alloc_exp_mem macro pages
		mov bx,pages
		mov ah,43h
		int 67h
		or ah,ah
endm

; caller: DX = handle
;
; ZF = 1 if OK
EMM_free_exp_mem macro handle
		mov dx,handle
		mov ah,45h
		int 67h
		or ah,ah
endm

; BX = page frame segment
Get_EMM_pageframe macro
		mov ah,41h
		int 67h
		or ah,ah
endm

EMM_map_page macro phys_page,log_page,handle
		mov ah,44h
		mov dx,handle
		mov al,phys_page
		mov bx,log_page
		int 67h
		or ah,ah
endm

EMM_map_and_call macro handle,offs_map_and_call_str
		mov ah,56h
		mov dx,handle
		mov si,offset offs_map_and_call_str
		int 67h
		or ah,ah
endm
