; Macros and structures for the XMS driver
; XMS API
;  Written by  Kiselev J. CZ 1994.

ext_mem_move struc
	xms_counter dd 0
	xms_source_handle dw 0
	offset_source dd 0
	xms_dest_handle dw 0
	offset_dest dd 0
ext_mem_move	ends

; XMS installation check
; ZF = 1 if OK
XMS_install_check macro
		mov ax,4300h		; AX = 4300h
		int 2fh			; Installation check
		cmp al,80h		; AL = 80 if XMS drv is present
endm

; ES:BX points to driver entry point
Get_XMS_drv_address macro
		mov ax,4310h		; AX = 4310h
		int 2fh			; Get XMS driver address
endm

; AX = XMS version (in BCD)
; BX = internal revision number
; DX =  1 if HMA exist
;	0 if not
Get_XMS_version	macro
		xor ax,ax		; AH = 0
		call xms_call		; Get XMS version number
endm

; AX = size of largest ext mem block
; DX = total ext mem (in KB)
XMS_get_free_ext_mem macro
		mov ah,8		; AH = 8
		call xms_call		; Get free extended memory
endm

; caller: DX = Kbytes needed
;
; DX = handle
; ZF = 1 if OK
XMS_alloc_ext_mem macro block_size
		mov dx,block_size
		mov ah,9 		; AH = 9
		call xms_call		; allocate ext mem block
		dec ax
endm

; caller: DX = handle
;
; ZF = 1 if OK
XMS_free_ext_mem macro handle
		mov dx,handle
		mov ah,10		; AH = 10
		call xms_call		; free ext mem block
		dec ax
endm

; caller: DX = handle
;	  BX = new size
;
; DX = handle
; ZF = 1 if OK
XMS_resize_ext_mem macro handle,new_size
		mov dx,handle
		mov bx,new_size
		mov ah,15
		call xms_call		; allocate ext mem block
		dec ax
endm

