; The protected mode kernel
; (Chapter 16 Assembly Language Master Class)
; Written by Y. Kiselev

; Hardware interrupt emulator

server_data32 segment para public use32
tick	dd 0
in_flag	db FALSE
server_data32 ends

IRQNUM	macro i
		sub esp,12
		mov byte ptr [esp+10],TRUE	; hard_int flag = TRUE
		mov byte ptr [esp+8],i		; int_number
		jmp hardware_int
endm

server_code32 segment para public use32

IRQ8 :
		push ds

		push data32_sel
		pop ds

		cmp in_flag,TRUE
		je nost

		inc tick
		cmp tick,9
		jne nost

		mov tick,0

		mov in_flag,TRUE
		call refresh_statistic
		mov in_flag,FALSE

nost:
		pop ds
		IRQNUM 8
comment #
		push ds
		push eax
		push ebx
		str ax                  ; current TSS selector
		sub ax,8                ; alias TSS selector
		mov ds,eax
		xor ebx,ebx

		cli
		mov eax,36			; adjust PL0 stack within TSS
		test dword ptr [esp+8+12],VMflag; int 8 occur in V86 mode ?
		jnz adjpl0
		mov al,12
		test byte ptr [esp+4+12],3
		jz adjpl0
		mov al,20
adjpl0:
		add [ebx].tss_str.esp_0,eax

		pop ebx
		pop eax
		pop ds
		iretd
		#
IRQ9 :
		push eax
		in al,60h
		cmp al,53h       	; DEL key
		jnz no_reboot
		push ds
		mov eax,flat_sel
		mov ds,eax
		mov al,ds:[417h]	; get shift status
		pop ds
		test al,8		; check for Cntl/Alt
		jz no_reboot
		test al,4
		jz no_reboot

		; call ask_for_reboot

		in al,61h
		mov ah,al
		or al,80h
		out 61h,al
		mov al,ah
		out 61h,al

		mov al,EOI
		out MASTER8259A,al	;send EOI to master 8259A controller
		pop eax
		iretd
no_reboot:
		pop eax

		IRQNUM 9

IRQA : IRQNUM 0ah
IRQB : IRQNUM 0bh
IRQC : IRQNUM 0ch
IRQD : IRQNUM 0dh
IRQE : IRQNUM 0eh
IRQF : IRQNUM 0fh

IRQ70 : IRQNUM 70h
IRQ71 : IRQNUM 71h
IRQ72 : IRQNUM 72h
IRQ73 : IRQNUM 73h
IRQ74 : IRQNUM 74h
IRQ75 : IRQNUM 75h
IRQ76 : IRQNUM 76h
IRQ77 : IRQNUM 77h


comment #
dummy_iret0	proc near
; Default interrupt handler for first 8 h/w interrupts
		push eax
		mov al,EOI
		out MASTER8259A,al	;send EOI to master 8259A controller
		pop eax
		iretd
dummy_iret0	endp

dummy_iret1	proc near
		push eax
		mov al,EOI
		out MASTER8259A,al		;send EOI to both master & slave 8259A
		out SLAVE8259A,al
		pop eax
		iretd
dummy_iret1	endp 
#
server_code32 ends
