; This module contains bin2ascii convert routines
; for debug and error messages
;
; Written by Y Kiselev.

server_code32 segment para public use32
;convert byte bin2hex
;AL = 8 bit value to convert
; ds:[ebx+esi] <- string
; si point to the end of line
PutHexByte	proc near
		mov ah,al
		shr al,4
		add al,'0'	;convert high half byte
		cmp al,'9'
		jbe _0_9
		add al,'A'-'9'-1
_0_9:
		mov [ebx+esi],al
		inc esi
		and ah,0fh
		add ah,'0'
		cmp ah,'9'
		jbe __0_9;convert low half byte
		add ah,'A'-'9'-1
__0_9:
		mov [ebx+esi],ah
		inc esi
		ret
PutHexByte	endp

;covert word bin2hex
;AX = 16 bit value to convert
PutHexWord	proc near
		push eax
		mov al,ah
		call PutHexByte
		pop eax
		call PutHexByte
		ret
PutHexWord	endp

;covert dword bin2hex
;EAX = 32 bit value to convert
PutHexDWord	proc near
		push eax
		shr eax,16
		call PutHexWord
		pop eax
		call PutHexWord
		ret
PutHexDWord	endp

;Binary to ASCII conversion routine
;EAX = 32 bit value to convert
PutDecDword	proc near
		push ebx
		add esi,ebx
		mov ebx,10
		xor ecx,ecx
next_digitd:
		xor edx,edx
		div ebx		;convert to decimal digits
		push edx
		inc ecx
		or eax,eax
		jnz next_digitd
putnext_digitd:
		pop eax
		add al,'0'	;to get ASCII code
		mov [esi],al
		inc esi
		dec ecx
		jnz putnext_digitd
		pop ebx
		sub esi,ebx
		ret
PutDecDword	endp
server_code32 ends