//Program 17.1
/* This program produces a dump of the files pointed to in    *
* the command string. You can point to more than one file.    *
* To save information in a text file, the command line should *
* have the following format: DUMP file1 file2 ... >out_file   *
* This means that you want to redirect output from the screen *
* to the file OUT_FILE                                        */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void do_dump(char *f_name)
{
	FILE *f=fopen(f_name,"rb");
	long offs=0;
	unsigned char buf[20];
	char string[200];

	printf("File: %s\n\n",f_name);
	printf("Address                 Hexadecimal                              Characters\n\n");
	for(;;)
	{
		int i=fread(buf,1,16,f); //Try to read 16 bytes from the input file
		if(!i) break;  //if EOF - return
		char s[20];
//Point to the offset of the first byte in the string
		sprintf(string,"%08X   ",offs);
//Hexadecimal representation
		for(int j=0;j<16;j++)
		{
			if(j<i)
				sprintf(s,"%02X ",buf[j]);
			else
				sprintf(s,"   ");
			strcat(string,s);
		}
		strcat(string,"   ");
//Character representation
		for(j=0;j<16;j++)
		{
			if(j<i)
				sprintf(s,"%c",(buf[j]>=0x20)?buf[j]:'.');
			else
				sprintf(s," ");
			strcat(string,s);
		}
		printf("%s\n",string);
		offs+=i; //Increase offset
	}
	fclose(f);
	printf("\n\n\n");
}


void main(int argc,char *argv[])
{
	if(argc<2)
	{
		puts("Format: DUMP file_name1 file_name2 ...");
		exit(1);
	}
	for(int i=1;i<argc;i++)
	{
		do_dump(argv[i]);
	}
}
