//Program 17.3
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <conio.h>

int Susp_Count=0;       //Counter of suspicious files

void TestExe(char *);

void TestCom(char *fname)
{
	FILE *f=fopen(fname,"rb");
	unsigned char buf[10];  //buffer for reading bytes
	unsigned offs;
	
	if(!f) return;
	fread(buf,1,3,f);
	if((*buf=='M')&&(*(buf+1)=='Z'))
	{
//MZ signature was found, it is EXE file
		fclose(f);
		TestExe(fname);
		return;
	}
	if(*buf!=0xe9) return; //Not jump
//JMP was found, compute offset
	memcpy(&offs,buf+1,2);
	fseek(f,offs,SEEK_CUR);
	fread(buf,1,3,f);
	if((*buf==0xe8)&&(!*(buf+1))&&(!*(buf+2)))
	{
//File Fname is suspicious!
		cprintf("%c - File is suspicious. Check it!\n",7);
		Susp_Count++;
	}
	fclose(f);
}

void TestExe(char *fname)
{
	FILE *f=fopen(fname,"rb");
	unsigned char buf[100]; //buffer for reading bytes
	unsigned hdr_size;
	unsigned ReloCS,ExeIP;
	
	if(!f) return;
	fread(buf,1,0x18,f);
	if((*buf!='M')||(*(buf+1)!='Z'))
	{
//MZ signature was not found, it is COM file
		fclose(f);
		TestCom(fname);
		return;
	}
//Compute header size
	memcpy(&hdr_size,buf+0x8,2);
//Compute ReloCS and ExeIP
	memcpy(&ReloCS,buf+0x16,2);     
	memcpy(&ExeIP,buf+0x14,2);
	fseek(f,(long)hdr_size*16L+(long)ReloCS*16L+(long)ExeIP,SEEK_SET);
	fread(buf,1,3,f);
	if((*buf==0xe8)&&(!*(buf+1))&&(!*(buf+2)))
	{
//File Fname is suspicious!
		cprintf("- %cFile is suspicious. Check it!\n",7);
		Susp_Count++;
	}
	fclose(f);      
}


void Find_All(char *path)
{
	struct ffblk buffer; //structure for the findfirst/findnext functions
	int res;
	char temp[81];
	
	strcpy(temp,path);
	strcat(temp,"*.*");
	res=findfirst(temp,&buffer,FA_DIREC);
	while(!res)
	{
		if(buffer.ff_attrib&FA_DIREC&&buffer.ff_name[0]!='.')
		{
			strcpy(temp,path);
			strcat(temp,buffer.ff_name);
			strcat(temp,"\\");
			Find_All(temp);
		}
		res=findnext(&buffer);
	}
	
	strcpy(temp,path);
	strcat(temp,"*.COM");
	res=findfirst(temp,&buffer,0xff);
	while(!res)
	{
		if(!(buffer.ff_attrib&FA_DIREC))
		{
			strcpy(temp,path);
			strcat(temp,buffer.ff_name);
			gotoxy(1,wherey());
			clreol();
			cprintf("%s",temp);
			TestCom(temp);
		}
		res=findnext(&buffer);
	}
	
	strcpy(temp,path);
	strcat(temp,"*.EXE");
	res=findfirst(temp,&buffer,0xff);
	while(!res)
	{
		if(!(buffer.ff_attrib&FA_DIREC))
		{
			strcpy(temp,path);
			strcat(temp,buffer.ff_name);
			gotoxy(1,wherey());
			clreol();
			cprintf("%s",temp);                     
			TestExe(temp);
		}
		res=findnext(&buffer);
	}
}


void main(int argc, char *argv[])
{
	char path[81];

	if(argc<2)
	{
		printf("Illegal format. Use: %s drive_1 drive_2 ....\n",argv[0]);
		exit(1);
	}       
	for(int i=1;i<argc;i++)
	{
//Call the procedure which finds all executable files on the disk
//and tests them.
		sprintf(path,"%c:\\",*argv[i]);
		Find_All(path);
	}
	printf("\n\nSummary: suspicious files number: %d\n",Susp_Count);
}
