//Simple Revisor program 17.6. This program checks the files in the
//database.
//We will get the information about the position of the database file from
//the environment variable REV_DBS=<path>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <dir.h>
#include <string.h>
#include <conio.h>

//Structure of the database file
struct DATABASE
			{
				char fname[80]; //File name
				unsigned head_len; //Length of the checked part
				unsigned char first512[512]; //Buffer for the checked part
				unsigned long length; //File length
			} database;
			
char dbs_name[80]; //Name of the database file for this session
FILE *dat_file;

void main(int argc, char *argv[])
{
	int i;
	ffblk buf;
	
	char drive[5],dir[80],name[12],ext[4];

	if(argc<2)
	{
		printf("Illegal format. Use: %s <key> [file_list]\n",argv[0]);
		printf("Where <key> is:\n");
		printf("A - add new file(s) to the database\n");
		printf("C - check files which were placed in the database\n");
		exit(1);
	}       
	if(getenv("REV_DBS")) //Try to find the REV_DBS string in the environment
	{
		strcpy(dbs_name,getenv("REV_DBS"));
		if(dbs_name[strlen(dbs_name)-1]!='\\')
			strcat(dbs_name,"\\");
	}       
	else *dbs_name=0;
	strcat(dbs_name,"REVISOR.DAT");
	dat_file=fopen(dbs_name,"a+b"); //Open the database file
	if(*argv[1]=='a'||*argv[1]=='A') //Add operation was pointed to
	{
		for(i=2;i<argc;i++) //Do this for all files pointed to in the command line
		{
			int res=findfirst(argv[i],&buf,0xffff);
			while(!res)
			{
				fnsplit(argv[i],drive,dir,name,ext);
				if(!*dir) getcwd(dir,79);
				fnmerge(database.fname,drive,dir,buf.ff_name,"");
				FILE *f=fopen(database.fname,"rb");
				if(f) //File was opened normally
				{
					//Read the saving part
					database.head_len=fread(database.first512,1,512,f);
					fseek(f,0,SEEK_END);
					database.length=ftell(f);
					fclose(f);
					//Write the file information to the database
					fwrite(&database,1,sizeof(database),dat_file);
					printf("File %s has been written to the database.\n",
															database.fname);
				}
				else
					printf("Cannot open file %s\n",database.fname);
				res=findnext(&buf);
			}
		}
	}
	else if(*argv[1]=='c'||*argv[1]=='C') //Check operation was pointed to
	{
		for(;;)
		{
			//Read next structure from the database
			int res=fread(&database,1,sizeof(database),dat_file);
			//If it was the last one - exit
			if(res<sizeof(database)) break;
			printf("File %s is checking. ",database.fname);
			FILE *f1=fopen(database.fname,"rb");
			unsigned char buffer[512];
			fread(buffer,1,database.head_len,f1);
			fseek(f1,0,SEEK_END);
			//Compare the saved part and the existing one.
			//Also check the file length
			if(memcmp(buffer,database.first512,database.head_len)||
				ftell(f1)!=database.length)
			{
				printf("%cFile has been changed!\n",7);
			}
			else
				printf("\n");
			fclose(f1);     
		}
	}
	fclose(dat_file);
}
