#include <stdlib.h>
#include <conio.h>
#include <string.h>

#include "common.h"
#include "mand_set.h"
#include "grfile.h"
#include "formats.h"
#include "keymouse.h"
#include "set_stuf.h"

#define MOUSE_SENSITIVITY 1


void show_clip_area(RECT win){
	setwritemode(XOR_PUT);
	setcolor(255);
	rectangle(win.a.x,win.a.y,win.b.x,win.b.y);
	line(win.a.x,win.a.y,win.b.x,win.b.y);
	line(win.a.x,win.b.y,win.b.x,win.a.y);
	setwritemode(NORMAL_PUT);
}

void show_point(pointtype p){
	setwritemode(XOR_PUT);
	setcolor(255);
	line(p.x - 10,p.y,p.x + 10,p.y);
	line(p.x ,p.y - 10,p.x,p.y + 10);
	setwritemode(NORMAL_PUT);
}

void adjust_clip_area(RECT &win, RECT restrictions){
	win.a.x = max(restrictions.a.x,min(win.a.x,restrictions.b.x-1));
	win.a.y = max(restrictions.a.y,min(win.a.y,restrictions.b.y-1));
	win.b.x = max(win.a.x+1, min(win.b.x,restrictions.b.x));
	win.b.y = max(win.a.y+1, min(win.b.y,restrictions.b.y));
}

void adjust_point(pointtype &p, RECT restrictions){
	p.x = max(restrictions.a.x,min(p.x,restrictions.b.x));
	p.y = max(restrictions.a.y,min(p.y,restrictions.b.y));
}

WORD clip_area(RECT &win, RECT restrictions) {
	WORD key;
	int d_mousex, d_mousey;
	BOOL  fin = FALSE, shft;

	adjust_clip_area(win, restrictions);
	show_clip_area(win);

	do {
	     setmousepos( getmaxx()/2, getmaxy()/2);
	     d_mousex = d_mousey = 0;

	     while ((!kbhit()) && (d_mousex == 0) && (d_mousey == 0)) {
			d_mousex = (mousex - getmaxx()/2)/MOUSE_SENSITIVITY;
			d_mousey = (mousey - getmaxy()/2)/MOUSE_SENSITIVITY;
			}

	     shft = keyboardstatus() & 3; // was shift pressed?
	     show_clip_area(win); // hide old

	     if (kbhit()) {
		key = readkeyword();
		if (shft)  // resize window
		   switch (key) {
		    case kwLeft:
		    case kwShiftLeft:  win.b.x--; break;

		    case kwRight:
		    case kwShiftRight: win.b.x++; break;

		    case kwUp:
		    case kwShiftUp:    win.b.y--; break;

		    case kwDown:
		    case kwShiftDown:  win.b.y++; break;

		    case kwHome:
		    case kwShiftHome:  win.b.x--; win.b.y--; break;

		    case kwEnd:
		    case kwShiftEnd:   win.b.x--; win.b.y++; break;

		    case kwPgUp:
		    case kwShiftPgUp:   win.b.x++; win.b.y--; break;


		    case kwPgDn:
		    case kwShiftPgDn:  win.b.x++; win.b.y++; break;
		    }
	      else
		   switch (key) {
		    case kwLeft:
		    case kwShiftLeft: win.a.x--; win.b.x--; break; // NumLock may cause kwShiftLeft

		    case kwRight:
		    case kwShiftRight: win.a.x++; win.b.x++; break;

		    case kwUp:
		    case kwShiftUp:  win.a.y--;  win.b.y--; break;

		    case kwDown:
		    case kwShiftDown: win.a.y++; win.b.y++; break;

		    case kwHome:
		    case kwShiftHome:  win.b.x--; win.b.y--;
				  win.a.x--; win.a.y--;
				  break;

		    case kwEnd:
		    case kwShiftEnd: win.b.x--; win.b.y++;
				win.a.x--; win.a.y++;
				break;

		    case kwPgUp:
		    case kwShiftPgUp:  win.a.x++; win.a.y--;
				win.b.x++; win.b.y--;
				break;


		    case kwPgDn:
		    case kwShiftPgDn:  win.a.x++; win.a.y++;
				win.b.x++; win.b.y++;
				break;
		    }

		switch (key) {
		    case kwEnter:
		    case kwEsc:
		    case kwBkSp:
		    case kwAltX:
		    case kwAltA:
		    case kwF2:
		    case kwF3:
		    case kwF4:
		    case kwF5:
		    case kwAltS:   fin = TRUE;
		}
	     }
	     else { // not kbhit, mouse moved
		if (shft || (buttons & 1)) {//resize
			 win.b.x += d_mousex;
			 win.b.y += d_mousey;
		 }
		 else {
			 win.a.x += d_mousex;
			 win.a.y += d_mousey;
			 win.b.x += d_mousex;
			 win.b.y += d_mousey;
		 }
	     }

	     if (!fin) {
			adjust_clip_area(win, restrictions);
			show_clip_area(win);
			}
	}
	while (!fin);
	return(key);
}

WORD select_point(pointtype &p, RECT restrictions) {
	WORD key;
	int d_mousex, d_mousey;
	BOOL  fin = FALSE, shft;

	adjust_point(p, restrictions);
	show_point(p);

	do {
	     setmousepos( getmaxx()/2, getmaxy()/2);
	     d_mousex = d_mousey = 0;

	     while ((!kbhit()) && (d_mousex == 0) && (d_mousey == 0)) {
			d_mousex = (mousex - getmaxx()/2)/MOUSE_SENSITIVITY;
			d_mousey = (mousey - getmaxy()/2)/MOUSE_SENSITIVITY;
			}

	     show_point(p); // hide old

	     if (kbhit()) {
		key = readkeyword();
		switch (key) {
		    case kwLeft:
		    case kwShiftLeft: p.x--; break; // NumLock may cause kwShiftLeft

		    case kwRight:
		    case kwShiftRight: p.x++; break;

		    case kwUp:
		    case kwShiftUp:  p.y--;   break;

		    case kwDown:
		    case kwShiftDown: p.y++;  break;

		    case kwHome:
		    case kwShiftHome:   p.x--; p.y--; break;

		    case kwEnd:
		    case kwShiftEnd: p.x--; p.y++;break;

		    case kwPgUp:
		    case kwShiftPgUp:  p.x++; p.y--; break;


		    case kwPgDn:
		    case kwShiftPgDn:  p.x++; p.y++; break;
		    }

		switch (key) {
		    case kwEnter:
		    case kwAltX:
		    case kwEsc:       fin = TRUE;
		}
	     }
	     else { // not kbhit, mouse moved
			 p.x += d_mousex;
			 p.y += d_mousey;
	     }

	     if (!fin) {
			adjust_point(p, restrictions);
			show_point(p);
			}
	}
	while (!fin);
	return(key);
}

BOOL write_descr(char *fname, mset_descr descr) {
	FILE *the_file;
	memcpy(descr.signature,"Mand",4);
	the_file = fopen(fname, "r+b");
	if (the_file == NULL) return(FALSE);
	fseek(the_file, 0, SEEK_END);
	fwrite(&descr,sizeof(mset_descr),1,the_file);
	fclose(the_file);
	return(TRUE);
}

BOOL read_descr(char *fname, mset_descr *descr) {
	FILE *the_file;
	the_file = fopen(fname, "rb");
	if (the_file == NULL) return(FALSE);
	fseek(the_file, -4, SEEK_END);
	fread(descr->signature,4,1,the_file);
	if (memcmp(descr->signature,"Mand",4) != 0) return(FALSE);

	fseek(the_file, -(long)sizeof(mset_descr), SEEK_END);
	fread(descr,sizeof(mset_descr),1,the_file);
	fclose(the_file);
	return(TRUE);
}


void init_keeper(mandelbrot_set	 *ms, BGRpalette pal) {
	image_keeper *keeper;

	ms->set_keeper(NULL); // free memory before
	keeper =  new image_keeper(UNKNOWN, // force_file,
			COLOR256IMG,
			ms ->screen_x,
			ms ->screen_y,
			pal,
			TRUE );  // top_to_bottom

	ms->set_keeper(keeper);
}

void save_file (mandelbrot_set	 *ms, BGRpalette *pal, char *outfilename) {
	graph_file_saver *grf_s;
	BYTE *tmp;
	mset_descr descr;
	int i;
	if ((!ms->calculated) || (ms->keeper == NULL)) return;
	grf_s = new targa_file_saver(outfilename,
		COLOR256IMG,NO_EXTENTION,
		ms ->screen_x,	ms ->screen_y,
		pal, TRUE, //compress
		TRUE,  TRUE); //top-to-bottom, left-to-right
	if ((grf_s == NULL) || (!grf_s->file_ok)) return;
	for (i = 0; i < ms ->keeper ->height; i++) {
		tmp = ms ->keeper -> give_line(grf_s -> line_n);
		grf_s->put_stand_line(tmp);
		}
	delete grf_s;

	descr.set_type = ms -> my_type();
	descr.x_min = ms ->x_min;
	descr.x_max = ms ->x_max;
	descr.y_max = ms ->y_max;
	descr.y_min = ms ->y_min;
	descr.screen_x = ms ->screen_x;
	descr.screen_y = ms ->screen_y;
	ms ->give_c(descr.c_re,descr.c_im);
	write_descr(outfilename, descr);
}

