; This is a demo program for Expasm Chapter 'Pentium'
; This program implement low level routines
; convolution, median, and rank filtering methods,
; optimized for Pentium.
; This module is a bad choice to demonstrate Pentium-aware
; optimization, because the low-level loops contain many commands
; that cause AGI and register contension and not enough instructions
; (and registers in x86) to schedule everything.

; Written by Y. Kiselev in Autumn 1994

.model large

public _box_row
public _med_row
public _rank_row

.code
.386
.387

;
;void _box_row(int Xsize,void* SourcePtr, void *DestPtr, int fxsize,
;		  int fysize, void *FilterPtr, float Koeff);
;

Xsize		EQU word ptr [bp+6]
SourcePtr	EQU dword ptr [bp+8]
DestPtr		EQU dword ptr [bp+12]
fXsize		EQU word ptr [bp+16]
fYsize		EQU word ptr [bp+18]
FilterPtr	EQU dword ptr [bp+20]
Koeff		EQU dword ptr [bp+24]

next_col	EQU word ptr [bp-4]
tmp_value	EQU word ptr [bp-8]
tmp_val2	EQU word ptr [bp-12]

_box_row	proc far
		push bp
		mov bp,sp
		sub sp,14

		push ds
		push si
		push di

		xor ax,ax
		lgs bx,SourcePtr
		mov ds,gs:[bx+2]
		mov es,word ptr FilterPtr[2]
		mov fs,word ptr DestPtr[2]

		mov next_col,ax
		mov tmp_value,ax
next_byte:
		mov di,word ptr FilterPtr[0]
		mov bx,word ptr SourcePtr[0]
		mov ch,byte ptr fYsize
		mov ah,byte ptr fXsize
		fldz
next_row:
		mov si,gs:[bx]
		add bx,4
		add si,next_col
		mov cl,ah
next_column:
		mov al,[si]
		inc si
		mov byte ptr tmp_value,al
		fild tmp_value
		fmul dword ptr es:[di]
		add di,4
		dec cl
		faddp st(1),st(0)
		jnz next_column

		dec ch
		jnz next_row

		fmul Koeff
		mov si,word ptr DestPtr[0]
		inc next_col
		fistp tmp_val2
		mov ax,tmp_val2
		inc word ptr DestPtr[0]
		cmp ax,255
		jle short l255
		mov ax,255
l255:
		or ax,ax
		jns short ok_
		mov al,0
ok_:
		dec Xsize
		mov fs:[si],al

		jnz next_byte

		pop di
		pop si
		pop ds
		mov sp,bp
		pop bp
		ret
_box_row	endp

;
;void _med_row1(int Xsize,void* SourcePtr, void *DestPtr, int fxsize,
;		  int fysize, int filtsize, WORD sort_array_offset);
;

Xsize		EQU word ptr [bp+6]
SourcePtr	EQU dword ptr [bp+8]
DestPtr		EQU dword ptr [bp+12]
fXsize		EQU word ptr [bp+16]
fYsize		EQU word ptr [bp+18]
filtsize	EQU word ptr [bp+20]
sort_array	EQU word ptr [bp+22]

next_col	EQU word ptr [bp-2]
tmp		EQU word ptr [bp-4]

_med_row	proc far
		push bp
		mov bp,sp
		sub sp,4

		push ds
		push si
		push di
		cld

		xor cx,cx
		lgs bx,SourcePtr
		mov ax,gs:[bx+2]
		mov es,ax
		mov ds,ax
		xor ax,ax
		mov fs,word ptr DestPtr[2]
		mov next_col,ax

		mov di,sort_array
		mov bx,word ptr SourcePtr[0]
		mov al,byte ptr fYsize
		mov ah,byte ptr fXsize
next_row1:
		mov si,gs:[bx]
		add bx,4
		add si,next_col
		mov cl,ah
		rep movsb

		dec al
		jnz next_row1

		; sorting
		mov dx,filtsize
		dec dx
loop1:
		mov si,sort_array
		mov cx,dx
loop2:
		mov al,[si]
		cmp [si+1],al
		jae short cont
		xchg al,[si+1]
		mov [si],al
cont:
		inc si
		dec cx
		jnz loop2
		dec dx
		jnz loop1

		mov ax,fXsize
		dec ax
		add next_col,ax
		jmp short go
next_byte1:
		; delete subcolumn
		mov ax,next_col
		mov dx,filtsize
		sub ax,fXsize
		mov bx,word ptr SourcePtr[0]
		mov tmp,ax
		mov ah,byte ptr fYsize
next_row2:
		mov si,gs:[bx]
		add bx,4
		add si,tmp
		mov di,sort_array

		mov al,[si]
		mov cx,dx
		repne scasb
		mov si,di
		dec di
		rep movsb

		dec dx
		dec ah
		jnz next_row2

		; add subcolumn
		mov bx,word ptr SourcePtr[0]
		mov ah,byte ptr fYsize
next_row3:
		mov si,gs:[bx]
		add bx,4
		add si,next_col
		mov di,sort_array

		mov cx,dx
		mov al,[si]
next_b:
		cmp al,[di]
		jb short l1
		inc di
		dec cx
		jnz next_b

		mov [di-1],al
		inc dx
		dec ah
		jnz next_row3
		jmp short go
l1:
		add di,cx
		std
		mov si,di
		inc dx
		dec si
		rep movsb
		cld
		mov [di],al
		dec ah
		jnz next_row3
go:
		mov bx,filtsize
		inc next_col
		shr bx,1
		mov si,word ptr DestPtr[0]
		add bx,sort_array
		inc word ptr DestPtr[0]
		mov al,[bx]

		dec Xsize
		mov fs:[si],al
		jnz next_byte1

		pop di
		pop si
		pop ds
		mov sp,bp
		pop bp
		ret
_med_row	endp

;
;void _rank_row(int Xsize,void* SourcePtr, void *DestPtr, int fxsize,
;		  int fysize, int filtsize, WORD hist_array_offset,
;		  float div_filtr_sq);
;

Xsize		EQU word ptr [bp+6]
SourcePtr	EQU dword ptr [bp+8]
DestPtr		EQU dword ptr [bp+12]
fXsize		EQU word ptr [bp+16]
fYsize		EQU word ptr [bp+18]
filtsize	EQU word ptr [bp+20]
hist_offset	EQU word ptr [bp+22]
div_filtr_sq	EQU dword ptr [bp+24]

next_col	EQU word ptr [bp-2]
filt_center	EQU word ptr [bp-4]
tmp		EQU dword ptr [bp-8]

_rank_row	proc far
		push bp
		mov bp,sp
		sub sp,8

		push ds
		push si
		push di

		cld
		xor cx,cx
		lgs bx,SourcePtr
		mov ax,gs:[bx+2]
		mov ds,ax
		mov es,ax
		xor eax,eax
		mov fs,word ptr DestPtr[2]
		mov next_col,ax

		mov cx,128
		mov di,hist_offset
		rep stosd		; clear histogram

		mov si,word ptr SourcePtr[0]
		mov ax,fYsize
		mov bx,si
		shr ax,1
		shl ax,2
		add si,ax
		mov cx,fXsize
		mov ax,gs:[si]
		shr cx,1
		add ax,cx
		mov filt_center,ax

		mov ch,byte ptr fYsize
		mov dh,byte ptr fXsize
next_row4:
		mov si,gs:[bx]
		add bx,4
		mov cl,dh
next_byte2:
		movzx di,byte ptr [si]
		shl di,1
		add di,hist_offset
		inc si
		inc word ptr [di]
		dec cl
		jnz next_byte2

		dec ch
		jnz next_row4

		mov ax,fXsize
		dec ax
		add next_col,ax
		jmp short go1
next_byte3:
		mov bx,word ptr SourcePtr[0]
		mov dx,next_col
		mov cl,byte ptr fYsize
		sub dx,fXsize
		xor ax,ax
next_byte4:
		mov si,gs:[bx]
		add bx,4
		add si,dx

		movzx di,byte ptr [si]
		shl di,1
		add di,hist_offset

		dec word ptr [di]
		dec cl
		jnz next_byte4

		mov cl,byte ptr fYsize
		sub bx,4
next_byte5:
		mov si,gs:[bx]
		sub bx,4
		add si,next_col

		movzx di,byte ptr [si]
		shl di,1
		add di,hist_offset
		inc word ptr [di]
		dec cl
		jnz next_byte5
go1:
		mov si,filt_center
		movzx ax,byte ptr [si]
		inc si
		mov di,hist_offset
		mov cx,ax
		shl ax,1
		add di,ax
		xor eax,eax
		mov filt_center,si
		mov ax,[di]
		sub di,2
		shr ax,1
add_prevbyte:
		add ax,[di]
		sub di,2
		dec cx
		jnz add_prevbyte

		mov ebx,eax
		shl eax,8
		sub eax,ebx
		mov bx,filtsize
		shr bx,1
		add eax,ebx
		mov si,word ptr DestPtr[0]
		mov tmp,eax
		fild tmp
		fmul div_filtr_sq
		inc next_col
		inc word ptr DestPtr[0]
		fistp tmp
		mov al,byte ptr tmp

		dec Xsize
		mov fs:[si],al
		jnz next_byte3

		pop di
		pop si
		pop ds
		mov sp,bp
		pop bp
		ret
_rank_row	endp
end
