; This is a demo program for Expasm Chapter 'Pentium'.
; Low-level routines for matrix multiplication

; Written by Y. Kiselev in Autumn 1994

.model large
.386
.387
public _mult_matrix	; 486 optimized
public _mult_matrixp	; Pentium light
public _mult_matrixp1	; Pentium full force

.code

M1		EQU dword ptr [bp+6]
M2		EQU dword ptr [bp+10]
OffsetM2	EQU word ptr [bp+10]
Mres		EQU dword ptr [bp+14]

_mult_matrix	proc far
		push bp
		mov bp,sp
		push ds
		push si
		push di

		les di,M1
		lds si,M2
		lgs bx,Mres

		mov al,4
next_row:
		mov si,OffsetM2
		mov ah,4
next_item:
		fld dword ptr es:[di]
		fmul dword ptr [si]
		fld dword ptr es:[di+4]
		fmul dword ptr [si+4*4]
		fld dword ptr es:[di+2*4]
		fmul dword ptr [si+8*4]
		fld dword ptr es:[di+3*4]
		fmul dword ptr [si+12*4]
		faddp st(1),st
		faddp st(1),st
		faddp st(1),st
		fstp dword ptr gs:[bx-4]   ; result(i,j)

		add si,4
		add bx,4
		dec ah
		jnz next_item
		add di,16
		dec al
		jnz next_row

		pop di
		pop si
		pop ds
		pop bp
		ret
_mult_matrix	endp

_mult_matrixp	proc far
		push bp
		mov bp,sp
		push ds
		push si
		push di

		les di,M1
		lds si,M2
		lgs bx,Mres

		mov al,4
next_row1:
		mov si,OffsetM2
		mov ah,4
next_item1:
		fld dword ptr es:[di]
		fmul dword ptr [si]
		fld dword ptr es:[di+4]
		fmul dword ptr [si+4*4]
		fld dword ptr es:[di+2*4]
		fmul dword ptr [si+8*4]
		fxch st(2)
		faddp st(1),st
		fld dword ptr es:[di+3*4]
		fmul dword ptr [si+12*4]
		fxch st(2)
		faddp st(1),st
		add si,4
		add bx,4
		faddp st(1),st
		fstp dword ptr gs:[bx-4]   ; result(i,j)

		dec ah
		jnz next_item1
		add di,16
		dec al
		jnz next_row1

		pop di
		pop si
		pop ds
		pop bp
		ret
_mult_matrixp	endp

_mult_matrixp1	proc far
		push bp
		mov bp,sp
		push ds
		push si
		push di

		les di,M1
		lds si,M2
		lgs bx,Mres

		mov al,4
next_row2:
		;------ 0 row
		fld dword ptr es:[di]
		fmul dword ptr [si]
		fld dword ptr es:[di+4]
		fmul dword ptr [si+4*4]
		fld dword ptr es:[di+8]
		fmul dword ptr [si+8*4]
		fxch st(2)
		faddp st(1),st
		fld dword ptr es:[di+12]
		fmul dword ptr [si+12*4]
		fxch st(2)
		faddp st(1),st
		;----- 1 row
		fld dword ptr es:[di]
		fmul dword ptr [si+4]
		fxch st(2)
		faddp st(1),st
		fld dword ptr es:[di+4]
		fmul dword ptr [si+4*4+4]
		fxch st(1)
		fstp dword ptr gs:[bx]   ; result(1,j)
		fld dword ptr es:[di+8]
		fmul dword ptr [si+8*4+4]
		fxch st(2)
		faddp st(1),st
		fld dword ptr es:[di+12]
		fmul dword ptr [si+12*4+4]
		fxch st(2)
		faddp st(1),st
		;----- 2 row
		fld dword ptr es:[di]
		fmul dword ptr [si+8]
		fxch st(2)
		faddp st(1),st
		fld dword ptr es:[di+4]
		fmul dword ptr [si+4*4+8]
		fxch st(1)
		fstp dword ptr gs:[bx+4]   ; result(2,j)
		fld dword ptr es:[di+8]
		fmul dword ptr [si+8*4+8]
		fxch st(2)
		faddp st(1),st
		fld dword ptr es:[di+12]
		fmul dword ptr [si+12*4+8]
		fxch st(2)
		faddp st(1),st
		;----- 3 row
		fld dword ptr es:[di]
		fmul dword ptr [si+12]
		fxch st(2)
		faddp st(1),st
		fld dword ptr es:[di+4]
		fmul dword ptr [si+4*4+12]
		fxch st(1)
		fstp dword ptr gs:[bx+8]   ; result(2,j)
		fld dword ptr es:[di+8]
		fmul dword ptr [si+8*4+12]
		fxch st(2)
		faddp st(1),st
		fld dword ptr es:[di+12]
		fmul dword ptr [si+12*4+12]
		fxch st(2)
		faddp st(1),st
		faddp st(1),st
		add bx,16
		add di,16
		dec al
		fstp dword ptr gs:[bx-4]   ; result(2,j)
		jnz next_row2

		pop di
		pop si
		pop ds
		pop bp
		ret
_mult_matrixp1	endp
end