; This is a template test program that provides the necessary
; framework to test performance of your low-level loops.
; Look for the place to fill in down in this file.
;
; Written by Y. Kiselev 1994

.model small
.stack 100h

; New Pentium+ commands :
; if eax = 0 then result in eax,edx,ecx,ebx
; if eax = 1 then result in eax,edx
cpuid	macro
	db 0fh,0a2h
endm

; undocumented commands :
; read stamp counter
rdtsc	macro
	db 0fh,31h
endm
; read model specific register
; ecx = MSR for read
rdmsr	macro
	db 0fh,32h
endm

; write model specific register
; ecx = MSR for write
wrmsr	macro
	db 0fh,30h
endm

.data
	old_time dd 0
		 dd 0
	mess1 db 'Press any key for start test.',10,13,'$'
	prot_mess db 'processor must be in real mode.','$'
.code
.386P
.387
		mov ax,@data
		mov ds,ax
		cli
		mov ss,ax
		mov sp,offset stack
		sti

		call CheckProcessor
		cmp al,5
		jb prog_exit
		mov eax,cr0
		test al,1
		jz short no_prot_mode
		lea dx,prot_mess
		mov ah,9
		int 21h
		jmp prog_exit
no_prot_mode:
		mov dx,offset mess1
		mov ah,9
		int 21h

		mov ah,0
		int 16h
		finit

		rdtsc
		mov old_time,eax
		mov old_time[4],edx
		mov ecx,10000

mm1:
		; ...
		; Put your code in here to test performance.
		; ...

		dec cx
		jnz mm1


		rdtsc
		sub eax,old_time
		sbb edx,old_time[4]
		;mov ecx,60000		; for 60MHz P5,  in ms
		;div ecx
		xor bx,bx
		call PutDecDWord

		mov ah,0
		int 16h
prog_exit:
		mov ah,4ch
		int 21h

; Return in AL processor type
; AL = 0..N (0 - 86,1 - 186,2 - 286,3 - 386,4 - 486,...)
CheckProcessor	proc
		mov ax,0ffffh
		mov cl,42h
		shr ax,cl
		test ax,3fffh
		jnz chk186
		mov al,0
		ret
chk186:
		push sp
		pop bx
		cmp bx,sp
		je chk286
		inc al
		ret
chk286:
		mov bx,7000h
		push bx
		popf
		pushf
		pop bx
		and bh,70h
		jnz chk386
		inc al
		ret
chk386:
		mov bx,sp		;Intel original text
		and sp,not 3
		pushfd
		pop eax
		mov ecx,eax
		xor eax,40000h
		push eax
		popfd
		pushfd
		pop eax
		mov sp,bx
		xor eax,ecx
		jnz chk486
		mov al,3	;386
		ret
chk486:
		mov bx,sp
		and sp,not 3
		pushfd
		pop eax
		mov ecx,eax
		xor eax,200000h
		push eax
		popfd
		pushfd
		pop eax
		push ecx
		popfd
		mov sp,bx
		xor eax,ecx
		jnz chkP5
		mov al,4
		ret
chkP5:
		mov eax,1
		cpuid
		and ax,0f00h
		shr ax,8
		ret
CheckProcessor	endp

;Binary to ASCII conversion routine
;EAX = 32 bit value to convert
PutDecDword	proc
		mov ebx,10
		xor cx,cx
next_digitd:
		xor edx,edx
		div ebx		;convert to decimal digits
		push dx
		inc cx
		or eax,eax
		jnz next_digitd
		mov ah,2
putnext_digitd:
		pop dx
		add dl,'0'	;to get ASCII code
		int 21h
		inc si
		loop putnext_digitd
		ret
PutDecDword	endp
end