name key_get_flags_enhanced
;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================

.model small

.code

public key_get_flags_enhanced
key_get_flags_enhanced proc
;--------------------------------------
; Get keyboard flags for enhanced keyboard
;
; inputs: none
;
; outputs: AL    7    bits     0
;               Ŀ
;               
;                        right shift key
;                       left shift key
;                      either control key
;                     either alt key
;                    scroll lock on
;                   num lock on
;                  caps lock on
;                 insert on
;
;          AH    7    bits     0
;               Ŀ
;               
;                        left ctrl key
;                       left alt key
;                      right ctrl key
;                     right alt key
;                    scroll key
;                   num lock
;                  caps lock
;                 sys req
;
; Notes: the 4 high bits of AL toggle on and off
;        all other bits are set when key is down
;--------------------------------------

           mov    ah, 12h              ; read keyboard flags, enhanced
           int    16h                  ; BIOS keyboard
           ret

key_get_flags_enhanced endp
end
