name key_get_key_or_mouse
;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================

.model small

EXTRN key_read_char         : proc
EXTRN key_get_status        : proc
EXTRN mouse_exists          : proc
EXTRN mouse_read_pos_status : proc

.code

public key_get_key_or_mouse
key_get_key_or_mouse proc
;--------------------------------------
; Wait for keystroke or mouse click
;
; outputs: BL col
;          BH row
;            or
;          BX = -1 if a keystroke
;          AX ASCII code and scan code
;--------------------------------------

           push   cx
           push   dx
           xor    bx, bx

; check for mouse existance

           call   mouse_exists
           jnc    km_5

; wait for mouse state where all buttons are up (prevent key bounce)
km_1:
           call   mouse_read_pos_status
           or     bx, bx
           jnz    km_1

; get a key or a mouse click
km_2:
           call   key_get_status
           jne    km_5
           call   mouse_read_pos_status
           or     bx, bx               ; if no mouse click
           jz     km_2                 ;  loop back

; convert mouse position to row/col

           mov    ax, 3
           xchg   ax, cx
           shr    ax, cl
           shr    dx, cl
           mov    bl, al
           mov    bh, dl
km_ret:
           pop    dx
           pop    cx
           ret

; no mouse (wait for a key) or a key was pressed so read it
km_5:
           call   key_read_char
           mov    bx, -1               ; flag for a keystroke
           jmp    km_ret

key_get_key_or_mouse endp

end
