name key_test_enhanced
;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================

.model small

.code

public key_test_enhanced
key_test_enhanced proc
;--------------------------------------
; Test for a BIOS that supports the enhanced (101-key) keyboard
; (this routine flushes the keyboard buffer first)
;
; inputs: none
;
; outputs: ZF set if enhanced keyboard BIOS supported
;--------------------------------------

           push   ax
           push   cx

; flush keyboard buffer
kt_1:
           mov    ah, 1
           int    16h
           jz     kt_2
           mov    ah, 0
           int    16h
           jmp    kt_1

; load dummy char/scan code into keyboard buffer
kt_2:
           mov    cx, -1
           mov    ax, 502h
           int    16h
           or     al, al
           jnz    kt_ret

; test for the dummy char showing up
; (older keyboard BIOS routines do not pass -1 through)

           mov    ah, 10h              ; read the char, check for the dummy one
           int    16h
           cmp    ax, -1
kt_ret:
           pop    cx
           pop    ax
           ret

key_test_enhanced endp
end
