;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation
;
;====================================================================
; QWL Library Macros
;====================================================================

;--------------------------------------
; Macros for Mouse compatibility
;
; conditional assembly based on no_mouse_code will
; null out all the mouse code in the SCR, WIN and CUR
;--------------------------------------

mouse_off MACRO       ; hide the mouse (called before a screen update)
 ifndef no_mouse_code
  call scr_mouse_hide
 endif
ENDM

mouse_on MACRO        ; unhide the mouse (called after a screen update)
 ifndef no_mouse_code
  call scr_mouse_unhide
 endif
ENDM

mouse_externals MACRO   ; declare external mouse procs
 ifndef no_mouse_code
  EXTRN scr_mouse_hide   : proc
  EXTRN scr_mouse_unhide : proc
 endif
ENDM


;--------------------------------------
; Macros for cursor control
;--------------------------------------

cursor_pos MACRO line, col             ; MACRO to set cursor position
 IFNB <line>
  mov dx, ((line)*256) + col
 ENDIF
  xor  bh, bh
  mov  ah, 2
  push bp
  int  10h
  pop  bp
ENDM

cursor_type MACRO first, last          ; MACRO to set cursor type
 IFNB <first>
  mov  cx, ((first)*256) + last
 ENDIF
  xor  bh, bh
  mov  ah, 1
  push bp
  int  10h
  pop  bp
ENDM
