;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Shrink memory allocation
;====================================================================

.model small

.code

public mem_shrink
mem_shrink proc
;--------------------------------------
; Shrink memory allocated to minimum
; (MUST be called before changing ES)
;
; This utility meant for use in standard memory model programs
;
; inputs: ES    PSP segment
;         SS    stack segment (MUST be last)
;         SP    assumed to be near the top of the stack segment
;
;--------------------------------------

           mov    ax, ss
           mov    bx, sp
           mov    cl, 4
           shr    bx, cl
           add    bx, 3                ; roundoff + safety for top of stack
           add    bx, ax               ; ending segment of program

           mov    ax, es               ; PSP segment
           sub    bx, ax               ; size of program in para

           push   es                   ; check current size
           mov    ax, es
           dec    ax
           mov    es, ax
           cmp    ES:[3], bx
           pop    es
           jbe    sm_1

           mov    ah, 4ah              ; change size of memory block
           int    21h
sm_1:
           ret

mem_shrink endp
end
