;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Convert byte to hex ASCII
;====================================================================

.model small

.code

public num_hex8
num_hex8 proc
;--------------------------------------
; Convert a byte to hex ASCII
;
; inputs: DS:DI dest buffer
;         AL    byte to convert
;
; outputs: DS:DI ptr to string
;          CX    len of string(2)
;--------------------------------------

           push   bx
           push   di

           mov    bx, ax
           and    al, 0f0h             ; get high nibble
           mov    cl, 4                ; shift down
           shr    al, cl
           call   put_hex              ; put 1 hex digit
           inc    di
           mov    al, bl               ; repeat for low nibble
           and    al, 0fh
           call   put_hex
           mov    cx, 2

           pop    di
           pop    bx
           ret

num_hex8 endp

put_hex proc near
;--------------------------------------
; Insert a hex digit
;
; inputs: DS:DI dest buffer
;         AL value
;
; outputs: hex digit at DS:DI
;--------------------------------------

           add    al, '0'
           cmp    al, '9'
           jle    ph_1
           add    al, 7                ; add 7 for A - F
ph_1:
           mov    [di], al
           ret

put_hex endp
end
