;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================

.model small

.code

public num_random_word
num_random_word proc
;--------------------------------------
; Generate the next random number
;
; inputs: none
;
; outputs: AX  generated random number
;--------------------------------------

        push    dx
        push    ds

        mov     ax, @data
        mov     ds, ax

        mov     ax, num_rnd_val
        mul     num_rnd_mult
        inc     ax
        mov     num_rnd_val, ax

        pop     ds
        pop     dx

        ret

num_random_word endp

public num_random_word_init
num_random_word_init proc
;--------------------------------------
; Set the random number generator initial value
;
; inputs: AX init value (if 0 use clock tick)
;
; outputs: initial value stored
;--------------------------------------

        push    ds
        or      ax, ax
        jnz     nr_1

        mov     ax, 40h
        mov     ds, ax
        mov     ax, DS:[6ch]           ; get low timer tick word
        add     ax, DS:[6eh]           ; add high timer tick word

nr_1:
        push    ax
        mov     ax, @data
        mov     ds, ax
        pop     ax
        mov     num_rnd_val, ax

        pop     ds
        ret

num_random_word_init endp


.data

num_rnd_val  dw 12345           ; arbitrary seed value
num_rnd_mult dw 9421            ; multiplier (X)

end
