;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================

.model small

.code

public num_uword
num_uword proc
;--------------------------------------
; Convert unsigned word to ascii, any base
;
; inputs:  AX    word
;          DS:DI address for string
;          BX    base (must be 2 - 36; no error checking)
;
; outputs: string at DS:DI
;          CX length
;--------------------------------------

           push   ax
           push   dx
           push   di
           push   si
           push   es
           pushf

           push   ds                   ; ES = DS for stosb
           pop    es

           mov    si, di               ; save starting ptr
           cld
wta_1:
           xor    dx, dx
           div    bx
           xchg   ax, dx
           add    al, '0'              ; convert to decimal digit
           cmp    al, '9'
           jbe    wta_2
           add    al, 7                ; adjust to alpha for base 11 and above
wta_2:
           stosb
           mov    ax, dx
           or     ax, ax               ; if zero then done
           jnz    wta_1

           stosb                       ; terminate with a null

; reverse byte order

           mov    cx, di
           sub    cx, si
           dec    cx

           push   cx
           lea    di, [si-1]
           add    di, cx               ; DI = SI + CX - 1 (last byte)
           shr    cx, 1                ; count to reverse
           jz     wta_4                ; done if only 1 byte
wta_3:
           lodsb                       ; xchg front and back bytes
           xchg   al, [di]             ;  while moving towards center
           mov    [si-1], al
           dec    di
           loop   wta_3
wta_4:
           pop    cx

           popf
           pop    es
           pop    si
           pop    di
           pop    dx
           pop    ax
           ret

num_uword endp
end
