;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Display String on Screen
;====================================================================

.model small

EXTRN scr_get_strlen        : proc
EXTRN scr_set_attributes    : proc
EXTRN scr_offset            : proc
EXTRN scr_display_line_text : proc

.data

EXTRN scr_video_seg : word

.code

public scr_display_string
scr_display_string proc
;--------------------------------------
; Display string with constant attributes
;
; inputs: DS:SI  string for screen
;         CX     len of string (if 0, then it ends with null)
;         AL     0 default attributes
;                1 atrributes in AH
;                2  existing attr
;         AH     attributes
;         BH     row
;         BL     col
;--------------------------------------

           push   ax
           push   bx
           push   cx
           push   dx
           push   di
           push   si
           push   ds
           push   es

           call   scr_get_strlen       ; get len if CX = 0
           jz     dstr_ret             ; return if zero len string
           call   scr_set_attributes

           push   ax
           call   scr_offset
           mov    di, ax
           pop    ax
           mov    es, scr_video_seg
           call   scr_display_line_text
dstr_ret:
           pop    es
           pop    ds
           pop    si
           pop    di
           pop    dx
           pop    cx
           pop    bx
           pop    ax
           ret

scr_display_string endp
end
