;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Screen fill
;====================================================================

.model small

include libmac.inc

EXTRN scr_offset           : proc
EXTRN scr_set_attributes   : proc
mouse_externals

.data

EXTRN scr_video_seg : word


.code

public scr_fill_screen
scr_fill_screen proc
;--------------------------------------
; Fill screen area with constant char and attributes
;
; inputs: DL     char
;         CX     len of string
;         AL     0  default attributes
;                1  atrributes in AH
;                2  existing attr
;         AH     attributes
;         BH     row
;         BL     col
;
;--------------------------------------

           push   ax
           push   bx
           push   cx
           push   dx
           push   di
           push   si
           push   es
           pushf

           jcxz   sf_exit

           call   scr_set_attributes

           push   ax
           call   scr_offset
           mov    di, ax
           pop    ax
           mov    es, scr_video_seg

           mouse_off

           xchg   al, dl
           cld
           cmp    dl, 2                ; check for using existing attr
           je     sf_3
           rep    stosw
sf_ret:
           mouse_on
sf_exit:
           popf
           pop    es
           pop    si
           pop    di
           pop    dx
           pop    cx
           pop    bx
           pop    ax
           ret

sf_3:
           stosb
           inc    di
           loop   sf_3
           jmp    sf_ret

scr_fill_screen endp
end
