;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Screen init
;====================================================================

.model small

include libstruc.inc
include libmac.inc
include libequ.inc

EXTRN scr_get_max_col    : proc
EXTRN scr_get_max_row    : proc
EXTRN scr_get_video_type : proc
EXTRN scr_update_row_col : proc

.data

public scr_display_type, scr_video_wait, scr_mono_flag
public scr_video_seg,    scr_max_col,    scr_max_row, scr_max_size

scr_display_type  db 0
scr_video_wait    db 0
scr_mono_flag     db 0

scr_video_seg     dw 0
scr_max_col       dw 0
scr_max_row       dw 0
scr_max_size      dw 0

.code

public scr_init
scr_init proc
;--------------------------------------
; Screen Library system initialization routine
;
; inputs: none
;
; outputs: CF  set if error
;          AL  0 if ok, else error code
;--------------------------------------

           push   bx
           push   ds

; must do auto setup

           call   scr_get_video_type   ; returns AL= type
           mov    scr_display_type, al

           mov    bx, 0b000h           ; mono segment
           cmp    al, video_mono
           je     dbi_1
           mov    bx, 0b800h           ; color segment
dbi_1:
           mov    scr_video_seg, bx

           xor    bx, bx
           mov    scr_video_wait, bl
           cmp    al, video_mono
           jne    dbi_2
           inc    bh
dbi_2:
           mov    scr_mono_flag, bh

; setup max col

           xor    bx, bx
           call   scr_update_row_col
           mov    bl, 80               ; default screen width
           mov    scr_max_col, bx

; setup max row

           xor    bx, bx
           mov    bl, 25               ; default screen height
           mov    scr_max_row, bx
           call   scr_set_max_size
           xor    ax, ax               ; no error

           pop    ds
           pop    bx
           ret

scr_init endp

public scr_set_max_size
scr_set_max_size proc
;--------------------------------------
; Set the maximum number of screen characters
;
; inputs: none
;
; output: AX max size
;
;--------------------------------------

           push   bx

           call   scr_get_max_col
           xchg   ax, bx
           call   scr_get_max_row
           mul    bl
           mov    scr_max_size, ax

           pop    bx
           ret

scr_set_max_size endp
end
