;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; String Length Routines for Screen Routines
;====================================================================

.model small

.code

public scr_get_strlen
scr_get_strlen proc near
;--------------------------------------
; Get strlen of string
; (used internally to get len when CX = 0)
;
; inputs: DS:SI string
;         CX len or 0
;
; outputs: CX len
;          ZF set if CX = 0
;--------------------------------------

           push   ax
           or     cx, cx
           jnz    gsl_1
           call   scr_str_len
           mov    cx, ax
           or     cx, cx
gsl_1:
           pop    ax
           ret

scr_get_strlen endp

public scr_str_len
scr_str_len proc
;--------------------------------------
; Len of string at DS:SI
;--------------------------------------

           push   cx
           push   di
           push   es

           push   ds
           pop    es
           mov    di, si

           call   scr_str_len_es

           pop    es
           pop    di
           pop    cx
           ret

scr_str_len  endp

public scr_str_len_es
scr_str_len_es proc
;--------------------------------------
; Len of string at ES:DI
;--------------------------------------

           push   cx
           push   di
           pushf

           mov    cx, -1      ; max str len
           xor    al, al      ; char to look for
           cld
           repne  scasb       ; repeat while ES:[DI] <> 0
           mov    ax, -2
           sub    ax, cx      ; len

           popf
           pop    di
           pop    cx
           ret

scr_str_len_es  endp

end
