;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Get Video Adapter Type
;====================================================================

.model small

include libequ.inc

.code

public scr_get_video_type
scr_get_video_type proc
;--------------------------------------
; Test for display type being used
;
; outputs: AL   1 mono
;               2 CGA
;               3 EGA
;               4 MCGA
;               5 VGA
;
;          AH   2 if EGA/VGA mono mode
;--------------------------------------

           push   bx
           push   cx
           push   dx
           push   bp

           mov    ah, 15               ; get current display mode
           int    10h
           xchg   ax, dx               ; DL = mode
           cmp    dl, 7                ; 7 is mono text mode
           jne    not_mono
gvt_1:
           mov    al, video_mono
           jmp    gvt_ret

; test for VGA
not_mono:
           mov    ax, 1A00h
           int    10h
           cmp    al, ah
           jne    not_vga
           mov    al, video_VGA
           cmp    bl, 7                ; check for VGA mono
           je     gvt_3
           jmp    gvt_ret

; test for EGA
not_vga:
           mov    bh, -1               ; illegal values
           mov    cl, bh
           mov    bl, 10h              ; request EGA info
           mov    ah, 12h
           int    10h

; test for proper return from EGA BIOS

           cmp    bh, 1                ; 0/1 for color/mono
           ja     gvt_ret
           cmp    cl, 15               ; 0 - 15 for EGA
           ja     gvt_5                ; must be CGA if above 15
           mov    al, video_EGA

; check for EGA mono mode
gvt_2:
           cmp    dl, 2                ; EGA mono mode?
           jne    gvt_ret
gvt_3:
           mov    ah, 2                ; mono mode
           jmp    gvt_ret2
gvt_ret:
           xor    ah, ah
gvt_ret2:
           pop    bp
           pop    dx
           pop    cx
           pop    bx
           ret
gvt_5:
           mov    al, video_CGA
           jmp    gvt_ret

scr_get_video_type endp
end
