;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Update screen row/col
; Get BIOS row/col
;====================================================================

.model small

.data

EXTRN scr_max_col  : word
EXTRN scr_max_row  : word

public scr_bios_seg
scr_bios_seg  dw 0

.code

public scr_update_row_col
scr_update_row_col proc
;--------------------------------------
; Get BIOS row/col and update values used by the library
;
; inputs:  DS @data
;
; outputs: AX columns
;          BX rows
;
;--------------------------------------

           call   scr_get_bios_row_col
           xor    bx, bx
           mov    bl, ah
           mov    ah, 0
           mov    scr_max_col, ax
           mov    scr_max_row, bx
           ret

scr_update_row_col endp

public scr_get_bios_row_col
scr_get_bios_row_col proc
;--------------------------------------
; Get the row and columns from BIOS data area
;
; inputs:  DS @data
;
; outputs: AL columns
;          AH rows
;
;--------------------------------------

           push   ds
           mov    ds, scr_bios_seg
           mov    al, DS:[4Ah]
           or     al, al
           jne    sgb_1
           mov    al, 80               ; default value if zero
sgb_1:
           mov    ah, DS:[84h]
           or     ah, ah
           jne    sgb_ret
           mov    ah, 24               ; default value if zero
sgb_ret:
           inc    ah                   ; BIOS stores number - 1
           pop    ds
           ret

scr_get_bios_row_col endp
end
