;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Display Window
;====================================================================

.model small

include libequ.inc

EXTRN win_xfer_buf       : proc
EXTRN win_restore_window : proc

.data

EXTRN scr_default_attr : byte

win_tmp_len     dw max_win_size
win_tmp_ptr     dd win_buf
win_buf         db max_win_size dup(0)

.code

public win_display_window
win_display_window proc
;--------------------------------------
; Display window from ASCIIZ strings (clips excess data)
;
; inputs: DS:SI buffer of ASCIIZ strings followed by null
;         AL    default ASCII char (normally 0 or 20h)
;         AH    attributes (0 = use default)
;         CL    indent amount
;         BL    left col
;         BH    top row
;         DL    width
;         DH    height
;
;
; outputs:
;--------------------------------------

           push   bx
           push   cx
           push   dx
           push   di
           push   si
           push   bp
           push   ds
           push   es
           pushf

           cmp    cl, dl               ; insure indent not too much
           jl     dw0
           xor    cl, cl
dw0:
           add    bl, cl               ; move col over
           sub    dl, cl               ; reduce width

           mov    bp, bx               ; save row/col

           cmp    al, 0                ; default char
           jne    dw1
           mov    al, ' '
dw1:
           cmp    ah, 0                ; attributes
           jne    dw2
           mov    ah, scr_default_attr
dw2:

; fill buffer with default char and attributes

           push   cx
           push   es
           mov    cx, win_tmp_len
           shr    cx, 1
           les    di, win_tmp_ptr

           cld
           rep    stosw
           pop    es
           pop    cx

           mov    cl, dh               ; height
           mov    bh, dl               ; width

; fill buffer with text

           push   dx
           xor    dx, dx               ; no left margin
           push   es
           les    di, win_tmp_ptr
           call   win_xfer_buf
           pop    es
           pop    dx

; copy tmp buffer to the screen

           mov    bx, bp
           lds    si, win_tmp_ptr
           call   win_restore_window
dw_ret:
           popf
           pop    es
           pop    ds
           pop    bp
           pop    si
           pop    di
           pop    dx
           pop    cx
           pop    bx
           ret

win_display_window endp

end
