;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Window Popup
;====================================================================

.model small

EXTRN scr_init            : proc
EXTRN scr_mouse_init      : proc
EXTRN win_get_coordinates : proc
EXTRN win_push_window     : proc
EXTRN win_display_area    : proc

.data

EXTRN scr_video_seg : word

.code

public win_popup
win_popup proc
;--------------------------------------
; Display a popup window
;
; inputs: DS:SI  window structure
;         ES:DI  buffer for screen data
;
; outputs: CF set if error
;          AL error code
;             1 window off screen
;             2 not enough buffer space
;             3 too many windows
;
;--------------------------------------

           push   bx
           push   cx
           push   dx
           push   di
           push   si
           push   bp
           push   ds
           push   es

           cmp    scr_video_seg, 0
           jnz    wp_1
           call   scr_init
           call   scr_mouse_init
wp_1:
           call   win_get_coordinates

; save screen window area

           call   win_push_window
           jc     wp_ret                   ; returns with error code

; display the window data and/or blank out the area

           xor    cx, cx
           call   win_display_area
           clc
wp_ret:
           pop    es
           pop    ds
           pop    bp
           pop    si
           pop    di
           pop    dx
           pop    cx
           pop    bx
           ret

win_popup endp
end
