;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Save window data in buffer
;====================================================================

.model small

include libstruc.inc

EXTRN win_check_coordinates : proc
EXTRN win_save_window       : proc
EXTRN cur_get_pos_type      : proc

.code

public win_push_window
win_push_window proc
;--------------------------------------
; Save window parameters and data in specified buffer
;
; inputs: BL    col
;         BH    row
;         DL    width
;         DH    height
;         DS    @data
;         ES:DI save buffer
;
; outputs: CF set if error
;             AL = 1 window off screen
;
;--------------------------------------

           push   bx
           push   cx
           push   dx
           push   di
           push   si
           push   ds

           call   win_check_coordinates
           mov    al, 1
           jc     pw_ret

           push   es
           pop    ds

; save items in buffer

           mov    si, di
           mov    [si].scr_row, bh
           mov    [si].scr_col, bl
           mov    [si].scr_width, dl
           mov    [si].scr_height, dh
           lea    di, [si].scr_cur_type+2  ; end of struct + 1
           mov    [si].scr_buffer, di
           push   dx
           call   cur_get_pos_type
           mov    [si].scr_cur_pos, dx
           mov    [si].scr_cur_type, cx
           pop    dx

; save the screen data

           call   win_save_window
           clc
pw_ret:
           pop    ds
           pop    si
           pop    di
           pop    dx
           pop    cx
           pop    bx
           ret

win_push_window endp

end
