;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Remove window from screen
;====================================================================

.model small

include libstruc.inc

EXTRN win_restore_window : proc
EXTRN cur_set_pos        : proc
EXTRN cur_set_scan       : proc

.code

public win_remove
win_remove proc
;--------------------------------------
; Remove window from the screen, restore screen data
;
; inputs: ES:DI ptr to buffer where screen data is stored
;         DS    @data
;--------------------------------------

           push   ax
           push   bx
           push   cx
           push   dx
           push   di
           push   si
           push   ds

           push   es
           pop    ds

; restore the screen

           mov    si, [di].scr_buffer
           mov    bh, [di].scr_row
           mov    bl, [di].scr_col
           mov    dl, [di].scr_width
           mov    dh, [di].scr_height
           call   win_restore_window

; restore the cursor

           mov    ax, [di].scr_cur_pos
           call   cur_set_pos
           mov    ax, [di].scr_cur_type
           call   cur_set_scan

           pop    ds
           pop    si
           pop    di
           pop    dx
           pop    cx
           pop    bx
           pop    ax
           ret

win_remove endp

end
