;====================================================================
;
; Copyright(c) 1994 Quantasm Corporation. All rights reserved.
;
; Quantasm Corporation Window Library
;
;====================================================================
; Window xfer string to/from screen or buffer
;====================================================================

.model small

.code

public win_xfer_buf
win_xfer_buf proc
;--------------------------------------
; Transfer strings to window buffer
;
; inputs:  AH    attributes
;          ES:DI dest ptr
;          DS:SI source ASCIIZ strings
;          BH    window width
;          CL    window height
;          DX    string left margin
;
;--------------------------------------

           push   bp
           xor    ch, ch
fwb1:
           mov    bl, bh               ; reset width
           or     dx, dx
           jz     fwb3

           mov    bp, dx

; scan by non-displayed portion of string
fwb2:
           lodsb                       ; read a char
           or     al, al
           jz     fwb6                 ; done with line if a null
           dec    bp
           jnz    fwb2

fwb3:
           lodsb                       ; read a char
           or     al, al
           jz     fwb6                 ;  done with line if a null
           stosb                       ; store a char
           inc    di
           dec    bl                   ; check for too many char
           jnz    fwb3
fwb4:
           lodsb                       ; scan to null (for clipped line)
           or     al, al
           jnz    fwb4
fwb6:
           push   dx
           xor    dx, dx               ; skip DI to next window line
           mov    dl, bl
           shl    dx, 1
           add    di, dx
           pop    dx
           cmp    byte ptr [si], 0     ; check for end of window text
           je     fwb7
           loop   fwb1                 ; loop for next line
fwb7:
           pop    bp
           ret

win_xfer_buf endp
end
