;======================================
; Table driven screen display using QWL
;======================================

.model small

.stack

.code

includelib qwl

extrn scr_init           : proc
extrn scr_display_string : proc
extrn scr_blank_screen   : proc
extrn mem_shrink         : proc


main proc

        mov     ax, @data
        mov     ds, ax

        call    mem_shrink

        push    ds
        pop     es

; initialize library for screen

        call    scr_init

; erase the screen

        mov     al, 7                   ; attr to erase with
        call    scr_blank_screen

; display the text

        call    display_info

; terminate program

        mov     ah, 4ch
        int     21h

main endp

display_info proc

        lea     di, disp_tbl

dsp_1:
        mov     si, [di]
        cmp     si, -1
        je      dsp_ret

        mov     bl, [di+2]
        mov     bh, [di+3]
        mov     al, 1
        mov     ah, 7
        xor     cx, cx
        call    scr_display_string

        add     di, 4
        jmp     dsp_1

dsp_ret:
        ret

display_info endp


.data

disp_tbl label byte

dw str1         ; ptr to string
 db 1,3         ; column, row
dw str2
 db 1,4
dw str3
 db 1,5
dw str4
 db 40,3
dw str5
 db 40,4
dw str6
 db 40,5

dw -1   ; end of table

str1 db 'First Name:',0
str2 db 'Last Name:',0
str3 db 'Course:',0
str4 db 'Date:',0
str5 db 'Grade:',0
str6  db 'Credits:',0

end main
