;======================================
; Table driven screen display with conversion types
;======================================

.model small

.stack

.code

includelib qwl

extrn scr_init           : proc
extrn scr_display_string : proc
extrn scr_blank_screen   : proc
extrn mem_shrink         : proc
extrn num_int_to_ascii   : proc


main proc

        mov     ax, @data
        mov     ds, ax

        call    mem_shrink

        push    ds
        pop     es

; initialize library for screen

        call    scr_init

; erase the screen

        mov     al, 7                   ; attr to erase with
        call    scr_blank_screen

; display the text

        call    display_info

; terminate program

        mov     ah, 4ch
        int     21h

main endp

display_info proc

        lea     di, disp_tbl
dsp_1:
        mov     si, [di]
        cmp     si, -1
        je      dsp_ret
        xor     bx, bx
        mov     bl, [di+4]              ; get conversion type
        add     bx, bx
        call    CS:convert[bx]          ; call conversion routine
dsp_3:
        mov     bl, [di+2]
        mov     bh, [di+3]
        mov     al, 1
        mov     ah, 7
        call    scr_display_string

        add     di, 5
        jmp     dsp_1

dsp_ret:
        ret

convert label word
dw conv_string
dw conv_num
dw conv_grade

display_info endp

conv_string proc

        xor     cx, cx
        ret

conv_string endp

conv_num proc

        push    di
        mov     ax, [si]                ; get value
        lea     di, temp_num
        call    num_int_to_ascii
        mov     si, di                  ; return ptr to string
        xor     cx, cx
        pop     di
        ret

conv_num endp

conv_grade proc
;--------------------------------------
; Convert numerical grade to letter
;--------------------------------------

        mov     al, [si]                ; get value
        lea     si, num_to_grade
cg_1:
        cmp     al, [si]
        jae     cg_2
        add     si, 3
        jmp     cg_1
cg_2:
        inc     si                      ; return pointer to string
        mov     cx, 2                   ; length of string
        ret

conv_grade endp


.data

disp_tbl label byte

dw str1         ; ptr to string
 db 1,3         ; column, row
 db 0           ; string type
dw str2
 db 1,4
 db 0
dw str3
 db 1,5
 db 0
dw str4
 db 40,3
 db 0
dw str5
 db 40,4
 db 0
dw str6
 db 40,5
 db 0

dw str1a
 db 13,3
 db 0
dw str2a
 db 13,4
 db 0
dw str3a
 db 13,5
 db 0
dw str4a
 db 50,3
 db 0
dw num5a
 db 50,4
 db 2
dw num6a
 db 50,5
 db 1

dw -1   ; end of table

str1  db 'First Name:',0
str2  db 'Last Name:',0
str3  db 'Course:',0
str4  db 'Date:',0
str5  db 'Grade:',0
str6  db 'Credits:',0

str1a db 'John',0
str2a db 'Smith',0
str3a db 'CS101',0
str4a db '01/01/95',0
num5a dw 90
num6a dw 3

temp_num db 6 dup(0)

num_to_grade label byte
db 100, 'A+'
db  90, 'A '
db  80, 'B '
db  70, 'C '
db  60, 'D '
db   0, 'F '

end main
