;======================================
; Table driven screen display with macros
;======================================

.model small

.stack

.code

includelib qwl
include libstruc.inc

extrn scr_init           : proc
extrn scr_blank_screen   : proc
extrn scr_display_string : proc
EXTRN scr_setup_attr_tbl : proc
extrn win_popup          : proc
extrn win_remove         : proc
extrn key_read_char      : proc
extrn mem_shrink         : proc
extrn num_int_to_ascii   : proc


dsp MACRO dptr, col, row, typ
 dw dptr
ifb <typ>
 db col, row, 0
else
 db col, row, typ
endif
ENDM

dsp_struc struc
  dsp_ptr  dw ?
  dsp_col  db ?
  dsp_row  db ?
  dsp_type db ?
dsp_struc ends


main proc

        mov     ax, @data
        mov     ds, ax

        call    mem_shrink

        push    ds
        pop     es

; initialize library for screen

        call    scr_init
        lea     si, attr_tbl
        mov     cx, attr_tbl_len
        call    scr_setup_attr_tbl

; erase the screen

        mov     al, attr1               ; attr to erase with
        call    scr_blank_screen

; display the text

        call    display_info

; terminate program

        mov     ah, 4ch
        int     21h

main endp

display_info proc

        lea     di, disp_tbl
dsp_1:
        mov     si, [di].dsp_ptr
        cmp     si, -1
        je      dsp_ret
        xor     bx, bx
        mov     bl, [di].dsp_type       ; get conversion type
        add     bx, bx
        call    CS:convert[bx]          ; call conversion routine
dsp_3:
        mov     bl, [di].dsp_col
        mov     bh, [di].dsp_row
        mov     al, 1
        mov     ah, attr1
        call    scr_display_string

        add     di, size dsp_struc
        jmp     dsp_1

dsp_ret:
        ret

convert label word
dw conv_string
dw conv_num
dw conv_grade

display_info endp

conv_string proc

        xor     cx, cx                  ; no conversion required
        ret

conv_string endp

conv_num proc

        push    di
        mov     ax, [si]                ; get value
        lea     di, temp_num
        call    num_int_to_ascii
        mov     si, di                  ; return ptr to string
        xor     cx, cx
        pop     di
        ret

conv_num endp

public conv_grade
conv_grade proc
;--------------------------------------
; Convert numerical grade to letter
;--------------------------------------

        mov     al, [si]                ; get value
        cmp     al, 90
        jb      cg_0
        push    ax
        push    di
        lea     si, win1
        lea     di, buf1
        call    win_popup
        call    key_read_char
        call    win_remove
        pop     di
        pop     ax
cg_0:
        lea     si, num_to_grade
cg_1:
        cmp     al, [si]
        jae     cg_2
        add     si, 3
        jmp     cg_1
cg_2:
        inc     si                      ; return pointer to string
        mov     cx, 2                   ; length of string
        ret

conv_grade endp

.data

disp_tbl label byte

dsp str1,   1, 3, 0     ; ptr, column, row, type
dsp str2,   1, 4, 0
dsp str3,   1, 5, 0
dsp str4,  40, 3, 0
dsp str5,  40, 4, 0
dsp str6,  40, 5, 0
dsp str1a, 13, 3, 0
dsp str2a, 13, 4, 0
dsp str3a, 13, 5, 0
dsp str4a, 50, 3, 0
dsp num5a, 50, 4, 2
dsp num6a, 50, 5, 1

dw -1   ; end of table

str1  db 'First Name:',0
str2  db 'Last Name:',0
str3  db 'Course:',0
str4  db 'Date:',0
str5  db 'Grade:',0
str6  db 'Credits:',0

str1a db 'John',0
str2a db 'Smith',0
str3a db 'CS101',0
str4a db '01/01/95',0
num5a dw 90
num6a dw 3

temp_num db 6 dup(0)

num_to_grade label byte
db 100, 'A+'
db  90, 'A '
db  80, 'B '
db  70, 'C '
db  60, 'D '
db   0, 'F '

h1      equ 4
w1      equ 30
win1 window_struc <25,  8, h1, w1, attr2, 2, 1, msg1>
               ;  col, row,ht,wid, attr, l, t, strings

attr_tbl label byte
attr1 db 70h, 17h       ; mono then color attr
attr2 db 07h, 47h
attr_tbl_len equ ($ - attr_tbl)/2

msg1 db '    Congratulations!',0
     db " An 'A' in this class.",0
     db 0

buf1 db (size screen_struc) + ( h1 * w1 * 2) dup (0)

end main
