;****************************************
;*					*
;*	Printer Executive Program	*
;*	Author: Yu.I.Petrenko		*
;*					*
;****************************************
.286
cseg    segment BYTE
ORG     100H
	assume  CS:cseg,DS:cseg,ES:cseg,SS:nothing
	START:	JMP BEGIN
;=========================================================
;program data
	Comspec	DB 	'COMSPEC=',0
		DB 	80 DUP(0)
	Parms 	DW 	0
		DW 	OFFSET CmdTail
		DW 	?	;Seg CmdTail
		DW 	0,0	;FCB1,don't matter
		DW 	0,0	;FCB2,don't matter

	CmdTail DB      EnvOld-CmdTail-2	
				;Length of next string
		DB 	'/c \tmp\PTR.exe',13
				;Command tail
	EnvOld	DW      0	;Old parameters
	SS_Old 	DW      0
	SP_Old	DW      0
	Error	DW      0

	EndMessage 	DB	'End of program',13,10,'$'
	CSLong	DB		'The COMSPEC string too long',13,10,'$'
	NoComSpec 	DB      'A COMSPEC not found',13,10,'$'

	Errors: DW 	OFFSET ErrUnn
		DW 	OFFSET Error1
		DW 	OFFSET Error2
		DW 	OFFSET Error3
		DW 	OFFSET Error4
		DW 	OFFSET Error5
		DW 	OFFSET ErrUnn
		DW 	OFFSET ErrUnn
		DW 	OFFSET Error8
		DW 	OFFSET ErrUnn
		DW 	OFFSET ErrorA
		DW 	OFFSET ErrorB

	Error1 	DB      ' Error #1: invalid function',13,10,'$'
	Error2	DB      ' Error #2: file not found',13,10,'$'
	Error3	DB      ' Error #3: path not found',13,10,'$'
	Error4	DB      ' Error #4: too many open files',13,10,'$'
	Error5	DB      ' Error #5: access denied',13,10,'$'
	Error8	DB      ' Error #8: not enough memory',13,10,'$'
	ErrorA	DB      ' Error #A: bad environment',13,10,'$'
	ErrorB	DB      ' Error #B: bad format',13,10,'$'
	ErrUnn	DB      ' Unknown error',13,10,'$'

BEGIN:
	MOV 	AX,CS
	MOV 	DS,AX
	mov 	Parms[4],AX
	cli
	mov 	SS,AX
	mov 	BX,offset endd
	add 	BX,400h
	mov 	SP,BX
	xor 	AX,AX
	push	AX
	sti
;Main Routine
	MOV 	AX,ES:[2Ch]
	MOV 	EnvOld,AX	;Save environment segment
	mov 	BX,SP		;offset endd
	mov 	CL,4		;Divide it by 16
	shr 	BX,CL
	inc 	BX		;Number of segments for code & data
	MOV 	AH,4Ah		;Modify memory allocation
	INT 	21h

	MOV 	SI,OFFSET ComSpec
	CALL	Srch		;Try to find it
	JNC 	GotComSpec	;Succes

	MOV 	DX,0		;Set
	MOV 	BH,0		;page 0,
	MOV 	AH,2		;set cursor
	INT 	10h

	MOV 	DX,OFFSET NoComSpec
	MOV 	AH,9		;Display
	INT 	21h		;Error message
	JMP 	OutFrom
GotComSpec: 
	MOV 	BX,offset Comspec[2]	;Path buffer
	MOV 	CL,0
GCS1:	
	MOV     AL,BYTE PTR ES:[DI]	;Get character
	MOV 	BYTE PTR [BX],AL	;Store character
	INC 	DI
	INC 	BX
	INC 	CL
	CMP 	AL,0			;End of entry?
	JE 	GCS2
	CMP	CL,80			;Too many characters?
	JL 	GCS1			;No, continue
	MOV	DX,OFFSET CSLong
	MOV	AH,9			;Error message
	INT	21h
	JMP	OutFrom

GCS2:	MOV     Error,0			;No errors
	MOV	AH,4Bh			;EXEC function
	MOV	AL,0			;Load and execute
	MOV	DX,offset Comspec[2]	;Path name of file to execute
	PUSH	DS
	POP 	ES			;ES:BX points to
	MOV 	BX,OFFSET Parms		;parameter block
	MOV 	SS_Old,SS		;Save SP:SS
	MOV 	SP_Old,SP
	INT 	21h
	JNC 	Back			;OK, continue
	MOV 	Error,AX		;Error occured
Back: 
	MOV     SS,SS_Old		;Restore SP:SS
	MOV 	SP,SP_Old
	CMP 	Error,0			;Was there an error?
	JE 	OutFrom			;No, exit

	MOV	BX,Error		;Error value
	SHL	BX,1
	MOV	DX, word ptr Errors[BX]
	MOV	AH,9			;Display error message
	INT	21h
OutFrom: 
	MOV	DX,OFFSET EndMessage
	MOV 	AH,9			;Display it
	INT 	21h
	mov 	AH,4Ch
	int 	21h
;======================SDUBROUTINES=======================
Srch:	push	AX
	push	BX
	push	SI
	MOV 	ES,EnvOld
	MOV 	DI,0;ES:DI points to environment
L1:	MOV     BX,SI			;Start of COMSPEC name
	MOV 	AX,ES:[DI]		;Get two characters
	CMP 	AX,0		;0 ends an environment block
	JE 	NotFound
L2:
	MOV     AL,[BX]			;Get character
	INC	BX			;Next character
	CMP	AL,0			;End of entry?
	JE 	Found			;Yes
	CMP	AL,ES:[DI]		;Same?
	JNE	L3			;No, find entry end
	INC	DI			;Next character
	JMP	L2			;Once more
L3:
	INC	DI		;Next environment character
	CMP	BYTE PTR ES:[DI],0	;End of entry?
	JNE 	L3			;No yet
	inc 	DI
	JMP 	L1			;Try once more
Found:
	CLC
	JMP	L4
NotFound:
	STC
L4:	pop	SI
	pop	BX
	pop	AX
	RET
;=========================================================
endd:
CSEG 	ENDS
END 	START

