
;****************************************
;*					*
;*	   Simple Tutorial              *
;*    Interrupt Handler Program         *
;*	Author: Yu.I.Petrenko		*
;*					*
;****************************************
.286
cd segment
assume cs:cd,ds:cd,es:cd,ss:nothing
   ORG 100h
start:  JMP BEG
;=========================================================
;program data
;---------------------------------------------------------
Message1      DB	0Ah,0Dh
	      DB	'The program is already loaded',0Ah,0Dh
	      DB	0Ah,0Dh,'$'
Message2      DB	0Ah,0Dh
	      DB	'The tutorial interrupt handler is now installed'
              DB        0Ah,0Dh,0Ah,0Dh,'$'
Old_0C_Off    DW   0    ;old interrupt 0Ch vector
Old_0C_Seg    DW   0    ;
OldIMR        DB   0    ;PIC mask register value
Parole        DW   3456h
RESID         DB   0    ;resident flag
;*********************************************************
BEG:    ;The program start
;=========================================================
; COM1 port initialization
;---------------------------------------------------------
;First it checks for being already loaded
        MOV AX,CS
        MOV DS,AX
PUSH BP         ;register storing
 PUSH AX
  PUSH BX
   PUSH CX
    PUSH DX
     PUSH ES

     IN AL,21h          ;storing of IMR initial value
     MOV OldIMR,AL

     OR AL,10h  ;masking of COM1 interrupt - IRQ4
                ;for IRQ4 to be prohibited surely
     OUT 21h,AL

;now the program checks, if it is loaded before
     MOV AL,0Ch
     MOV AH,35h ;get Int 0Ch vector in ES:BX
     INT 21h
     MOV AX,CS:Parole
     MOV CX,ES:Parole
     CMP CX,AX  ;if couincide,then the same program
                ;already loaded
     JNZ T ; no, first load

qq:  STI   ;yes, the same program already loaded,
           ;go away
	MOV	AH,9
	LEA	DX,Message1	;Type $-string
	INT	21h

     MOV AL,OldIMR ;set old interrupt flags
     OUT 21h,AL    ;IRQ4 permitted
     POP ES     ;register restoring
    POP DX
   POP CX
  POP BX
 POP AX
POP BP
    JMP EXIT ; without reloading twice
;---------------------------------------------------------
T:      ;the very first program loading
        MOV	AH,9
	LEA	DX,Message2	;Type $-string
	INT	21h

     MOV RESID,1  ;set resident flag
     MOV Old_0C_off,BX  ;Store ES:BX as old Int 0Ch vector
     MOV Old_0C_seg,ES
     MOV DX, offset Int_0Ch
     MOV AL,0Ch
     MOV AH,25h
     INT 21h ;Set as new Int 0Ch vector the own one
     PUSH CS
     POP DS
     CLI         ;interrupts forbidden

     IN AL,21h   ;read 1-st interrupt controller IMR
     AND AL,0EFh ;clear it's 4-th bit

     STI         ;interrupts permitted

     MOV AL,OldIMR ; 1-st interrupt controller IMR
     OUT 21h,AL    ; restored

     POP ES         ;register restoring
    POP DX
   POP CX
  POP BX
 POP AX
POP BP
     jmp EXIT ;initialisation end, program already works
;=========================================================
;Interrupt 0Ch handler
;---------------------------------------------------------
Int_0Ch:
   PUSH BP              ;register storing
    PUSH AX
     PUSH BX
      PUSH CX
       PUSH DX
        PUSH DS
         PUSH ES
          PUSH DI
           PUSH SI
            PUSH CS
            POP DS

  ; here you can jump to handle the interrupt call

  ; JMP Handler ; jump, if you need it really

OLD_0C:            ; no, something else
           POP SI  ;register restoring
          POP DI
         POP ES
        POP DS
       POP DX
      POP CX
     POP BX
    POP AX
   POP BP
    PUSH Old_0C_seg
     PUSH Old_0C_off
   RETF ; old interrupt call for other cases
;---------------------------------------------------------
;  Reset and exit
;---------------------------------------------------------
 Handler:
;---------------------------------------------------------
 INT_RET:       
   STI ; now interrupts are permitted
   MOV AL,20h   ;  it is the EOI
   OUT 20h,AL   ;  command
           POP SI           ;register restoring
          POP DI
         POP ES
        POP DS
       POP DX
      POP CX
     POP BX
    POP AX
   POP BP
   IRET
;---------------------------------------------------------
EXIT:
     CMP RESID,0
     JNZ Q    ;not resident yet?
     JMP ENDD ;yes nothing to do
    Q:      MOV DX,OFFSET zzz ;stay resident
            SHR DX,4
            ADD DX,1;
            MOV AL,0   ;return code
            MOV AH,31h
            int 21h
ENDD:                  ;all done, exit
            MOV AX,4C00h
            int 21h
zzz:        ; program end marker for int 31h
cd ends
end start
;*********************************************************
