
;****************************************
;*					*
;*	      Morse Code                *
;*        Generating Program            *
;*	Author: Yu.I.Petrenko		*
;*					*
;****************************************
.286
cd segment
assume cs:cd,ds:cd,es:cd,ss:nothing
   ORG 100h
start:  JMP BEG
;program data
Alfabet    DB 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
           DB 'abcdefghijklmnopqrstuvwxyz'
Digits     DB '1234567890'

Codes      DW 60h,95h,99h,94h,40h,59h,0A4h,55h,50h
              ;A   B   C   D   E   F   G    H   I
           DW 6Ah,98h,65h,0a0h,90h,0A8h,69h,0A6h,64h
              ; J   K   L   M   N   O    P   Q    R
           DW 54h,80h,58h,56h,68h,96h,9Ah,0A5h
            ; S   T   U   V   W   X   Y   Z
           DW 60h,95h,99h,94h,40h,59h,0A4h,55h,50h
           DW 6Ah,98h,65h,0a0h,90h,0A8h,69h,0A6h,64h
           DW 54h,80h,58h,56h,68h,96h,9Ah,0A5h
           DW 6A80h,5A80h,5680h,5580h,5540h
             ;1     2     3     4     5
           DW 0AA40h,0A54h,0A940h,0AA40h,0AA80h
             ;6      7     8      9      0'
DELAY_Value DW ?
Temp        DW 5  ;dot interval
Temp0       DW 20 ;dash interval
Temp1       DW 20 ;interval between characters
Temp2       DW 30 ;space - interval between words

Char        DW ?
Divisor     DW ?

Table      DW 100h DUP (0)
;There is a text to be "transmitted"
Text       DB  'One Two Three Four Five Six Seven Eight Nine Ten','$'
 BEG:          ;
 ;Initialisation
                MOV AX,CS
                MOV DS,AX
      CALL Make_Table
;this code accelerates the time approximately by 50 times
;Einstein would envy you!
mov al,00110110b
out 43h,al
mov ax,11932
out 40h,al
mov al,ah
out 40h,al     ; Set 100 Hz tics

                XOR BX,BX
 Act:           XOR DH,DH
                MOV DL,Text[BX] ; Read a text
                push bx
                CMP DL,'$'      ; until find a $
                JNZ A2

                JMP EXIT        ; then exit

 A2:            CMP DL,' '      ; text encoding
                JNZ A3
                mov AX,Temp2
                CALL Delay
 A3:
                MOV DI,DX
                shl di,1
                MOV AX,Table[DI]
                mov Char,AX
                CALL Encode
                mov ax,temp1
                call Delay
                pop bx
                inc bx
                JMP  Act
;---------------------------------------------------------
Encode:
;Input: Char - sound sequence code
;10 = dot, 01 = dash, 00 = nothing
;Output: speaker sounds
          MOV DX,8000h
          MOV CX,8      ; the Char variable represents
                        ; the sound intervals code
                        ; as four 2-bit fields
                        ; which are decoded here
  Dash:   TEST Char,DX
          JZ Dot
          push cx
          CALL C2
          pop CX
  Dot:    SHR DX,1
          TEST Char,DX
          JZ L
          push cx
          CALL C1
          pop cx
    L:    SHR DX,1
          LOOP Dash
          RET
;---------------------------------------------------------
    C1:         CALL Sound_ON   ;Dot: short
                MOV AX,Temp     ;sound
                CALL Delay
                CALL Sound_OFF
                mov AX,temp
                Call DELAY
                RET
;---------------------------------------------------------
    C2:         CALL Sound_ON    ;Dash: long sound
                MOV AX,Temp0
                CALL Delay
                CALL Sound_OFF
                mov AX,Temp
                CALL DELAY
                RET
;---------------------------------------------------------
Pause1:         MOV AX,Temp2      ; this is only delay
                MOV DELAY_Value,AX; call
                CALL Delay
                RET
;---------------------------------------------------------
Pause2:         MOV AX,30         ; this is also delay
                MOV DELAY_Value,AX; call
                CALL Delay
                RET
;---------------------------------------------------------
Delay:             ; this subroutine
mov DELAY_Value,AX ; produces a delay
   PUSH ES
   MOV AX,40h
   MOV ES,AX
   MOV AX,ES:[6Ch] ;counter value
   XOR CX,CX
D1: MOV BX,ES:[6Ch]
    CMP BX,AX
    JZ D1
    MOV AX,BX
    INC CX
    CMP CX,DELAY_Value
    JNZ D1
    POP ES
    RET
;---------------------------------------------------------
Freq dw 534h
Old_AL DB ?
;---------------------------------------------------------
Sound_ON:    ; this subruotine produces
push ax      ; timer 2 programming for
push bx      ; 1000 Hz meander
push dx
mov ax,1193  ;1000hz
push ax      ; timer counter (divider)
in al,61h
MOV Old_AL,AL
or al,3
out 61h,al
mov al, 0Bh  ; cannel 2, mode 3, binary word
out 43h,al
pop ax
out 42h,al   ; low byte
xchg al,ah
out 42h,al   ; high byte, timer starts now
pop dx
pop bx
pop ax
RET          ; it whistles, but silently!
;---------------------------------------------------------
Sound_OFF:
MOV AL,Old_AL
OUT 61h,AL   ; now there are silence everywhere!
      RET
;---------------------------------------------------------
Make_Table:
        MOV CX, offset Codes - offset Alfabet
        MOV SI,0
        mov di,0
Make:   XOR BH,BH
        MOV BL,Alfabet[SI]
        MOV AX,Codes[DI]
        shl BX,1
        MOV Table[BX],AX;      Codes[SI]
        shr BX,1
        INC SI
        ADD DI,2
        LOOP Make
                RET
;---------------------------------------------------------
 EXIT:
                MOV AX,CS
                MOV DS,AX
mov al,00110110b
out 43h,al
mov ax,0
out 40h,al
mov al,ah
out 40h,al  ; reprogramming the ticks to old frequency

      MOV AH,4Ch
      INT 21h     ;EXIT
cd ends
end start

