#ifndef SBENV_H
#define SBENV_H

#include <dos.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <io.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <alloc.h>


typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;

char *sb_dir = NULL;
WORD base_port;
WORD IRQ_line;
WORD DMA_channel;


void get_sb_env(void) {
  char *sb_param;
  sb_dir = getenv("SOUND");
  if (sb_dir != NULL) {
    sb_param = getenv("BLASTER");
    if (sb_param != NULL) {
      sscanf(strpbrk(sb_param, "Aa") + 1, "%x", &base_port);
      sscanf(strpbrk(sb_param, "Ii") + 1, "%d", &IRQ_line);
      sscanf(strpbrk(sb_param, "Dd") + 1, "%d", &DMA_channel);
    }
  }
}


void *load_driver(char *fname) {
  int drv_handle;
  WORD drv = 0;
  WORD drv_size;
  drv_handle = open(fname, O_RDONLY | O_BINARY);
  if (drv_handle == -1) return NULL;
  drv_size = filelength(drv_handle);
  if (allocmem((drv_size + 15) / 16, &drv) != -1) return NULL;
  read(drv_handle, MK_FP(drv, 0), drv_size);
  close(drv_handle);
  return MK_FP(drv, 0);
}

BYTE huge *double_buffer = NULL;
BYTE huge *midi_buffer = NULL;
WORD midi_size;
BYTE huge *common_buffer = NULL;

void alloc_common_buffer(WORD size_64KB) {
  WORD lead_free;
  DWORD abs_common;
  DWORD abs_double;
  common_buffer = farcalloc(  size_64KB + 1, 0x10000UL);
  if (common_buffer == NULL) return;
  abs_common = (DWORD)FP_SEG(common_buffer) * 16 + FP_OFF(common_buffer);
  abs_double = (abs_common + 0xFFFFUL) & ~0xFFFFUL;
  double_buffer = common_buffer + (abs_double - abs_common);
  if ((lead_free = abs_double - abs_common) < 0x8000) {
    midi_buffer = double_buffer + size_64KB * 0x10000UL;
    midi_size = 65536UL - lead_free;
  }
  else {
    midi_buffer = common_buffer;
    midi_size = lead_free;
  }
}


#endif
