/*
   WAV.H -- Definitions and functions for WAV files
*/
#ifndef WAV.H
#define WAV.H

#include "sbenv.h"

typedef struct {
  char	  RIFF_txt[4];
  DWORD	  chunk_size;
  char	  WAVEfmt_txt[8];
  DWORD	  u10;
  WORD	  u1;
  WORD	  channels;
  DWORD	  sample_rate;
  DWORD	  byte_rate;
  WORD	  bytes_per_sample;
  WORD	  bits_per_channel;
  char	  data_txt[4];
  DWORD	  data_size;
} WAV_HEADER;

WAV_HEADER wav_head = {
  {'R','I','F','F'},
  0,
  {'W','A','V','E','f','m','t', ' '},
  0x10,
  1,
  0,
  0,
  0,
  0,
  0,
  {'d','a','t','a'},
  0
};


void calc_wav_header (WAV_HEADER *w_h, WORD chans,
  WORD bits, WORD rate, DWORD len) {
  w_h->chunk_size = len + sizeof(WAV_HEADER) - 8;
  w_h->channels = chans;
  w_h->sample_rate = rate ;
  w_h->byte_rate = (long)rate * chans * bits / 8;
  w_h->bytes_per_sample = bits / 8 * chans;
  w_h->bits_per_channel = bits ;
  w_h->data_size = len;
}

#endif
