; char3.asm: character conversion: upper to lowercase

	.model small
	.stack 100h

CR      equ     13d
LF      equ     10d

	.data

msg1        db  'Enter an uppercase letter: ', '$'
result  db  CR, LF,'The lowercase equivalent is: ', '$'
bad_msg db  CR, LF,'Not an uppercase letter: ', '$'
	.code
;                   main program
start:
		mov ax, @data
		mov ds, ax

		mov ax, offset msg1
		call    puts
		call    getc    ; read uppercase letter
		mov bl, al      ; save character in bl
		cmp bl, 'A'
		jl  invalid     ; if bl < `A`  goto invalid
		cmp bl, 'Z'     ; if bl > `Z`  goto invalid
		jg  invalid
						; otherwise its valid
		add bl, 32d     ; convert to lowercase

		mov ax, offset result
		call    puts    ; display result message
		mov al, bl      
		call    putc    ; display lowercase letter
		jmp finish

invalid:    mov ax, offset bad_msg  ; not an uppercase letter
		call    puts        ; display bad_msg
		mov al, bl
		call    putc        ; display character entered

finish:
		mov ax, 4c00h
		int 21h         ; return to ms-dos

; User defined I/O subprograms: getc, putc, puts

puts:                                  
				; display a string terminated by $
				; ax contains address of string
		push ax         ;Save register values
		push bx
		push cx
		push dx

		mov dx, ax
		mov ah, 9
		int 21h         ; call ms-dos to output string

		pop dx          ; Restore register values
		pop cx
		pop bx
		pop ax
		ret

putc:                           ; display character in al
		push ax         ;Save Registers
		push bx
		push cx
		push dx

		mov dl, al
		mov ah, 2h
		int 21h
		
		pop dx          ; Restore register values
		pop cx
		pop bx
		pop ax
		
		ret


getc:                           ; read character into al
		push bx         ;Save register values
		push cx
		push dx

		mov ah, 1h
		int 21h         
		
		pop dx          ; Restore register values
		pop cx
		pop bx
		
		
		ret

		end start


