; ex3_20.asm     Exercise 3.20: Read characters from the keyboard and 
;                count the number of characters entered, 
;                stoping when the $ character is entered.

        .model small

        .stack 256

CR  equ     13d
LF  equ     10d

        .data

prompt1   db 'Enter characters: $'
response  db CR, LF,'Number of characters entered: $'


        .code

start:
        mov ax, @data
        mov ds, ax

        mov ax, offset prompt1
        call puts

        mov cx, 0d
count:        
        call getc

        cmp al, '$'
        je finish

        inc cx          ; count the character
        jmp count

finish: 
        mov ax, offset response
        call puts

        mov ax, cx
        call putn

        mov ax, 4c00h
        int 21h

; User defined subprograms.

putn:           ; display number in ax
        
                ; dx contains remainder (rem in C above)
                ; cx contains 10 for division

    push    bx
    push    cx
    push    dx

    mov     dx, 0               ; dx = 0
    push    dx                  ; push 0 as sentinel
    mov     cx, 10              ; cx = 10

    cmp     ax, 0
    jge     calc_digits         ; number is negative
    neg     ax                  ; ax = -ax; ax is now positive
    push    ax                  ; save ax
    mov     al, '-'             ; display - sign
    call    putc
    pop ax          

calc_digits:
    div cx                      ; dx:ax = ax / cx
                                ; ax = result, dx = remainder
    add dx, '0'                 ; convert dx to digit
    push    dx                  ; save digit on stack
    mov dx, 0                   ; dx = 0
    cmp ax, 0                   ; finished ?
    jne calc_digits             ; no, repeat process

; all digits now on stack, display them in reverse

disp_loop:
    pop ax                      ; get last digit from stack
    cmp ax, 0                   ; is it sentinel
    je  end_disp_loop           ; if yes, we are finished 
    
    call    putc                ; otherwise display digit
    jmp disp_loop

end_disp_loop:
    pop dx                      ; restore registers
    pop cx
    pop bx
    ret

puts:               ; display a string terminated by $
                    ; ax contains address of string

        push    bx  ; save bx 
        push    cx  ; save cx
        push    dx  ; save dx

        mov dx, ax
        mov ah, 9h
        int 21h ; call ms-dos to output string

        pop dx  ; restore dx
        pop cx  ; restore cx
        pop bx  ; restore bx
        ret

putc:               ; display character in al
        push    ax  ; save ax
        push    bx  ; save bx 
        push    cx  ; save cx
        push    dx  ; save dx

        mov dl, al
        mov ah, 2h
        int 21h

        pop dx  ; restore dx
        pop cx  ; restore cx
        pop bx  ; restore bx
        pop ax  ; restore ax

        ret

getc:               ; read character into al
        push    bx  ; save bx 
        push    cx  ; save cx
        push    dx  ; save dx

        mov ah, 1h
        int 21h

        pop dx  ; restore dx
        pop cx  ; restore cx
        pop bx  ; restore bx

        ret
        end start

