; guess.asm: Guessing game program. User is asked to guess which letter the 
; program 'knows'. Here 'A' is the "known" letter
; Author:   Joe Carthy
; Date: June 1994

		.model small
		.stack 100h

CR      equ     13d
LF      equ     10d


		.data

prompt  db  "Guessing game: Enter a letter (A to Z): $"
yes_msg db  CR, LF, "You guessed correctly !! $" 
no_msg  db  CR, LF, "Sorry incorrect guess $" 

		.code

start:      
		mov ax, @data
		mov ds, ax

		mov ax, offset prompt
		call puts                  ; prompt for input

		call getc                  ; read character 
		cmp al, 'A'
		jne is_not_an_a
		  mov ax, offset yes_msg     ; if action
		  call puts                  ; display correct guess message
		jmp end_else1
is_not_an_a:                                 ; else action
		mov ax, offset no_msg
		call puts                   ; display wrong guess message

end_else1:

finish:        
		mov ax, 4c00h
		int     21h

; User defined I/O subprograms: getc, putc, puts

puts:                                  
				; display a string terminated by $
				; ax contains address of string
		push ax         ;Save register values
		push bx
		push cx
		push dx

		mov dx, ax
		mov ah, 9
		int 21h         ; call ms-dos to output string

		pop dx          ; Restore register values
		pop cx
		pop bx
		pop ax
		ret

putc:                           ; display character in al
		push ax         ;Save Registers
		push bx
		push cx
		push dx

		mov dl, al
		mov ah, 2h
		int 21h
		
		pop dx          ; Restore register values
		pop cx
		pop bx
		pop ax
		
		ret


getc:                           ; read character into al
		push bx         ;Save register values
		push cx
		push dx

		mov ah, 1h
		int 21h         
		
		pop dx          ; Restore register values
		pop cx
		pop bx
		
		
		ret

		end start


