; sum.asm: sums 4 numbers passed as parameters on the stack
;          to a subprogram called sum. Store sum in ax.

		.model small
		.stack 256
		
		.data                

arg1        dw  3
arg2        dw  7
arg3        dw  4
arg4        dw  11

		.code
start:
		mov ax, @data 
		mov ds, ax
  
		mov bx, offset arg1     ; bx = address of list

		call    sum             ; compute sum store it in ax

		call    putn            ; display result

		mov ax, 4c00h
		int     21h

sum:                                    ; returns sum of 4 element list in ax
		mov ax, [bx]            ; ax = arg1
		add bx, 2               ; bx points to arg2
		add ax, [bx]            ; ax = ax + arg2
		add bx, 2               ; bx points to arg3
		add ax, [bx]            ; ax = ax + arg3
		add bx, 2               ; bx points to arg4
		add ax, [bx]            ; ax = ax + arg4

		ret

putn:                                   ; display number in ax
		; ax contains number  
		; dx contains remainder 
		; cx contains 10 for division

	push    bx
	push    cx
	push    dx
	
	mov dx, 0                       ; dx = 0
	push dx                         ; push 0 as sentinel
	mov cx, 10                      ; cx = 10
	
	cmp ax, 0
	jge calc_digits                 ; number is negative
	neg ax                          ; ax = -ax; ax is now positive
	push  ax                        ; save ax
	mov al, '-'                     ; display - sign
	call putc
	pop ax                          ; restore ax

calc_digits:
	div cx                          ; dx:ax = ax / cx
					; ax = result, dx = remainder 
	add dx, '0'                     ; convert dx to digit
	push dx                         ; save digit on stack
	mov dx, 0                       ; dx = 0
	cmp ax, 0                       ; finished ?
	jne calc_digits                 ; no, repeat process
					; all digits now on stack, display 
					; them in reverse

disp_loop:
	pop ax                          ; get last digit from stack
	cmp ax, 0                       ; is it sentinel
	je  end_disp_loop               ; if yes, we are finished 
	call putc                       ; otherwise display digit
	jmp disp_loop
end_disp_loop:

	pop dx                          ; restore registers
	pop cx
	pop bx

	ret


putc:               ; display character in al
		push    ax  ; save ax
		push    bx  ; save bx 
		push    cx  ; save cx
		push    dx  ; save dx

		mov dl, al
		mov ah, 2h
		int 21h

		pop dx  ; restore dx
		pop cx  ; restore cx
		pop bx  ; restore bx
		pop ax  ; restore ax

		ret
		end start
